/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright (c) 2011-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3, as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

VALA_EXTERN gchar* terminal_utils_sanitize_path (const gchar* _path,
                                     const gchar* shell_location,
                                     gboolean add_file_scheme);
VALA_EXTERN gchar* terminal_utils_strip_uri (const gchar* _uri);
VALA_EXTERN gchar* terminal_utils_construct_parent_path (const gchar* path);
VALA_EXTERN gchar* terminal_utils_escape_uri (const gchar* uri,
                                  gboolean allow_utf8,
                                  gboolean allow_single_quote);
VALA_EXTERN gchar* terminal_utils_get_parent_path_from_path (const gchar* path);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 84 "Utils.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 106 "Utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 110 "Utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 116 "Utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 120 "Utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 124 "Utils.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 132 "Utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 160 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 169 "Utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 183 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 192 "Utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 206 "Utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 215 "Utils.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 224 "Utils.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 238 "Utils.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 242 "Utils.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 248 "Utils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 253 "Utils.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 259 "Utils.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 263 "Utils.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 267 "Utils.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 271 "Utils.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 275 "Utils.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 279 "Utils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 294 "Utils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 303 "Utils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 310 "Utils.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 316 "Utils.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 324 "Utils.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 328 "Utils.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 334 "Utils.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 339 "Utils.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 345 "Utils.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 349 "Utils.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 353 "Utils.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 359 "Utils.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 365 "Utils.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 377 "Utils.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 381 "Utils.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 385 "Utils.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 390 "Utils.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 398 "Utils.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 416 "Utils.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 422 "Utils.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 426 "Utils.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 434 "Utils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 443 "Utils.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 452 "Utils.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 458 "Utils.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 466 "Utils.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 478 "Utils.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 484 "Utils.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 488 "Utils.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 496 "Utils.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 507 "Utils.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 516 "Utils.c"
	}
}

gchar*
terminal_utils_sanitize_path (const gchar* _path,
                              const gchar* shell_location,
                              gboolean add_file_scheme)
{
	gchar* scheme = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	gchar* _tmp1_;
	gchar** parts_scheme = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint parts_scheme_length1;
	gint _parts_scheme_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** parts_sep = NULL;
	const gchar* _tmp23_;
	gchar** _tmp24_;
	gchar** _tmp25_;
	gint parts_sep_length1;
	gint _parts_sep_size_;
	gint index = 0;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gchar* _result_ = NULL;
	const gchar* _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* result;
#line 21 "../src/Utils.vala"
	g_return_val_if_fail (_path != NULL, NULL);
#line 21 "../src/Utils.vala"
	g_return_val_if_fail (shell_location != NULL, NULL);
#line 23 "../src/Utils.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../src/Utils.vala"
	scheme = _tmp0_;
#line 23 "../src/Utils.vala"
	_tmp1_ = g_strdup ("");
#line 23 "../src/Utils.vala"
	path = _tmp1_;
#line 25 "../src/Utils.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_path, "://", 2);
#line 25 "../src/Utils.vala"
	parts_scheme = _tmp3_;
#line 25 "../src/Utils.vala"
	parts_scheme_length1 = _vala_array_length (_tmp2_);
#line 25 "../src/Utils.vala"
	_parts_scheme_size_ = parts_scheme_length1;
#line 26 "../src/Utils.vala"
	_tmp4_ = parts_scheme;
#line 26 "../src/Utils.vala"
	_tmp4__length1 = parts_scheme_length1;
#line 26 "../src/Utils.vala"
	if (_tmp4__length1 == 2) {
#line 590 "Utils.c"
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 27 "../src/Utils.vala"
		_tmp5_ = parts_scheme;
#line 27 "../src/Utils.vala"
		_tmp5__length1 = parts_scheme_length1;
#line 27 "../src/Utils.vala"
		_tmp6_ = _tmp5_[0];
#line 27 "../src/Utils.vala"
		_tmp7_ = g_strconcat (_tmp6_, "://", NULL);
#line 27 "../src/Utils.vala"
		_g_free0 (scheme);
#line 27 "../src/Utils.vala"
		scheme = _tmp7_;
#line 28 "../src/Utils.vala"
		_tmp8_ = parts_scheme;
#line 28 "../src/Utils.vala"
		_tmp8__length1 = parts_scheme_length1;
#line 28 "../src/Utils.vala"
		_tmp9_ = _tmp8_[1];
#line 28 "../src/Utils.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 28 "../src/Utils.vala"
		_g_free0 (path);
#line 28 "../src/Utils.vala"
		path = _tmp10_;
#line 623 "Utils.c"
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 29 "../src/Utils.vala"
		_tmp11_ = parts_scheme;
#line 29 "../src/Utils.vala"
		_tmp11__length1 = parts_scheme_length1;
#line 29 "../src/Utils.vala"
		if (_tmp11__length1 == 1) {
#line 633 "Utils.c"
			gchar* _tmp13_;
#line 30 "../src/Utils.vala"
			if (add_file_scheme) {
#line 637 "Utils.c"
				gchar* _tmp12_;
#line 31 "../src/Utils.vala"
				_tmp12_ = g_strdup ("file://");
#line 31 "../src/Utils.vala"
				_g_free0 (scheme);
#line 31 "../src/Utils.vala"
				scheme = _tmp12_;
#line 645 "Utils.c"
			}
#line 34 "../src/Utils.vala"
			_tmp13_ = g_strdup (_path);
#line 34 "../src/Utils.vala"
			_g_free0 (path);
#line 34 "../src/Utils.vala"
			path = _tmp13_;
#line 653 "Utils.c"
		} else {
#line 36 "../src/Utils.vala"
			g_critical ("Utils.vala:36: Invalid path");
#line 37 "../src/Utils.vala"
			result = NULL;
#line 37 "../src/Utils.vala"
			parts_scheme = (_vala_array_free (parts_scheme, parts_scheme_length1, (GDestroyNotify) g_free), NULL);
#line 37 "../src/Utils.vala"
			_g_free0 (path);
#line 37 "../src/Utils.vala"
			_g_free0 (scheme);
#line 37 "../src/Utils.vala"
			return result;
#line 667 "Utils.c"
		}
	}
#line 40 "../src/Utils.vala"
	_tmp14_ = path;
#line 40 "../src/Utils.vala"
	_tmp15_ = g_uri_unescape_string (_tmp14_, NULL);
#line 40 "../src/Utils.vala"
	_g_free0 (path);
#line 40 "../src/Utils.vala"
	path = _tmp15_;
#line 41 "../src/Utils.vala"
	_tmp16_ = path;
#line 41 "../src/Utils.vala"
	if (_tmp16_ == NULL) {
#line 42 "../src/Utils.vala"
		result = NULL;
#line 42 "../src/Utils.vala"
		parts_scheme = (_vala_array_free (parts_scheme, parts_scheme_length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/Utils.vala"
		_g_free0 (path);
#line 42 "../src/Utils.vala"
		_g_free0 (scheme);
#line 42 "../src/Utils.vala"
		return result;
#line 692 "Utils.c"
	}
#line 45 "../src/Utils.vala"
	_tmp17_ = path;
#line 45 "../src/Utils.vala"
	_tmp18_ = terminal_utils_strip_uri (_tmp17_);
#line 45 "../src/Utils.vala"
	_g_free0 (path);
#line 45 "../src/Utils.vala"
	path = _tmp18_;
#line 702 "Utils.c"
	{
		gboolean _tmp19_ = FALSE;
#line 47 "../src/Utils.vala"
		_tmp19_ = TRUE;
#line 47 "../src/Utils.vala"
		while (TRUE) {
#line 709 "Utils.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 47 "../src/Utils.vala"
			if (!_tmp19_) {
#line 714 "Utils.c"
				const gchar* _tmp20_;
#line 50 "../src/Utils.vala"
				_tmp20_ = path;
#line 50 "../src/Utils.vala"
				if (!string_contains (_tmp20_, "//")) {
#line 50 "../src/Utils.vala"
					break;
#line 722 "Utils.c"
				}
			}
#line 47 "../src/Utils.vala"
			_tmp19_ = FALSE;
#line 48 "../src/Utils.vala"
			_tmp21_ = path;
#line 48 "../src/Utils.vala"
			_tmp22_ = string_replace (_tmp21_, "//", "/");
#line 48 "../src/Utils.vala"
			_g_free0 (path);
#line 48 "../src/Utils.vala"
			path = _tmp22_;
#line 735 "Utils.c"
		}
	}
#line 52 "../src/Utils.vala"
	_tmp23_ = path;
#line 52 "../src/Utils.vala"
	_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, G_DIR_SEPARATOR_S, 3);
#line 52 "../src/Utils.vala"
	parts_sep = _tmp25_;
#line 52 "../src/Utils.vala"
	parts_sep_length1 = _vala_array_length (_tmp24_);
#line 52 "../src/Utils.vala"
	_parts_sep_size_ = parts_sep_length1;
#line 53 "../src/Utils.vala"
	index = 0;
#line 54 "../src/Utils.vala"
	while (TRUE) {
#line 752 "Utils.c"
		gboolean _tmp26_ = FALSE;
		gchar** _tmp27_;
		gint _tmp27__length1;
		const gchar* _tmp28_;
		gint _tmp30_;
#line 54 "../src/Utils.vala"
		_tmp27_ = parts_sep;
#line 54 "../src/Utils.vala"
		_tmp27__length1 = parts_sep_length1;
#line 54 "../src/Utils.vala"
		_tmp28_ = _tmp27_[index];
#line 54 "../src/Utils.vala"
		if (_tmp28_ == NULL) {
#line 766 "Utils.c"
			gchar** _tmp29_;
			gint _tmp29__length1;
#line 54 "../src/Utils.vala"
			_tmp29_ = parts_sep;
#line 54 "../src/Utils.vala"
			_tmp29__length1 = parts_sep_length1;
#line 54 "../src/Utils.vala"
			_tmp26_ = index < (_tmp29__length1 - 1);
#line 775 "Utils.c"
		} else {
#line 54 "../src/Utils.vala"
			_tmp26_ = FALSE;
#line 779 "Utils.c"
		}
#line 54 "../src/Utils.vala"
		if (!_tmp26_) {
#line 54 "../src/Utils.vala"
			break;
#line 785 "Utils.c"
		}
#line 55 "../src/Utils.vala"
		_tmp30_ = index;
#line 55 "../src/Utils.vala"
		index = _tmp30_ + 1;
#line 791 "Utils.c"
	}
#line 58 "../src/Utils.vala"
	_tmp31_ = parts_sep;
#line 58 "../src/Utils.vala"
	_tmp31__length1 = parts_sep_length1;
#line 58 "../src/Utils.vala"
	_tmp32_ = _tmp31_[index];
#line 58 "../src/Utils.vala"
	if (g_strcmp0 (_tmp32_, "~") == 0) {
#line 801 "Utils.c"
		gchar** _tmp33_;
		gint _tmp33__length1;
		const gchar* _tmp34_;
		gchar* _tmp35_;
#line 59 "../src/Utils.vala"
		_tmp33_ = parts_sep;
#line 59 "../src/Utils.vala"
		_tmp33__length1 = parts_sep_length1;
#line 59 "../src/Utils.vala"
		_tmp34_ = g_get_home_dir ();
#line 59 "../src/Utils.vala"
		_tmp35_ = g_strdup (_tmp34_);
#line 59 "../src/Utils.vala"
		_g_free0 (_tmp33_[index]);
#line 59 "../src/Utils.vala"
		_tmp33_[index] = _tmp35_;
#line 818 "Utils.c"
	} else {
		gchar** _tmp36_;
		gint _tmp36__length1;
		const gchar* _tmp37_;
#line 60 "../src/Utils.vala"
		_tmp36_ = parts_sep;
#line 60 "../src/Utils.vala"
		_tmp36__length1 = parts_sep_length1;
#line 60 "../src/Utils.vala"
		_tmp37_ = _tmp36_[index];
#line 60 "../src/Utils.vala"
		if (g_strcmp0 (_tmp37_, ".") == 0) {
#line 831 "Utils.c"
			gchar** _tmp38_;
			gint _tmp38__length1;
			gchar* _tmp39_;
#line 61 "../src/Utils.vala"
			_tmp38_ = parts_sep;
#line 61 "../src/Utils.vala"
			_tmp38__length1 = parts_sep_length1;
#line 61 "../src/Utils.vala"
			_tmp39_ = g_strdup (shell_location);
#line 61 "../src/Utils.vala"
			_g_free0 (_tmp38_[index]);
#line 61 "../src/Utils.vala"
			_tmp38_[index] = _tmp39_;
#line 845 "Utils.c"
		} else {
			gchar** _tmp40_;
			gint _tmp40__length1;
			const gchar* _tmp41_;
#line 62 "../src/Utils.vala"
			_tmp40_ = parts_sep;
#line 62 "../src/Utils.vala"
			_tmp40__length1 = parts_sep_length1;
#line 62 "../src/Utils.vala"
			_tmp41_ = _tmp40_[index];
#line 62 "../src/Utils.vala"
			if (g_strcmp0 (_tmp41_, "..") == 0) {
#line 858 "Utils.c"
				gchar** _tmp42_;
				gint _tmp42__length1;
				gchar* _tmp43_;
#line 63 "../src/Utils.vala"
				_tmp42_ = parts_sep;
#line 63 "../src/Utils.vala"
				_tmp42__length1 = parts_sep_length1;
#line 63 "../src/Utils.vala"
				_tmp43_ = terminal_utils_construct_parent_path (shell_location);
#line 63 "../src/Utils.vala"
				_g_free0 (_tmp42_[index]);
#line 63 "../src/Utils.vala"
				_tmp42_[index] = _tmp43_;
#line 872 "Utils.c"
			}
		}
	}
#line 66 "../src/Utils.vala"
	_tmp44_ = scheme;
#line 66 "../src/Utils.vala"
	_tmp45_ = parts_sep;
#line 66 "../src/Utils.vala"
	_tmp45__length1 = parts_sep_length1;
#line 66 "../src/Utils.vala"
	_tmp46_ = _vala_g_strjoinv (G_DIR_SEPARATOR_S, _tmp45_, (gint) _tmp45__length1);
#line 66 "../src/Utils.vala"
	_tmp47_ = _tmp46_;
#line 66 "../src/Utils.vala"
	_tmp48_ = string_replace (_tmp47_, "//", "/");
#line 66 "../src/Utils.vala"
	_tmp49_ = _tmp48_;
#line 66 "../src/Utils.vala"
	_tmp50_ = g_strconcat (_tmp44_, _tmp49_, NULL);
#line 66 "../src/Utils.vala"
	_tmp51_ = _tmp50_;
#line 66 "../src/Utils.vala"
	_tmp52_ = terminal_utils_escape_uri (_tmp51_, TRUE, TRUE);
#line 66 "../src/Utils.vala"
	_tmp53_ = _tmp52_;
#line 66 "../src/Utils.vala"
	_g_free0 (_tmp51_);
#line 66 "../src/Utils.vala"
	_g_free0 (_tmp49_);
#line 66 "../src/Utils.vala"
	_g_free0 (_tmp47_);
#line 66 "../src/Utils.vala"
	_result_ = _tmp53_;
#line 67 "../src/Utils.vala"
	result = _result_;
#line 67 "../src/Utils.vala"
	parts_sep = (_vala_array_free (parts_sep, parts_sep_length1, (GDestroyNotify) g_free), NULL);
#line 67 "../src/Utils.vala"
	parts_scheme = (_vala_array_free (parts_scheme, parts_scheme_length1, (GDestroyNotify) g_free), NULL);
#line 67 "../src/Utils.vala"
	_g_free0 (path);
#line 67 "../src/Utils.vala"
	_g_free0 (scheme);
#line 67 "../src/Utils.vala"
	return result;
#line 918 "Utils.c"
}

/*** Simplified version of PF.FileUtils function, with fewer checks ***/
static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1195 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1195 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1197 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1197 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 943 "Utils.c"
		gchar* _tmp2_;
#line 1198 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1198 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1198 "glib-2.0.vapi"
		return result;
#line 951 "Utils.c"
	} else {
#line 1200 "glib-2.0.vapi"
		result = -1;
#line 1200 "glib-2.0.vapi"
		return result;
#line 957 "Utils.c"
	}
}

gchar*
terminal_utils_get_parent_path_from_path (const gchar* path)
{
	gint _tmp0_;
	gint _tmp1_;
	GString* string_builder = NULL;
	GString* _tmp3_;
	gint last_separator = 0;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GString* _tmp11_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
#line 71 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 72 "../src/Utils.vala"
	_tmp0_ = strlen (path);
#line 72 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 72 "../src/Utils.vala"
	if (_tmp1_ < 2) {
#line 984 "Utils.c"
		gchar* _tmp2_;
#line 73 "../src/Utils.vala"
		_tmp2_ = g_strdup (G_DIR_SEPARATOR_S);
#line 73 "../src/Utils.vala"
		result = _tmp2_;
#line 73 "../src/Utils.vala"
		return result;
#line 992 "Utils.c"
	}
#line 76 "../src/Utils.vala"
	_tmp3_ = g_string_new (path);
#line 76 "../src/Utils.vala"
	string_builder = _tmp3_;
#line 77 "../src/Utils.vala"
	if (g_str_has_suffix (path, G_DIR_SEPARATOR_S)) {
#line 1000 "Utils.c"
		GString* _tmp4_;
		GString* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 78 "../src/Utils.vala"
		_tmp4_ = string_builder;
#line 78 "../src/Utils.vala"
		_tmp5_ = string_builder;
#line 78 "../src/Utils.vala"
		_tmp6_ = _tmp5_->str;
#line 78 "../src/Utils.vala"
		_tmp7_ = strlen (_tmp6_);
#line 78 "../src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 78 "../src/Utils.vala"
		g_string_erase (_tmp4_, (gssize) (_tmp8_ - 1), (gssize) -1);
#line 1018 "Utils.c"
	}
#line 81 "../src/Utils.vala"
	_tmp9_ = string_builder;
#line 81 "../src/Utils.vala"
	_tmp10_ = _tmp9_->str;
#line 81 "../src/Utils.vala"
	last_separator = string_last_index_of (_tmp10_, G_DIR_SEPARATOR_S, 0);
#line 82 "../src/Utils.vala"
	if (last_separator < 0) {
#line 83 "../src/Utils.vala"
		last_separator = 0;
#line 1030 "Utils.c"
	}
#line 86 "../src/Utils.vala"
	_tmp11_ = string_builder;
#line 86 "../src/Utils.vala"
	g_string_erase (_tmp11_, (gssize) last_separator, (gssize) -1);
#line 87 "../src/Utils.vala"
	_tmp12_ = string_builder;
#line 87 "../src/Utils.vala"
	_tmp13_ = _tmp12_->str;
#line 87 "../src/Utils.vala"
	_tmp14_ = g_strconcat (_tmp13_, G_DIR_SEPARATOR_S, NULL);
#line 87 "../src/Utils.vala"
	result = _tmp14_;
#line 87 "../src/Utils.vala"
	_g_string_free0 (string_builder);
#line 87 "../src/Utils.vala"
	return result;
#line 1048 "Utils.c"
}

gchar*
terminal_utils_construct_parent_path (const gchar* path)
{
	gint _tmp0_;
	gint _tmp1_;
	GString* sb = NULL;
	GString* _tmp3_;
	gint last_separator = 0;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GString* _tmp11_;
	gchar* parent_path = NULL;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
#line 90 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 91 "../src/Utils.vala"
	_tmp0_ = strlen (path);
#line 91 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Utils.vala"
	if (_tmp1_ < 2) {
#line 1075 "Utils.c"
		gchar* _tmp2_;
#line 92 "../src/Utils.vala"
		_tmp2_ = g_strdup (G_DIR_SEPARATOR_S);
#line 92 "../src/Utils.vala"
		result = _tmp2_;
#line 92 "../src/Utils.vala"
		return result;
#line 1083 "Utils.c"
	}
#line 95 "../src/Utils.vala"
	_tmp3_ = g_string_new (path);
#line 95 "../src/Utils.vala"
	sb = _tmp3_;
#line 97 "../src/Utils.vala"
	if (g_str_has_suffix (path, G_DIR_SEPARATOR_S)) {
#line 1091 "Utils.c"
		GString* _tmp4_;
		GString* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 98 "../src/Utils.vala"
		_tmp4_ = sb;
#line 98 "../src/Utils.vala"
		_tmp5_ = sb;
#line 98 "../src/Utils.vala"
		_tmp6_ = _tmp5_->str;
#line 98 "../src/Utils.vala"
		_tmp7_ = strlen (_tmp6_);
#line 98 "../src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 98 "../src/Utils.vala"
		g_string_erase (_tmp4_, (gssize) (_tmp8_ - 1), (gssize) -1);
#line 1109 "Utils.c"
	}
#line 101 "../src/Utils.vala"
	_tmp9_ = sb;
#line 101 "../src/Utils.vala"
	_tmp10_ = _tmp9_->str;
#line 101 "../src/Utils.vala"
	last_separator = string_last_index_of (_tmp10_, G_DIR_SEPARATOR_S, 0);
#line 102 "../src/Utils.vala"
	if (last_separator < 0) {
#line 103 "../src/Utils.vala"
		last_separator = 0;
#line 1121 "Utils.c"
	}
#line 105 "../src/Utils.vala"
	_tmp11_ = sb;
#line 105 "../src/Utils.vala"
	g_string_erase (_tmp11_, (gssize) last_separator, (gssize) -1);
#line 107 "../src/Utils.vala"
	_tmp12_ = sb;
#line 107 "../src/Utils.vala"
	_tmp13_ = _tmp12_->str;
#line 107 "../src/Utils.vala"
	_tmp14_ = g_strconcat (_tmp13_, G_DIR_SEPARATOR_S, NULL);
#line 107 "../src/Utils.vala"
	parent_path = _tmp14_;
#line 109 "../src/Utils.vala"
	result = parent_path;
#line 109 "../src/Utils.vala"
	_g_string_free0 (sb);
#line 109 "../src/Utils.vala"
	return result;
#line 1141 "Utils.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1162 "Utils.c"
}

gchar*
terminal_utils_strip_uri (const gchar* _uri)
{
	gchar* uri = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 113 "../src/Utils.vala"
	_tmp0_ = g_strdup (_uri);
#line 113 "../src/Utils.vala"
	uri = _tmp0_;
#line 115 "../src/Utils.vala"
	if (_uri != NULL) {
#line 1177 "Utils.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 116 "../src/Utils.vala"
		_tmp1_ = uri;
#line 116 "../src/Utils.vala"
		_tmp2_ = string_strip (_tmp1_);
#line 116 "../src/Utils.vala"
		_g_free0 (uri);
#line 116 "../src/Utils.vala"
		uri = _tmp2_;
#line 117 "../src/Utils.vala"
		_tmp3_ = uri;
#line 117 "../src/Utils.vala"
		_tmp4_ = string_replace (_tmp3_, "\n", "");
#line 117 "../src/Utils.vala"
		_g_free0 (uri);
#line 117 "../src/Utils.vala"
		uri = _tmp4_;
#line 118 "../src/Utils.vala"
		_tmp5_ = uri;
#line 118 "../src/Utils.vala"
		_tmp6_ = string_replace (_tmp5_, "\r", "");
#line 118 "../src/Utils.vala"
		_g_free0 (uri);
#line 118 "../src/Utils.vala"
		uri = _tmp6_;
#line 1208 "Utils.c"
	}
#line 121 "../src/Utils.vala"
	result = uri;
#line 121 "../src/Utils.vala"
	return result;
#line 1214 "Utils.c"
}

gchar*
terminal_utils_escape_uri (const gchar* uri,
                           gboolean allow_utf8,
                           gboolean allow_single_quote)
{
	gchar* placeholder = NULL;
	gchar* _tmp0_;
	gchar** parts = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* uri_to_escape = NULL;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_;
	gchar* rc = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* result;
#line 124 "../src/Utils.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 126 "../src/Utils.vala"
	_tmp0_ = g_strdup ("::::::");
#line 126 "../src/Utils.vala"
	placeholder = _tmp0_;
#line 127 "../src/Utils.vala"
	_tmp2_ = _tmp1_ = g_strsplit (uri, G_DIR_SEPARATOR_S, 0);
#line 127 "../src/Utils.vala"
	parts = _tmp2_;
#line 127 "../src/Utils.vala"
	parts_length1 = _vala_array_length (_tmp1_);
#line 127 "../src/Utils.vala"
	_parts_size_ = parts_length1;
#line 128 "../src/Utils.vala"
	_tmp3_ = parts;
#line 128 "../src/Utils.vala"
	_tmp3__length1 = parts_length1;
#line 128 "../src/Utils.vala"
	_tmp4_ = parts;
#line 128 "../src/Utils.vala"
	_tmp4__length1 = parts_length1;
#line 128 "../src/Utils.vala"
	_tmp5_ = parts;
#line 128 "../src/Utils.vala"
	_tmp5__length1 = parts_length1;
#line 128 "../src/Utils.vala"
	_tmp6_ = parts;
#line 128 "../src/Utils.vala"
	_tmp6__length1 = parts_length1;
#line 128 "../src/Utils.vala"
	_tmp7_ = _tmp5_[_tmp6__length1 - 1];
#line 128 "../src/Utils.vala"
	_tmp8_ = placeholder;
#line 128 "../src/Utils.vala"
	_tmp9_ = string_replace (_tmp7_, "#", _tmp8_);
#line 128 "../src/Utils.vala"
	_g_free0 (_tmp3_[_tmp4__length1 - 1]);
#line 128 "../src/Utils.vala"
	_tmp3_[_tmp4__length1 - 1] = _tmp9_;
#line 129 "../src/Utils.vala"
	_tmp10_ = parts;
#line 129 "../src/Utils.vala"
	_tmp10__length1 = parts_length1;
#line 129 "../src/Utils.vala"
	_tmp11_ = _vala_g_strjoinv (G_DIR_SEPARATOR_S, _tmp10_, (gint) _tmp10__length1);
#line 129 "../src/Utils.vala"
	uri_to_escape = _tmp11_;
#line 130 "../src/Utils.vala"
	_tmp12_ = string_replace (G_URI_RESERVED_CHARS_GENERIC_DELIMITERS G_URI_RESERVED_CHARS_SUBCOMPONENT_DELIMITERS, "#", "");
#line 130 "../src/Utils.vala"
	_tmp13_ = _tmp12_;
#line 130 "../src/Utils.vala"
	_tmp14_ = string_replace (_tmp13_, "*", "");
#line 130 "../src/Utils.vala"
	_tmp15_ = _tmp14_;
#line 130 "../src/Utils.vala"
	_tmp16_ = string_replace (_tmp15_, "~", "");
#line 130 "../src/Utils.vala"
	_tmp17_ = _tmp16_;
#line 130 "../src/Utils.vala"
	_g_free0 (_tmp15_);
#line 130 "../src/Utils.vala"
	_g_free0 (_tmp13_);
#line 130 "../src/Utils.vala"
	rc = _tmp17_;
#line 135 "../src/Utils.vala"
	if (!allow_single_quote) {
#line 1329 "Utils.c"
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 136 "../src/Utils.vala"
		_tmp18_ = rc;
#line 136 "../src/Utils.vala"
		_tmp19_ = string_replace (_tmp18_, "'", "");
#line 136 "../src/Utils.vala"
		_g_free0 (rc);
#line 136 "../src/Utils.vala"
		rc = _tmp19_;
#line 1340 "Utils.c"
	}
#line 141 "../src/Utils.vala"
	_tmp21_ = uri_to_escape;
#line 141 "../src/Utils.vala"
	_tmp22_ = g_uri_unescape_string (_tmp21_, NULL);
#line 141 "../src/Utils.vala"
	_tmp20_ = _tmp22_;
#line 141 "../src/Utils.vala"
	if (_tmp20_ == NULL) {
#line 1350 "Utils.c"
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 141 "../src/Utils.vala"
		_tmp23_ = uri_to_escape;
#line 141 "../src/Utils.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 141 "../src/Utils.vala"
		_g_free0 (_tmp20_);
#line 141 "../src/Utils.vala"
		_tmp20_ = _tmp24_;
#line 1361 "Utils.c"
	}
#line 140 "../src/Utils.vala"
	_tmp25_ = rc;
#line 140 "../src/Utils.vala"
	_tmp26_ = g_uri_escape_string (_tmp20_, _tmp25_, allow_utf8);
#line 140 "../src/Utils.vala"
	_tmp27_ = _tmp26_;
#line 140 "../src/Utils.vala"
	_tmp28_ = placeholder;
#line 140 "../src/Utils.vala"
	_tmp29_ = string_replace (_tmp27_, _tmp28_, "#");
#line 140 "../src/Utils.vala"
	_tmp30_ = _tmp29_;
#line 140 "../src/Utils.vala"
	_g_free0 (_tmp27_);
#line 140 "../src/Utils.vala"
	result = _tmp30_;
#line 140 "../src/Utils.vala"
	_g_free0 (_tmp20_);
#line 140 "../src/Utils.vala"
	_g_free0 (rc);
#line 140 "../src/Utils.vala"
	_g_free0 (uri_to_escape);
#line 140 "../src/Utils.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 140 "../src/Utils.vala"
	_g_free0 (placeholder);
#line 140 "../src/Utils.vala"
	return result;
#line 1391 "Utils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

