/* SettingsPopover.c generated by valac 0.56.17, the Vala compiler
 * generated from SettingsPopover.vala, do not modify */

/*
 * Copyright 2023 elementary, Inc (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-only
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <granite.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <vte/vte.h>
#include <glib/gi18n-lib.h>

#define TERMINAL_SETTINGS_POPOVER_STYLE_CSS "\n" \
"        .color-button radio {\n" \
"            background-color: %s;\n" \
"            color: %s;\n" \
"            padding: 10px;\n" \
"            -gtk-icon-shadow: none;\n" \
"        }\n" \
"    "
#define TERMINAL_THEMES_PALETTE_SIZE 19
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_OUT "term.zoom::out"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_DEFAULT "term.zoom::default"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_IN "term.zoom::in"
#define TERMINAL_THEMES_HIGH_CONTRAST "high-contrast"
#define TERMINAL_THEMES_LIGHT "solarized-light"
#define TERMINAL_THEMES_DARK "dark"
#define TERMINAL_THEMES_CUSTOM "custom"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_SETTINGS_POPOVER (terminal_settings_popover_get_type ())
#define TERMINAL_SETTINGS_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopover))
#define TERMINAL_SETTINGS_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopoverClass))
#define TERMINAL_IS_SETTINGS_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS_POPOVER))
#define TERMINAL_IS_SETTINGS_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS_POPOVER))
#define TERMINAL_SETTINGS_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopoverClass))

typedef struct _TerminalSettingsPopover TerminalSettingsPopover;
typedef struct _TerminalSettingsPopoverClass TerminalSettingsPopoverClass;
typedef struct _TerminalSettingsPopoverPrivate TerminalSettingsPopoverPrivate;
enum  {
	TERMINAL_SETTINGS_POPOVER_0_PROPERTY,
	TERMINAL_SETTINGS_POPOVER_TERMINAL_PROPERTY,
	TERMINAL_SETTINGS_POPOVER_NUM_PROPERTIES
};
static GParamSpec* terminal_settings_popover_properties[TERMINAL_SETTINGS_POPOVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
enum  {
	TERMINAL_SETTINGS_POPOVER_SHOW_THEME_EDITOR_SIGNAL,
	TERMINAL_SETTINGS_POPOVER_NUM_SIGNALS
};
static guint terminal_settings_popover_signals[TERMINAL_SETTINGS_POPOVER_NUM_SIGNALS] = {0};

struct _TerminalSettingsPopover {
	GtkPopover parent_instance;
	TerminalSettingsPopoverPrivate * priv;
};

struct _TerminalSettingsPopoverClass {
	GtkPopoverClass parent_class;
};

struct _TerminalSettingsPopoverPrivate {
	GBindingGroup* terminal_binding;
	GtkBox* theme_buttons;
};

struct _Block2Data {
	int _ref_count_;
	TerminalSettingsPopover* self;
	GtkRadioButton* dark_button;
	GtkCssProvider* custom_button_provider;
	GtkRadioButton* custom_button;
};

static gint TerminalSettingsPopover_private_offset;
static gpointer terminal_settings_popover_parent_class = NULL;
VALA_EXTERN GSettings* terminal_application_settings;

VALA_EXTERN GType terminal_settings_popover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettingsPopover, g_object_unref)
VALA_EXTERN TerminalSettingsPopover* terminal_settings_popover_new (void);
VALA_EXTERN TerminalSettingsPopover* terminal_settings_popover_construct (GType object_type);
static GtkRadioButton* terminal_settings_popover_add_theme_button (TerminalSettingsPopover* self,
                                                            const gchar* theme,
                                                            GtkCssProvider** css_provider);
static void terminal_settings_popover_update_theme_provider (GtkCssProvider* css_provider,
                                                      const gchar* theme);
static void __lambda17_ (TerminalSettingsPopover* self,
                  GtkToggleButton* b);
static void ___lambda17__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void terminal_settings_popover_update_active_colorbutton (GtkRadioButton* default_button,
                                                          const gchar* theme);
static gint __lambda18_ (GtkRadioButton* b,
                  const gchar* t);
static gint ___lambda18__gcompare_func (gconstpointer a,
                                 gconstpointer b);
VALA_EXTERN GdkRGBA* terminal_themes_get_rgba_palette (const gchar* theme,
                                           gint* result_length1);
static gboolean terminal_settings_popover_font_scale_to_zoom (GBinding* binding,
                                                       GValue* font_scale,
                                                       GValue* label);
VALA_EXTERN VteTerminal* terminal_settings_popover_get_terminal (TerminalSettingsPopover* self);
VALA_EXTERN void terminal_settings_popover_set_terminal (TerminalSettingsPopover* self,
                                             VteTerminal* value);
static GObject * terminal_settings_popover_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _terminal_settings_popover___lambda19_ (Block2Data* _data2_);
static void __terminal_settings_popover___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static gboolean _terminal_settings_popover_font_scale_to_zoom_gbinding_transform_func (GBinding* binding,
                                                                                GValue* from_value,
                                                                                GValue* to_value,
                                                                                gpointer self);
static void _terminal_settings_popover___lambda20_ (Block2Data* _data2_,
                                             GSettings* s,
                                             const gchar* n);
static void __terminal_settings_popover___lambda20__g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self);
static void _gtk_widget_show_all_gtk_widget_show (GtkWidget* _sender,
                                           gpointer self);
static void terminal_settings_popover_finalize (GObject * obj);
static GType terminal_settings_popover_get_type_once (void);
static void _vala_terminal_settings_popover_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_terminal_settings_popover_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

VALA_EXTERN const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_OUT[3];
VALA_EXTERN const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_DEFAULT[3];
VALA_EXTERN const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_IN[4];

static inline gpointer
terminal_settings_popover_get_instance_private (TerminalSettingsPopover* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalSettingsPopover_private_offset);
}

TerminalSettingsPopover*
terminal_settings_popover_construct (GType object_type)
{
	TerminalSettingsPopover * self = NULL;
#line 33 "../src/Widgets/SettingsPopover.vala"
	self = (TerminalSettingsPopover*) g_object_new (object_type, NULL);
#line 32 "../src/Widgets/SettingsPopover.vala"
	return self;
#line 177 "SettingsPopover.c"
}

TerminalSettingsPopover*
terminal_settings_popover_new (void)
{
#line 32 "../src/Widgets/SettingsPopover.vala"
	return terminal_settings_popover_construct (TERMINAL_TYPE_SETTINGS_POPOVER);
#line 185 "SettingsPopover.c"
}

static void
__lambda17_ (TerminalSettingsPopover* self,
             GtkToggleButton* b)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 175 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (b != NULL);
#line 176 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (b, gtk_radio_button_get_type (), GtkRadioButton));
#line 176 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = _tmp0_;
#line 176 "../src/Widgets/SettingsPopover.vala"
	if (_tmp1_) {
#line 202 "SettingsPopover.c"
		GSettings* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
#line 177 "../src/Widgets/SettingsPopover.vala"
		_tmp2_ = terminal_application_settings;
#line 177 "../src/Widgets/SettingsPopover.vala"
		g_object_get ((GtkActionable*) b, "action-target", &_tmp3_, NULL);
#line 177 "../src/Widgets/SettingsPopover.vala"
		_tmp4_ = _tmp3_;
#line 177 "../src/Widgets/SettingsPopover.vala"
		_tmp5_ = _tmp4_;
#line 177 "../src/Widgets/SettingsPopover.vala"
		g_settings_set_value (_tmp2_, "theme", _tmp5_);
#line 177 "../src/Widgets/SettingsPopover.vala"
		_g_variant_unref0 (_tmp5_);
#line 219 "SettingsPopover.c"
	}
}

static void
___lambda17__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 175 "../src/Widgets/SettingsPopover.vala"
	__lambda17_ ((TerminalSettingsPopover*) self, _sender);
#line 229 "SettingsPopover.c"
}

static GtkRadioButton*
terminal_settings_popover_add_theme_button (TerminalSettingsPopover* self,
                                            const gchar* theme,
                                            GtkCssProvider** css_provider)
{
	GtkCssProvider* _vala_css_provider = NULL;
	GtkRadioButton* button = NULL;
	GVariant* _tmp0_;
	GtkRadioButton* _tmp1_ = NULL;
	GtkCssProvider* _tmp2_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp3_;
	GtkBox* _tmp4_;
	GtkRadioButton* result;
#line 162 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (theme != NULL, NULL);
#line 163 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = g_variant_new_string (theme);
#line 163 "../src/Widgets/SettingsPopover.vala"
	g_variant_ref_sink (_tmp0_);
#line 163 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 163 "../src/Widgets/SettingsPopover.vala"
	g_object_set ((GtkActionable*) _tmp1_, "action-target", _tmp0_, NULL);
#line 163 "../src/Widgets/SettingsPopover.vala"
	_g_variant_unref0 (_tmp0_);
#line 163 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 163 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp1_);
#line 163 "../src/Widgets/SettingsPopover.vala"
	button = _tmp1_;
#line 168 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = gtk_css_provider_new ();
#line 168 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (_vala_css_provider);
#line 168 "../src/Widgets/SettingsPopover.vala"
	_vala_css_provider = _tmp2_;
#line 170 "../src/Widgets/SettingsPopover.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) button);
#line 170 "../src/Widgets/SettingsPopover.vala"
	style_context = _tmp3_;
#line 171 "../src/Widgets/SettingsPopover.vala"
	gtk_style_context_add_class (style_context, GRANITE_STYLE_CLASS_COLOR_BUTTON);
#line 172 "../src/Widgets/SettingsPopover.vala"
	gtk_style_context_add_provider (style_context, (GtkStyleProvider*) _vala_css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 173 "../src/Widgets/SettingsPopover.vala"
	terminal_settings_popover_update_theme_provider (_vala_css_provider, theme);
#line 175 "../src/Widgets/SettingsPopover.vala"
	g_signal_connect_object ((GtkToggleButton*) button, "toggled", (GCallback) ___lambda17__gtk_toggle_button_toggled, self, 0);
#line 181 "../src/Widgets/SettingsPopover.vala"
	_tmp4_ = self->priv->theme_buttons;
#line 181 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) button);
#line 182 "../src/Widgets/SettingsPopover.vala"
	result = button;
#line 182 "../src/Widgets/SettingsPopover.vala"
	if (css_provider) {
#line 182 "../src/Widgets/SettingsPopover.vala"
		*css_provider = _vala_css_provider;
#line 294 "SettingsPopover.c"
	} else {
#line 182 "../src/Widgets/SettingsPopover.vala"
		_g_object_unref0 (_vala_css_provider);
#line 298 "SettingsPopover.c"
	}
#line 182 "../src/Widgets/SettingsPopover.vala"
	return result;
#line 302 "SettingsPopover.c"
}

static gint
__lambda18_ (GtkRadioButton* b,
             const gchar* t)
{
	GCompareFunc _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint result;
#line 186 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 186 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (t != NULL, 0);
#line 186 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 186 "../src/Widgets/SettingsPopover.vala"
	g_object_get ((GtkActionable*) b, "action-target", &_tmp1_, NULL);
#line 186 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/Widgets/SettingsPopover.vala"
	_tmp3_ = _tmp2_;
#line 186 "../src/Widgets/SettingsPopover.vala"
	_tmp4_ = g_variant_get_string (_tmp3_, NULL);
#line 186 "../src/Widgets/SettingsPopover.vala"
	_tmp5_ = _tmp0_ (_tmp4_, t);
#line 186 "../src/Widgets/SettingsPopover.vala"
	_g_variant_unref0 (_tmp3_);
#line 186 "../src/Widgets/SettingsPopover.vala"
	result = _tmp5_;
#line 186 "../src/Widgets/SettingsPopover.vala"
	return result;
#line 338 "SettingsPopover.c"
}

static gint
___lambda18__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda18_ ((GtkRadioButton*) a, (const gchar*) b);
#line 186 "../src/Widgets/SettingsPopover.vala"
	return result;
#line 349 "SettingsPopover.c"
}

static void
terminal_settings_popover_update_active_colorbutton (GtkRadioButton* default_button,
                                                     const gchar* theme)
{
	GCompareFunc find_colorbutton = NULL;
	GSList* node = NULL;
	GSList* _tmp0_;
	GCompareFunc _tmp1_;
	GSList* _tmp2_;
	GSList* _tmp3_;
#line 185 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (default_button != NULL);
#line 185 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (theme != NULL);
#line 186 "../src/Widgets/SettingsPopover.vala"
	find_colorbutton = ___lambda18__gcompare_func;
#line 187 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = gtk_radio_button_get_group (default_button);
#line 187 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = find_colorbutton;
#line 187 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = g_slist_find_custom (_tmp0_, theme, _tmp1_);
#line 187 "../src/Widgets/SettingsPopover.vala"
	node = _tmp2_;
#line 189 "../src/Widgets/SettingsPopover.vala"
	_tmp3_ = node;
#line 189 "../src/Widgets/SettingsPopover.vala"
	if (_tmp3_ != NULL) {
#line 380 "SettingsPopover.c"
		GSList* _tmp4_;
		gconstpointer _tmp5_;
#line 190 "../src/Widgets/SettingsPopover.vala"
		_tmp4_ = node;
#line 190 "../src/Widgets/SettingsPopover.vala"
		_tmp5_ = _tmp4_->data;
#line 190 "../src/Widgets/SettingsPopover.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((GtkRadioButton*) _tmp5_), TRUE);
#line 389 "SettingsPopover.c"
	} else {
#line 192 "../src/Widgets/SettingsPopover.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) default_button, TRUE);
#line 393 "SettingsPopover.c"
	}
}

static void
terminal_settings_popover_update_theme_provider (GtkCssProvider* css_provider,
                                                 const gchar* theme)
{
	GdkRGBA* theme_palette = NULL;
	gint _tmp0_ = 0;
	GdkRGBA* _tmp1_;
	gint theme_palette_length1;
	gint _theme_palette_size_;
	gchar* background = NULL;
	gchar* _tmp2_;
	gchar* foreground = NULL;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 196 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (css_provider != NULL);
#line 196 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (theme != NULL);
#line 197 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = terminal_themes_get_rgba_palette (theme, &_tmp0_);
#line 197 "../src/Widgets/SettingsPopover.vala"
	theme_palette = _tmp1_;
#line 197 "../src/Widgets/SettingsPopover.vala"
	theme_palette_length1 = _tmp0_;
#line 197 "../src/Widgets/SettingsPopover.vala"
	_theme_palette_size_ = theme_palette_length1;
#line 198 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = gdk_rgba_to_string (&theme_palette[TERMINAL_THEMES_PALETTE_SIZE - 3]);
#line 198 "../src/Widgets/SettingsPopover.vala"
	background = _tmp2_;
#line 199 "../src/Widgets/SettingsPopover.vala"
	_tmp3_ = gdk_rgba_to_string (&theme_palette[TERMINAL_THEMES_PALETTE_SIZE - 2]);
#line 199 "../src/Widgets/SettingsPopover.vala"
	foreground = _tmp3_;
#line 431 "SettingsPopover.c"
	{
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 202 "../src/Widgets/SettingsPopover.vala"
		_tmp4_ = g_strdup_printf (TERMINAL_SETTINGS_POPOVER_STYLE_CSS, background, foreground);
#line 202 "../src/Widgets/SettingsPopover.vala"
		_tmp5_ = _tmp4_;
#line 202 "../src/Widgets/SettingsPopover.vala"
		gtk_css_provider_load_from_data (css_provider, _tmp5_, (gssize) -1, &_inner_error0_);
#line 202 "../src/Widgets/SettingsPopover.vala"
		_g_free0 (_tmp5_);
#line 202 "../src/Widgets/SettingsPopover.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 445 "SettingsPopover.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 201 "../src/Widgets/SettingsPopover.vala"
		e = _inner_error0_;
#line 201 "../src/Widgets/SettingsPopover.vala"
		_inner_error0_ = NULL;
#line 204 "../src/Widgets/SettingsPopover.vala"
		_tmp6_ = e;
#line 204 "../src/Widgets/SettingsPopover.vala"
		_tmp7_ = _tmp6_->message;
#line 204 "../src/Widgets/SettingsPopover.vala"
		g_critical ("SettingsPopover.vala:204: Unable to style color button: %s", _tmp7_);
#line 201 "../src/Widgets/SettingsPopover.vala"
		_g_error_free0 (e);
#line 467 "SettingsPopover.c"
	}
	__finally0:
#line 201 "../src/Widgets/SettingsPopover.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../src/Widgets/SettingsPopover.vala"
		_g_free0 (foreground);
#line 201 "../src/Widgets/SettingsPopover.vala"
		_g_free0 (background);
#line 201 "../src/Widgets/SettingsPopover.vala"
		theme_palette = (g_free (theme_palette), NULL);
#line 201 "../src/Widgets/SettingsPopover.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../src/Widgets/SettingsPopover.vala"
		g_clear_error (&_inner_error0_);
#line 201 "../src/Widgets/SettingsPopover.vala"
		return;
#line 484 "SettingsPopover.c"
	}
#line 196 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (foreground);
#line 196 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (background);
#line 196 "../src/Widgets/SettingsPopover.vala"
	theme_palette = (g_free (theme_palette), NULL);
#line 492 "SettingsPopover.c"
}

static gboolean
terminal_settings_popover_font_scale_to_zoom (GBinding* binding,
                                              GValue* font_scale,
                                              GValue* label)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 208 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 208 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (font_scale != NULL, FALSE);
#line 208 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 209 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = g_strdup_printf ("%.0f%%", g_value_get_double (font_scale) * 100);
#line 209 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = _tmp0_;
#line 209 "../src/Widgets/SettingsPopover.vala"
	g_value_set_string (label, _tmp1_);
#line 209 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp1_);
#line 210 "../src/Widgets/SettingsPopover.vala"
	result = TRUE;
#line 210 "../src/Widgets/SettingsPopover.vala"
	return result;
#line 521 "SettingsPopover.c"
}

VteTerminal*
terminal_settings_popover_get_terminal (TerminalSettingsPopover* self)
{
	VteTerminal* result;
	GBindingGroup* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	VteTerminal* _tmp3_;
#line 10 "../src/Widgets/SettingsPopover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = self->priv->terminal_binding;
#line 11 "../src/Widgets/SettingsPopover.vala"
	g_object_get (_tmp0_, "source", &_tmp1_, NULL);
#line 11 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = _tmp1_;
#line 11 "../src/Widgets/SettingsPopover.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, vte_terminal_get_type ()) ? ((VteTerminal*) _tmp2_) : NULL;
#line 11 "../src/Widgets/SettingsPopover.vala"
	if (_tmp3_ == NULL) {
#line 11 "../src/Widgets/SettingsPopover.vala"
		_g_object_unref0 (_tmp2_);
#line 546 "SettingsPopover.c"
	}
#line 11 "../src/Widgets/SettingsPopover.vala"
	result = _tmp3_;
#line 11 "../src/Widgets/SettingsPopover.vala"
	return result;
#line 552 "SettingsPopover.c"
}

void
terminal_settings_popover_set_terminal (TerminalSettingsPopover* self,
                                        VteTerminal* value)
{
	GBindingGroup* _tmp0_;
	GActionGroup* _tmp1_;
#line 14 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = self->priv->terminal_binding;
#line 15 "../src/Widgets/SettingsPopover.vala"
	g_object_set (_tmp0_, "source", (GObject*) value, NULL);
#line 16 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = gtk_widget_get_action_group ((GtkWidget*) value, "term");
#line 16 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "term", _tmp1_);
#line 14 "../src/Widgets/SettingsPopover.vala"
	g_object_notify_by_pspec ((GObject *) self, terminal_settings_popover_properties[TERMINAL_SETTINGS_POPOVER_TERMINAL_PROPERTY]);
#line 573 "SettingsPopover.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 36 "../src/Widgets/SettingsPopover.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 36 "../src/Widgets/SettingsPopover.vala"
	return _data2_;
#line 583 "SettingsPopover.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 36 "../src/Widgets/SettingsPopover.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 593 "SettingsPopover.c"
		TerminalSettingsPopover* self;
#line 36 "../src/Widgets/SettingsPopover.vala"
		self = _data2_->self;
#line 36 "../src/Widgets/SettingsPopover.vala"
		_g_object_unref0 (_data2_->custom_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
		_g_object_unref0 (_data2_->custom_button_provider);
#line 36 "../src/Widgets/SettingsPopover.vala"
		_g_object_unref0 (_data2_->dark_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
		_g_object_unref0 (self);
#line 36 "../src/Widgets/SettingsPopover.vala"
		g_slice_free (Block2Data, _data2_);
#line 607 "SettingsPopover.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../src/Widgets/SettingsPopover.vala"
	return self ? g_object_ref (self) : NULL;
#line 616 "SettingsPopover.c"
}

static void
_terminal_settings_popover___lambda19_ (Block2Data* _data2_)
{
	TerminalSettingsPopover* self;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 135 "../src/Widgets/SettingsPopover.vala"
	self = _data2_->self;
#line 136 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = _data2_->custom_button;
#line 136 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 136 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = _tmp1_;
#line 136 "../src/Widgets/SettingsPopover.vala"
	if (_tmp2_) {
#line 137 "../src/Widgets/SettingsPopover.vala"
		g_signal_emit (self, terminal_settings_popover_signals[TERMINAL_SETTINGS_POPOVER_SHOW_THEME_EDITOR_SIGNAL], 0);
#line 138 "../src/Widgets/SettingsPopover.vala"
		gtk_popover_popdown ((GtkPopover*) self);
#line 640 "SettingsPopover.c"
	}
}

static void
__terminal_settings_popover___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 135 "../src/Widgets/SettingsPopover.vala"
	_terminal_settings_popover___lambda19_ (self);
#line 650 "SettingsPopover.c"
}

static gboolean
_terminal_settings_popover_font_scale_to_zoom_gbinding_transform_func (GBinding* binding,
                                                                       GValue* from_value,
                                                                       GValue* to_value,
                                                                       gpointer self)
{
	gboolean result;
	result = terminal_settings_popover_font_scale_to_zoom (binding, from_value, to_value);
#line 143 "../src/Widgets/SettingsPopover.vala"
	return result;
#line 663 "SettingsPopover.c"
}

static void
_terminal_settings_popover___lambda20_ (Block2Data* _data2_,
                                        GSettings* s,
                                        const gchar* n)
{
	TerminalSettingsPopover* self;
	gboolean _tmp0_ = FALSE;
#line 151 "../src/Widgets/SettingsPopover.vala"
	self = _data2_->self;
#line 151 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (s != NULL);
#line 151 "../src/Widgets/SettingsPopover.vala"
	g_return_if_fail (n != NULL);
#line 152 "../src/Widgets/SettingsPopover.vala"
	if (g_strcmp0 (n, "background") == 0) {
#line 152 "../src/Widgets/SettingsPopover.vala"
		_tmp0_ = TRUE;
#line 683 "SettingsPopover.c"
	} else {
#line 152 "../src/Widgets/SettingsPopover.vala"
		_tmp0_ = g_strcmp0 (n, "foreground") == 0;
#line 687 "SettingsPopover.c"
	}
#line 152 "../src/Widgets/SettingsPopover.vala"
	if (_tmp0_) {
#line 691 "SettingsPopover.c"
		GtkCssProvider* _tmp1_;
#line 153 "../src/Widgets/SettingsPopover.vala"
		_tmp1_ = _data2_->custom_button_provider;
#line 153 "../src/Widgets/SettingsPopover.vala"
		terminal_settings_popover_update_theme_provider (_tmp1_, TERMINAL_THEMES_CUSTOM);
#line 697 "SettingsPopover.c"
	} else {
#line 154 "../src/Widgets/SettingsPopover.vala"
		if (g_strcmp0 (n, "theme") == 0) {
#line 701 "SettingsPopover.c"
			GtkRadioButton* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 155 "../src/Widgets/SettingsPopover.vala"
			_tmp2_ = _data2_->dark_button;
#line 155 "../src/Widgets/SettingsPopover.vala"
			_tmp3_ = g_settings_get_string (s, n);
#line 155 "../src/Widgets/SettingsPopover.vala"
			_tmp4_ = _tmp3_;
#line 155 "../src/Widgets/SettingsPopover.vala"
			terminal_settings_popover_update_active_colorbutton (_tmp2_, _tmp4_);
#line 155 "../src/Widgets/SettingsPopover.vala"
			_g_free0 (_tmp4_);
#line 715 "SettingsPopover.c"
		}
	}
}

static void
__terminal_settings_popover___lambda20__g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self)
{
#line 151 "../src/Widgets/SettingsPopover.vala"
	_terminal_settings_popover___lambda20_ (self, _sender, key);
#line 727 "SettingsPopover.c"
}

static void
_gtk_widget_show_all_gtk_widget_show (GtkWidget* _sender,
                                      gpointer self)
{
#line 159 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 736 "SettingsPopover.c"
}

static GObject *
terminal_settings_popover_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TerminalSettingsPopover * self;
	Block2Data* _data2_;
	GtkButton* zoom_out_button = NULL;
	gchar* _tmp0_;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_;
	GtkButton* zoom_default_button = NULL;
	gchar* _tmp3_;
	GtkButton* _tmp4_ = NULL;
	GtkButton* _tmp5_;
	GtkButton* zoom_in_button = NULL;
	gchar* _tmp6_;
	GtkButton* _tmp7_ = NULL;
	GtkButton* _tmp8_;
	GtkBox* font_size_box = NULL;
	GtkBox* _tmp9_ = NULL;
	GtkBox* _tmp10_;
	GtkButton* _tmp11_;
	GtkBox* _tmp12_;
	GtkButton* _tmp13_;
	GtkBox* _tmp14_;
	GtkButton* _tmp15_;
	GtkBox* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkBox* _tmp18_ = NULL;
	GtkRevealer* theme_revealer = NULL;
	GtkBox* _tmp19_;
	GtkWidget* _tmp20_;
	GtkRevealer* _tmp21_ = NULL;
	GraniteSwitchModelButton* follow_system_button = NULL;
	GSettings* _tmp22_;
	GraniteSwitchModelButton* _tmp23_ = NULL;
	GtkBox* theme_box = NULL;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GraniteSwitchModelButton* _tmp26_;
	GtkBox* _tmp27_;
	GtkRevealer* _tmp28_;
	GtkRadioButton* hc_button = NULL;
	GtkRadioButton* _tmp29_;
	GtkRadioButton* _tmp30_;
	GtkRadioButton* light_button = NULL;
	GtkRadioButton* _tmp31_;
	GtkRadioButton* _tmp32_;
	GtkRadioButton* _tmp33_;
	GtkRadioButton* _tmp34_;
	GtkRadioButton* _tmp35_;
	GtkRadioButton* _tmp36_;
	GtkRadioButton* _tmp37_;
	GtkRadioButton* _tmp38_;
	GtkCssProvider* _tmp39_ = NULL;
	GtkRadioButton* _tmp40_;
	GtkRadioButton* _tmp41_;
	GtkRadioButton* _tmp42_;
	GtkRadioButton* _tmp43_;
	GtkRadioButton* _tmp44_;
	GtkStyleContext* _tmp45_;
	GtkRadioButton* _tmp46_;
	GSettings* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GraniteSwitchModelButton* natural_copy_paste_button = NULL;
	gchar* _tmp50_;
	GSettings* _tmp51_;
	GraniteSwitchModelButton* _tmp52_ = NULL;
	GraniteSwitchModelButton* audible_bell_button = NULL;
	gchar* _tmp53_;
	GSettings* _tmp54_;
	GraniteSwitchModelButton* _tmp55_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp56_ = NULL;
	GtkBox* _tmp57_;
	GtkBox* _tmp58_;
	GtkBox* _tmp59_;
	GtkSeparator* _tmp60_;
	GtkSeparator* _tmp61_;
	GtkBox* _tmp62_;
	GtkBox* _tmp63_;
	GtkBox* _tmp64_;
	GtkSeparator* _tmp65_;
	GtkSeparator* _tmp66_;
	GtkBox* _tmp67_;
	GraniteSwitchModelButton* _tmp68_;
	GtkBox* _tmp69_;
	GraniteSwitchModelButton* _tmp70_;
	GtkBox* _tmp71_;
	GtkRadioButton* _tmp72_;
	GBindingGroup* _tmp73_;
	GBindingGroup* _tmp74_;
	GtkButton* _tmp75_;
	GraniteSwitchModelButton* _tmp76_;
	GtkRevealer* _tmp77_;
	GSettings* _tmp78_;
	GraniteSwitchModelButton* _tmp79_;
	GSettings* _tmp80_;
	GraniteSwitchModelButton* _tmp81_;
	GSettings* _tmp82_;
	GraniteSwitchModelButton* _tmp83_;
	GSettings* _tmp84_;
	GtkWidget* _tmp85_;
#line 36 "../src/Widgets/SettingsPopover.vala"
	parent_class = G_OBJECT_CLASS (terminal_settings_popover_parent_class);
#line 36 "../src/Widgets/SettingsPopover.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/Widgets/SettingsPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopover);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_data2_->_ref_count_ = 1;
#line 36 "../src/Widgets/SettingsPopover.vala"
	_data2_->self = g_object_ref (self);
#line 37 "../src/Widgets/SettingsPopover.vala"
	_tmp0_ = granite_markup_accel_tooltip (TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_OUT, (gint) G_N_ELEMENTS (TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_OUT), _ ("Zoom out"));
#line 37 "../src/Widgets/SettingsPopover.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-out-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 37 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp1_, _tmp0_);
#line 37 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp0_);
#line 37 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp1_);
#line 37 "../src/Widgets/SettingsPopover.vala"
	zoom_out_button = _tmp1_;
#line 43 "../src/Widgets/SettingsPopover.vala"
	_tmp2_ = zoom_out_button;
#line 43 "../src/Widgets/SettingsPopover.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp2_, TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_OUT);
#line 45 "../src/Widgets/SettingsPopover.vala"
	_tmp3_ = granite_markup_accel_tooltip (TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_DEFAULT, (gint) G_N_ELEMENTS (TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_DEFAULT), _ ("Default zoom level"));
#line 45 "../src/Widgets/SettingsPopover.vala"
	_tmp4_ = (GtkButton*) gtk_button_new ();
#line 45 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp4_, _tmp3_);
#line 45 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp3_);
#line 45 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp4_);
#line 45 "../src/Widgets/SettingsPopover.vala"
	zoom_default_button = _tmp4_;
#line 51 "../src/Widgets/SettingsPopover.vala"
	_tmp5_ = zoom_default_button;
#line 51 "../src/Widgets/SettingsPopover.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp5_, TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_DEFAULT);
#line 53 "../src/Widgets/SettingsPopover.vala"
	_tmp6_ = granite_markup_accel_tooltip (TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_IN, (gint) G_N_ELEMENTS (TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_IN), _ ("Zoom in"));
#line 53 "../src/Widgets/SettingsPopover.vala"
	_tmp7_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-in-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 53 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp7_, _tmp6_);
#line 53 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp6_);
#line 53 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp7_);
#line 53 "../src/Widgets/SettingsPopover.vala"
	zoom_in_button = _tmp7_;
#line 59 "../src/Widgets/SettingsPopover.vala"
	_tmp8_ = zoom_in_button;
#line 59 "../src/Widgets/SettingsPopover.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp8_, TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_IN);
#line 61 "../src/Widgets/SettingsPopover.vala"
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 61 "../src/Widgets/SettingsPopover.vala"
	gtk_box_set_homogeneous (_tmp9_, TRUE);
#line 61 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
#line 61 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp9_, 12);
#line 61 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp9_, 12);
#line 61 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp9_, 6);
#line 61 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp9_);
#line 61 "../src/Widgets/SettingsPopover.vala"
	font_size_box = _tmp9_;
#line 68 "../src/Widgets/SettingsPopover.vala"
	_tmp10_ = font_size_box;
#line 68 "../src/Widgets/SettingsPopover.vala"
	_tmp11_ = zoom_out_button;
#line 68 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 69 "../src/Widgets/SettingsPopover.vala"
	_tmp12_ = font_size_box;
#line 69 "../src/Widgets/SettingsPopover.vala"
	_tmp13_ = zoom_default_button;
#line 69 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 70 "../src/Widgets/SettingsPopover.vala"
	_tmp14_ = font_size_box;
#line 70 "../src/Widgets/SettingsPopover.vala"
	_tmp15_ = zoom_in_button;
#line 70 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 72 "../src/Widgets/SettingsPopover.vala"
	_tmp16_ = font_size_box;
#line 72 "../src/Widgets/SettingsPopover.vala"
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 72 "../src/Widgets/SettingsPopover.vala"
	gtk_style_context_add_class (_tmp17_, GTK_STYLE_CLASS_LINKED);
#line 74 "../src/Widgets/SettingsPopover.vala"
	_tmp18_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 74 "../src/Widgets/SettingsPopover.vala"
	gtk_box_set_homogeneous (_tmp18_, TRUE);
#line 74 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp18_, 6);
#line 74 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp18_, 6);
#line 74 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp18_);
#line 74 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (self->priv->theme_buttons);
#line 74 "../src/Widgets/SettingsPopover.vala"
	self->priv->theme_buttons = _tmp18_;
#line 80 "../src/Widgets/SettingsPopover.vala"
	_tmp19_ = self->priv->theme_buttons;
#line 80 "../src/Widgets/SettingsPopover.vala"
	_tmp20_ = _g_object_ref0 ((GtkWidget*) _tmp19_);
#line 80 "../src/Widgets/SettingsPopover.vala"
	_tmp21_ = (GtkRevealer*) gtk_revealer_new ();
#line 80 "../src/Widgets/SettingsPopover.vala"
	g_object_set ((GtkContainer*) _tmp21_, "child", _tmp20_, NULL);
#line 80 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (_tmp20_);
#line 80 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp21_);
#line 80 "../src/Widgets/SettingsPopover.vala"
	theme_revealer = _tmp21_;
#line 84 "../src/Widgets/SettingsPopover.vala"
	_tmp22_ = terminal_application_settings;
#line 84 "../src/Widgets/SettingsPopover.vala"
	_tmp23_ = granite_switch_model_button_new (_ ("Follow System Style"));
#line 84 "../src/Widgets/SettingsPopover.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp23_, g_settings_get_boolean (_tmp22_, "follow-system-style"));
#line 84 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp23_);
#line 84 "../src/Widgets/SettingsPopover.vala"
	follow_system_button = _tmp23_;
#line 88 "../src/Widgets/SettingsPopover.vala"
	_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 88 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp24_);
#line 88 "../src/Widgets/SettingsPopover.vala"
	theme_box = _tmp24_;
#line 89 "../src/Widgets/SettingsPopover.vala"
	_tmp25_ = theme_box;
#line 89 "../src/Widgets/SettingsPopover.vala"
	_tmp26_ = follow_system_button;
#line 89 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 90 "../src/Widgets/SettingsPopover.vala"
	_tmp27_ = theme_box;
#line 90 "../src/Widgets/SettingsPopover.vala"
	_tmp28_ = theme_revealer;
#line 90 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 92 "../src/Widgets/SettingsPopover.vala"
	_tmp29_ = terminal_settings_popover_add_theme_button (self, TERMINAL_THEMES_HIGH_CONTRAST, NULL);
#line 92 "../src/Widgets/SettingsPopover.vala"
	hc_button = _tmp29_;
#line 93 "../src/Widgets/SettingsPopover.vala"
	_tmp30_ = hc_button;
#line 93 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, _ ("High Contrast"));
#line 95 "../src/Widgets/SettingsPopover.vala"
	_tmp31_ = terminal_settings_popover_add_theme_button (self, TERMINAL_THEMES_LIGHT, NULL);
#line 95 "../src/Widgets/SettingsPopover.vala"
	light_button = _tmp31_;
#line 96 "../src/Widgets/SettingsPopover.vala"
	_tmp32_ = light_button;
#line 96 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _ ("Solarized Light"));
#line 97 "../src/Widgets/SettingsPopover.vala"
	_tmp33_ = light_button;
#line 97 "../src/Widgets/SettingsPopover.vala"
	_tmp34_ = hc_button;
#line 97 "../src/Widgets/SettingsPopover.vala"
	g_object_set (_tmp33_, "group", _tmp34_, NULL);
#line 99 "../src/Widgets/SettingsPopover.vala"
	_tmp35_ = terminal_settings_popover_add_theme_button (self, TERMINAL_THEMES_DARK, NULL);
#line 99 "../src/Widgets/SettingsPopover.vala"
	_data2_->dark_button = _tmp35_;
#line 100 "../src/Widgets/SettingsPopover.vala"
	_tmp36_ = _data2_->dark_button;
#line 100 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp36_, _ ("Dark"));
#line 101 "../src/Widgets/SettingsPopover.vala"
	_tmp37_ = _data2_->dark_button;
#line 101 "../src/Widgets/SettingsPopover.vala"
	_tmp38_ = hc_button;
#line 101 "../src/Widgets/SettingsPopover.vala"
	g_object_set (_tmp37_, "group", _tmp38_, NULL);
#line 105 "../src/Widgets/SettingsPopover.vala"
	_tmp40_ = terminal_settings_popover_add_theme_button (self, TERMINAL_THEMES_CUSTOM, &_tmp39_);
#line 105 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (_data2_->custom_button_provider);
#line 105 "../src/Widgets/SettingsPopover.vala"
	_data2_->custom_button_provider = _tmp39_;
#line 105 "../src/Widgets/SettingsPopover.vala"
	_data2_->custom_button = _tmp40_;
#line 106 "../src/Widgets/SettingsPopover.vala"
	_tmp41_ = _data2_->custom_button;
#line 106 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp41_, _ ("Custom"));
#line 107 "../src/Widgets/SettingsPopover.vala"
	_tmp42_ = _data2_->custom_button;
#line 107 "../src/Widgets/SettingsPopover.vala"
	_tmp43_ = hc_button;
#line 107 "../src/Widgets/SettingsPopover.vala"
	g_object_set (_tmp42_, "group", _tmp43_, NULL);
#line 108 "../src/Widgets/SettingsPopover.vala"
	_tmp44_ = _data2_->custom_button;
#line 108 "../src/Widgets/SettingsPopover.vala"
	_tmp45_ = gtk_widget_get_style_context ((GtkWidget*) _tmp44_);
#line 108 "../src/Widgets/SettingsPopover.vala"
	gtk_style_context_add_class (_tmp45_, "color-custom");
#line 110 "../src/Widgets/SettingsPopover.vala"
	_tmp46_ = _data2_->dark_button;
#line 110 "../src/Widgets/SettingsPopover.vala"
	_tmp47_ = terminal_application_settings;
#line 110 "../src/Widgets/SettingsPopover.vala"
	_tmp48_ = g_settings_get_string (_tmp47_, "theme");
#line 110 "../src/Widgets/SettingsPopover.vala"
	_tmp49_ = _tmp48_;
#line 110 "../src/Widgets/SettingsPopover.vala"
	terminal_settings_popover_update_active_colorbutton (_tmp46_, _tmp49_);
#line 110 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp49_);
#line 112 "../src/Widgets/SettingsPopover.vala"
	_tmp50_ = g_strdup (_ ("Shortcuts don’t require Shift; may interfere with CLI apps"));
#line 112 "../src/Widgets/SettingsPopover.vala"
	_tmp51_ = terminal_application_settings;
#line 112 "../src/Widgets/SettingsPopover.vala"
	_tmp52_ = granite_switch_model_button_new (_ ("Natural Copy/Paste"));
#line 112 "../src/Widgets/SettingsPopover.vala"
	granite_switch_model_button_set_description (_tmp52_, _tmp50_);
#line 112 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp50_);
#line 112 "../src/Widgets/SettingsPopover.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp52_, g_settings_get_boolean (_tmp51_, "natural-copy-paste"));
#line 112 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp52_);
#line 112 "../src/Widgets/SettingsPopover.vala"
	natural_copy_paste_button = _tmp52_;
#line 117 "../src/Widgets/SettingsPopover.vala"
	_tmp53_ = g_strdup (_ ("Notify for invalid input or multiple possible completions (subject to " \
"System Settings → Sound)"));
#line 117 "../src/Widgets/SettingsPopover.vala"
	_tmp54_ = terminal_application_settings;
#line 117 "../src/Widgets/SettingsPopover.vala"
	_tmp55_ = granite_switch_model_button_new (_ ("Event Alerts"));
#line 117 "../src/Widgets/SettingsPopover.vala"
	granite_switch_model_button_set_description (_tmp55_, _tmp53_);
#line 117 "../src/Widgets/SettingsPopover.vala"
	_g_free0 (_tmp53_);
#line 117 "../src/Widgets/SettingsPopover.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp55_, g_settings_get_boolean (_tmp54_, "audible-bell"));
#line 117 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp55_);
#line 117 "../src/Widgets/SettingsPopover.vala"
	audible_bell_button = _tmp55_;
#line 122 "../src/Widgets/SettingsPopover.vala"
	_tmp56_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 122 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp56_, 6);
#line 122 "../src/Widgets/SettingsPopover.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp56_, 12);
#line 122 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp56_);
#line 122 "../src/Widgets/SettingsPopover.vala"
	box = _tmp56_;
#line 127 "../src/Widgets/SettingsPopover.vala"
	_tmp57_ = box;
#line 127 "../src/Widgets/SettingsPopover.vala"
	_tmp58_ = font_size_box;
#line 127 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 128 "../src/Widgets/SettingsPopover.vala"
	_tmp59_ = box;
#line 128 "../src/Widgets/SettingsPopover.vala"
	_tmp60_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 128 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp60_);
#line 128 "../src/Widgets/SettingsPopover.vala"
	_tmp61_ = _tmp60_;
#line 128 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp61_);
#line 128 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (_tmp61_);
#line 129 "../src/Widgets/SettingsPopover.vala"
	_tmp62_ = box;
#line 129 "../src/Widgets/SettingsPopover.vala"
	_tmp63_ = theme_box;
#line 129 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
#line 130 "../src/Widgets/SettingsPopover.vala"
	_tmp64_ = box;
#line 130 "../src/Widgets/SettingsPopover.vala"
	_tmp65_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 130 "../src/Widgets/SettingsPopover.vala"
	g_object_ref_sink (_tmp65_);
#line 130 "../src/Widgets/SettingsPopover.vala"
	_tmp66_ = _tmp65_;
#line 130 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp66_);
#line 130 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (_tmp66_);
#line 131 "../src/Widgets/SettingsPopover.vala"
	_tmp67_ = box;
#line 131 "../src/Widgets/SettingsPopover.vala"
	_tmp68_ = natural_copy_paste_button;
#line 131 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 132 "../src/Widgets/SettingsPopover.vala"
	_tmp69_ = box;
#line 132 "../src/Widgets/SettingsPopover.vala"
	_tmp70_ = audible_bell_button;
#line 132 "../src/Widgets/SettingsPopover.vala"
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp70_);
#line 133 "../src/Widgets/SettingsPopover.vala"
	_tmp71_ = box;
#line 133 "../src/Widgets/SettingsPopover.vala"
	g_object_set ((GtkContainer*) self, "child", (GtkWidget*) _tmp71_, NULL);
#line 135 "../src/Widgets/SettingsPopover.vala"
	_tmp72_ = _data2_->custom_button;
#line 135 "../src/Widgets/SettingsPopover.vala"
	g_signal_connect_data ((GtkButton*) _tmp72_, "clicked", (GCallback) __terminal_settings_popover___lambda19__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 142 "../src/Widgets/SettingsPopover.vala"
	_tmp73_ = g_binding_group_new ();
#line 142 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (self->priv->terminal_binding);
#line 142 "../src/Widgets/SettingsPopover.vala"
	self->priv->terminal_binding = _tmp73_;
#line 143 "../src/Widgets/SettingsPopover.vala"
	_tmp74_ = self->priv->terminal_binding;
#line 143 "../src/Widgets/SettingsPopover.vala"
	_tmp75_ = zoom_default_button;
#line 143 "../src/Widgets/SettingsPopover.vala"
	g_binding_group_bind_with_closures (_tmp74_, "font-scale", (GObject*) _tmp75_, "label", G_BINDING_SYNC_CREATE, (GClosure*) g_cclosure_new ((GCallback) _terminal_settings_popover_font_scale_to_zoom_gbinding_transform_func, NULL, (GClosureNotify) NULL), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 145 "../src/Widgets/SettingsPopover.vala"
	_tmp76_ = follow_system_button;
#line 145 "../src/Widgets/SettingsPopover.vala"
	_tmp77_ = theme_revealer;
#line 145 "../src/Widgets/SettingsPopover.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp76_, "active", (GObject*) _tmp77_, "reveal-child", G_BINDING_SYNC_CREATE | G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 147 "../src/Widgets/SettingsPopover.vala"
	_tmp78_ = terminal_application_settings;
#line 147 "../src/Widgets/SettingsPopover.vala"
	_tmp79_ = follow_system_button;
#line 147 "../src/Widgets/SettingsPopover.vala"
	g_settings_bind (_tmp78_, "follow-system-style", (GObject*) _tmp79_, "active", G_SETTINGS_BIND_DEFAULT);
#line 148 "../src/Widgets/SettingsPopover.vala"
	_tmp80_ = terminal_application_settings;
#line 148 "../src/Widgets/SettingsPopover.vala"
	_tmp81_ = natural_copy_paste_button;
#line 148 "../src/Widgets/SettingsPopover.vala"
	g_settings_bind (_tmp80_, "natural-copy-paste", (GObject*) _tmp81_, "active", G_SETTINGS_BIND_DEFAULT);
#line 149 "../src/Widgets/SettingsPopover.vala"
	_tmp82_ = terminal_application_settings;
#line 149 "../src/Widgets/SettingsPopover.vala"
	_tmp83_ = audible_bell_button;
#line 149 "../src/Widgets/SettingsPopover.vala"
	g_settings_bind (_tmp82_, "audible-bell", (GObject*) _tmp83_, "active", G_SETTINGS_BIND_DEFAULT);
#line 151 "../src/Widgets/SettingsPopover.vala"
	_tmp84_ = terminal_application_settings;
#line 151 "../src/Widgets/SettingsPopover.vala"
	g_signal_connect_data (_tmp84_, "changed", (GCallback) __terminal_settings_popover___lambda20__g_settings_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 159 "../src/Widgets/SettingsPopover.vala"
	_tmp85_ = gtk_bin_get_child ((GtkBin*) self);
#line 159 "../src/Widgets/SettingsPopover.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) _gtk_widget_show_all_gtk_widget_show, _tmp85_, 0);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (box);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (audible_bell_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (natural_copy_paste_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (light_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (hc_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (theme_box);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (follow_system_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (theme_revealer);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (font_size_box);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (zoom_in_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (zoom_default_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (zoom_out_button);
#line 36 "../src/Widgets/SettingsPopover.vala"
	block2_data_unref (_data2_);
#line 36 "../src/Widgets/SettingsPopover.vala"
	_data2_ = NULL;
#line 36 "../src/Widgets/SettingsPopover.vala"
	return obj;
#line 1246 "SettingsPopover.c"
}

static void
terminal_settings_popover_class_init (TerminalSettingsPopoverClass * klass,
                                      gpointer klass_data)
{
#line 6 "../src/Widgets/SettingsPopover.vala"
	terminal_settings_popover_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Widgets/SettingsPopover.vala"
	g_type_class_adjust_private_offset (klass, &TerminalSettingsPopover_private_offset);
#line 6 "../src/Widgets/SettingsPopover.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_settings_popover_get_property;
#line 6 "../src/Widgets/SettingsPopover.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_settings_popover_set_property;
#line 6 "../src/Widgets/SettingsPopover.vala"
	G_OBJECT_CLASS (klass)->constructor = terminal_settings_popover_constructor;
#line 6 "../src/Widgets/SettingsPopover.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_settings_popover_finalize;
#line 6 "../src/Widgets/SettingsPopover.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SETTINGS_POPOVER_TERMINAL_PROPERTY, terminal_settings_popover_properties[TERMINAL_SETTINGS_POPOVER_TERMINAL_PROPERTY] = g_param_spec_object ("terminal", "terminal", "terminal", vte_terminal_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6 "../src/Widgets/SettingsPopover.vala"
	terminal_settings_popover_signals[TERMINAL_SETTINGS_POPOVER_SHOW_THEME_EDITOR_SIGNAL] = g_signal_new ("show-theme-editor", TERMINAL_TYPE_SETTINGS_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1269 "SettingsPopover.c"
}

static void
terminal_settings_popover_instance_init (TerminalSettingsPopover * self,
                                         gpointer klass)
{
#line 6 "../src/Widgets/SettingsPopover.vala"
	self->priv = terminal_settings_popover_get_instance_private (self);
#line 1278 "SettingsPopover.c"
}

static void
terminal_settings_popover_finalize (GObject * obj)
{
	TerminalSettingsPopover * self;
#line 6 "../src/Widgets/SettingsPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopover);
#line 29 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (self->priv->terminal_binding);
#line 30 "../src/Widgets/SettingsPopover.vala"
	_g_object_unref0 (self->priv->theme_buttons);
#line 6 "../src/Widgets/SettingsPopover.vala"
	G_OBJECT_CLASS (terminal_settings_popover_parent_class)->finalize (obj);
#line 1293 "SettingsPopover.c"
}

static GType
terminal_settings_popover_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalSettingsPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_settings_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalSettingsPopover), 0, (GInstanceInitFunc) terminal_settings_popover_instance_init, NULL };
	GType terminal_settings_popover_type_id;
	terminal_settings_popover_type_id = g_type_register_static (gtk_popover_get_type (), "TerminalSettingsPopover", &g_define_type_info, 0);
	TerminalSettingsPopover_private_offset = g_type_add_instance_private (terminal_settings_popover_type_id, sizeof (TerminalSettingsPopoverPrivate));
	return terminal_settings_popover_type_id;
}

GType
terminal_settings_popover_get_type (void)
{
	static volatile gsize terminal_settings_popover_type_id__once = 0;
	if (g_once_init_enter (&terminal_settings_popover_type_id__once)) {
		GType terminal_settings_popover_type_id;
		terminal_settings_popover_type_id = terminal_settings_popover_get_type_once ();
		g_once_init_leave (&terminal_settings_popover_type_id__once, terminal_settings_popover_type_id);
	}
	return terminal_settings_popover_type_id__once;
}

static void
_vala_terminal_settings_popover_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	TerminalSettingsPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopover);
#line 6 "../src/Widgets/SettingsPopover.vala"
	switch (property_id) {
#line 6 "../src/Widgets/SettingsPopover.vala"
		case TERMINAL_SETTINGS_POPOVER_TERMINAL_PROPERTY:
#line 6 "../src/Widgets/SettingsPopover.vala"
		g_value_take_object (value, terminal_settings_popover_get_terminal (self));
#line 6 "../src/Widgets/SettingsPopover.vala"
		break;
#line 1334 "SettingsPopover.c"
		default:
#line 6 "../src/Widgets/SettingsPopover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/SettingsPopover.vala"
		break;
#line 1340 "SettingsPopover.c"
	}
}

static void
_vala_terminal_settings_popover_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	TerminalSettingsPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_SETTINGS_POPOVER, TerminalSettingsPopover);
#line 6 "../src/Widgets/SettingsPopover.vala"
	switch (property_id) {
#line 6 "../src/Widgets/SettingsPopover.vala"
		case TERMINAL_SETTINGS_POPOVER_TERMINAL_PROPERTY:
#line 6 "../src/Widgets/SettingsPopover.vala"
		terminal_settings_popover_set_terminal (self, g_value_get_object (value));
#line 6 "../src/Widgets/SettingsPopover.vala"
		break;
#line 1360 "SettingsPopover.c"
		default:
#line 6 "../src/Widgets/SettingsPopover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/SettingsPopover.vala"
		break;
#line 1366 "SettingsPopover.c"
	}
}

