/* TerminalWidget.c generated by valac 0.56.17, the Vala compiler
 * generated from TerminalWidget.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2011-2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3, as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <vte/vte.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <handy.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <sys/wait.h>
#include <poll.h>
#include <pcre2.h>
#include <glib/gstdio.h>

#define TERMINAL_TERMINAL_WIDGET_DEFAULT_LABEL _ ("Terminal")
#define TERMINAL_TERMINAL_WIDGET_ACTION_COPY "term.copy"
#define TERMINAL_TERMINAL_WIDGET_ACTION_COPY_OUTPUT "term.copy-output"
#define TERMINAL_TERMINAL_WIDGET_ACTION_PASTE "term.paste"
#define TERMINAL_TERMINAL_WIDGET_ACTION_RELOAD "term.reload"
#define TERMINAL_TERMINAL_WIDGET_ACTION_SCROLL_TO_COMMAND "term.scroll-to-command"
#define TERMINAL_TERMINAL_WIDGET_ACTION_SELECT_ALL "term.select-all"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_DEFAULT "term.zoom::default"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_IN "term.zoom::in"
#define TERMINAL_TERMINAL_WIDGET_ACTION_ZOOM_OUT "term.zoom::out"
#define TERMINAL_TERMINAL_WIDGET_SEND_PROCESS_FINISHED_BASH "dbus-send --type=method_call " "--session --dest=io.elementary.terminal " "/io/elementary/terminal " "io.elementary.terminal.ProcessFinished " "string:$PANTHEON_TERMINAL_ID " "string:\"$(fc -nl -1 | cut -c 3-)\" " "int32:\$__bp_last_ret_value >/dev/null 2>&1"
#define TERMINAL_TERMINAL_WIDGET_USERCHARS "-[:alnum:]"
#define TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "[" TERMINAL_TERMINAL_WIDGET_USERCHARS "]"
#define TERMINAL_TERMINAL_WIDGET_PASSCHARS_CLASS "[-[:alnum:]\\Q,?;.:/!%$^*&~\"#'\\E]"
#define TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "[-[:alnum:]]"
#define TERMINAL_TERMINAL_WIDGET_HOST TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "+(\\." TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "+)*"
#define TERMINAL_TERMINAL_WIDGET_PORT "(?:\\:[[:digit:]]{1,5})?"
#define TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "[-[:alnum:]\\Q_$.+!*,;:@&=?/~#%\\E]"
#define TERMINAL_TERMINAL_WIDGET_PATHTERM_CLASS "[^\\Q]'.}>) \t\r\n,\"\\E]"
#define TERMINAL_TERMINAL_WIDGET_SCHEME "(?:news:|telnet:|nntp:|file:\\/|https?:|ftps?:|sftp:|webcal:" "|irc:|sftp:|ldaps?:|nfs:|smb:|rsync:|ssh:|rlogin:|telnet:|git:" "|git\\+ssh:|bzr:|bzr\\+ssh:|svn:|svn\\+ssh:|hg:|mailto:|magnet:)"
#define TERMINAL_TERMINAL_WIDGET_USERPASS TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "+(?:" TERMINAL_TERMINAL_WIDGET_PASSCHARS_CLASS "+)?"
#define TERMINAL_TERMINAL_WIDGET_URLPATH "(?:(/" TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "+(?:[(]" TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "*[)])*" TERMINAL_TERMINAL_WIDGET_PATHCHARS_CLASS "*)*" TERMINAL_TERMINAL_WIDGET_PATHTERM_CLASS ")?"
#define TERMINAL_TERMINAL_WIDGET_MIN_SCALE 0.25
#define TERMINAL_TERMINAL_WIDGET_MAX_SCALE 4.0
#define TERMINAL_TERMINAL_WIDGET_SYS_PIDFD_OPEN 434
#define TERMINAL_MAIN_WINDOW_ACTION_OPEN_IN_BROWSER "action-open-in-browser"
#define TERMINAL_THEMES_PALETTE_SIZE 19
#define TERMINAL_THEMES_DARK "dark"
#define TERMINAL_THEMES_LIGHT "solarized-light"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gboolean (*_LocalFunc0_) (guint keyval, guint code, gpointer user_data);

#define TERMINAL_TYPE_TERMINAL_WIDGET (terminal_terminal_widget_get_type ())
#define TERMINAL_TERMINAL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget))
#define TERMINAL_TERMINAL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidgetClass))
#define TERMINAL_IS_TERMINAL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL_WIDGET))
#define TERMINAL_IS_TERMINAL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL_WIDGET))
#define TERMINAL_TERMINAL_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidgetClass))

typedef struct _TerminalTerminalWidget TerminalTerminalWidget;
typedef struct _TerminalTerminalWidgetClass TerminalTerminalWidgetClass;
typedef struct _TerminalTerminalWidgetPrivate TerminalTerminalWidgetPrivate;

#define TERMINAL_TYPE_APPLICATION (terminal_application_get_type ())
#define TERMINAL_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplication))
#define TERMINAL_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))
#define TERMINAL_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))

typedef struct _TerminalApplication TerminalApplication;
typedef struct _TerminalApplicationClass TerminalApplicationClass;

#define TERMINAL_TYPE_MAIN_WINDOW (terminal_main_window_get_type ())
#define TERMINAL_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindow))
#define TERMINAL_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindowClass))
#define TERMINAL_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_MAIN_WINDOW))
#define TERMINAL_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_MAIN_WINDOW))
#define TERMINAL_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindowClass))

typedef struct _TerminalMainWindow TerminalMainWindow;
typedef struct _TerminalMainWindowClass TerminalMainWindowClass;
enum  {
	TERMINAL_TERMINAL_WIDGET_0_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_WINDOW_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY,
	TERMINAL_TERMINAL_WIDGET_NUM_PROPERTIES
};
static GParamSpec* terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_NUM_PROPERTIES];
typedef enum  {
	TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST,
	TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING,
	TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT
} TerminalTerminalWidgetDropTargets;

#define TERMINAL_TERMINAL_WIDGET_TYPE_DROP_TARGETS (terminal_terminal_widget_drop_targets_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;
typedef struct _TerminalMainWindowPrivate TerminalMainWindowPrivate;

#define TERMINAL_TYPE_UNSAFE_PASTE_DIALOG (terminal_unsafe_paste_dialog_get_type ())
#define TERMINAL_UNSAFE_PASTE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG, TerminalUnsafePasteDialog))
#define TERMINAL_UNSAFE_PASTE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG, TerminalUnsafePasteDialogClass))
#define TERMINAL_IS_UNSAFE_PASTE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG))
#define TERMINAL_IS_UNSAFE_PASTE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG))
#define TERMINAL_UNSAFE_PASTE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_UNSAFE_PASTE_DIALOG, TerminalUnsafePasteDialogClass))

typedef struct _TerminalUnsafePasteDialog TerminalUnsafePasteDialog;
typedef struct _TerminalUnsafePasteDialogClass TerminalUnsafePasteDialogClass;
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vte_regex_unref0(var) ((var == NULL) ? NULL : (var = (vte_regex_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

#define TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG (terminal_foreground_process_dialog_get_type ())
#define TERMINAL_FOREGROUND_PROCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG, TerminalForegroundProcessDialog))
#define TERMINAL_FOREGROUND_PROCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG, TerminalForegroundProcessDialogClass))
#define TERMINAL_IS_FOREGROUND_PROCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG))
#define TERMINAL_IS_FOREGROUND_PROCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG))
#define TERMINAL_FOREGROUND_PROCESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_FOREGROUND_PROCESS_DIALOG, TerminalForegroundProcessDialogClass))

typedef struct _TerminalForegroundProcessDialog TerminalForegroundProcessDialog;
typedef struct _TerminalForegroundProcessDialogClass TerminalForegroundProcessDialogClass;
typedef struct _Block6Data Block6Data;
enum  {
	TERMINAL_TERMINAL_WIDGET_CWD_CHANGED_SIGNAL,
	TERMINAL_TERMINAL_WIDGET_NUM_SIGNALS
};
static guint terminal_terminal_widget_signals[TERMINAL_TERMINAL_WIDGET_NUM_SIGNALS] = {0};

struct _TerminalTerminalWidget {
	VteTerminal parent_instance;
	TerminalTerminalWidgetPrivate * priv;
	TerminalApplication* app;
	gchar* terminal_id;
	GraniteWidgetsTab* tab;
	gchar* link_uri;
	gint default_size;
	gboolean last_key_was_return;
};

struct _TerminalTerminalWidgetClass {
	VteTerminalClass parent_class;
};

struct _TerminalTerminalWidgetPrivate {
	gchar* _current_working_directory;
	gboolean init_complete;
	gboolean _resized;
	GPid child_pid;
	TerminalMainWindow* _window;
	GtkMenu* menu;
	gchar* _tab_label;
	gboolean _child_has_exited;
	gboolean _killed;
	GtkClipboard* clipboard;
	GSimpleAction* copy_action;
	GSimpleAction* copy_output_action;
	GSimpleAction* paste_action;
	GSimpleAction* scroll_to_command_action;
	glong remembered_position;
	glong remembered_command_start_row;
	glong remembered_command_end_row;
	GtkEventControllerMotion* motion_controller;
	GtkEventControllerScroll* scroll_controller;
	GtkEventControllerKey* key_controller;
	GtkGestureMultiPress* press_gesture;
	gboolean modifier_pressed;
	gdouble scroll_delta;
};

struct _Block3Data {
	int _ref_count_;
	TerminalTerminalWidget* self;
	gulong once;
};

struct _TerminalMainWindow {
	HdyWindow parent_instance;
	TerminalMainWindowPrivate * priv;
	gboolean unsafe_ignored;
	GList* terminals;
};

struct _TerminalMainWindowClass {
	HdyWindowClass parent_class;
};

struct _Block4Data {
	int _ref_count_;
	TerminalTerminalWidget* self;
	TerminalUnsafePasteDialog* dialog;
};

struct _Block5Data {
	int _ref_count_;
	TerminalTerminalWidget* self;
	gchar* old_loc;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	TerminalForegroundProcessDialog* dialog;
};

static gint TerminalTerminalWidget_private_offset;
static gpointer terminal_terminal_widget_parent_class = NULL;
static gint terminal_terminal_widget_terminal_id_counter;
static gint terminal_terminal_widget_terminal_id_counter = 0;
VALA_EXTERN GSettings* terminal_application_settings;

VALA_EXTERN GType terminal_terminal_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminalWidget, g_object_unref)
VALA_EXTERN GType terminal_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalApplication, g_object_unref)
VALA_EXTERN GType terminal_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalMainWindow, g_object_unref)
static GType terminal_terminal_widget_drop_targets_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN TerminalTerminalWidget* terminal_terminal_widget_new (TerminalMainWindow* parent_window);
VALA_EXTERN TerminalTerminalWidget* terminal_terminal_widget_construct (GType object_type,
                                                            TerminalMainWindow* parent_window);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN void terminal_terminal_widget_set_window (TerminalTerminalWidget* self,
                                          TerminalMainWindow* value);
static void terminal_terminal_widget_set_child_has_exited (TerminalTerminalWidget* self,
                                                    gboolean value);
static void terminal_terminal_widget_set_killed (TerminalTerminalWidget* self,
                                          gboolean value);
static void terminal_terminal_widget_update_audible_bell (TerminalTerminalWidget* self);
static void terminal_terminal_widget_update_cursor_shape (TerminalTerminalWidget* self);
static void terminal_terminal_widget_update_theme (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_update_theme_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _terminal_terminal_widget_update_audible_bell_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _terminal_terminal_widget_update_theme_g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void _terminal_terminal_widget_update_cursor_shape_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void terminal_terminal_widget_pointer_focus (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_pointer_focus_gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                                                gdouble x,
                                                                                gdouble y,
                                                                                gpointer self);
static void terminal_terminal_widget_scroll (TerminalTerminalWidget* self,
                                      gdouble x,
                                      gdouble y);
static void _terminal_terminal_widget_scroll_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                          gdouble dx,
                                                                          gdouble dy,
                                                                          gpointer self);
static void __lambda29_ (TerminalTerminalWidget* self);
static void ___lambda29__gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                          gpointer self);
static gboolean terminal_terminal_widget_key_pressed (TerminalTerminalWidget* self,
                                               guint keyval,
                                               guint keycode,
                                               GdkModifierType modifiers);
static gboolean _terminal_terminal_widget_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                     guint keyval,
                                                                                     guint keycode,
                                                                                     GdkModifierType state,
                                                                                     gpointer self);
static void __lambda34_ (TerminalTerminalWidget* self);
static void ___lambda34__gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                         guint keyval,
                                                         guint keycode,
                                                         GdkModifierType state,
                                                         gpointer self);
static void __lambda35_ (TerminalTerminalWidget* self);
static void ___lambda35__gtk_event_controller_key_focus_out (GtkEventControllerKey* _sender,
                                                      gpointer self);
static gboolean __lambda36_ (TerminalTerminalWidget* self);
static gboolean ___lambda36__gtk_event_controller_key_modifiers (GtkEventControllerKey* _sender,
                                                          GdkModifierType object,
                                                          gpointer self);
static void terminal_terminal_widget_button_pressed (TerminalTerminalWidget* self,
                                              GtkGestureMultiPress* gesture,
                                              gint n_press,
                                              gdouble x,
                                              gdouble y);
static void _terminal_terminal_widget_button_pressed_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                               gint n_press,
                                                                               gdouble x,
                                                                               gdouble y,
                                                                               gpointer self);
static void terminal_terminal_widget_button_released (TerminalTerminalWidget* self,
                                               GtkGestureMultiPress* gesture,
                                               gint n_press,
                                               gdouble x,
                                               gdouble y);
static void _terminal_terminal_widget_button_released_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                 gint n_press,
                                                                                 gdouble x,
                                                                                 gdouble y,
                                                                                 gpointer self);
static gboolean _gtk_event_controller_handle_event_gtk_widget_event (GtkWidget* _sender,
                                                              GdkEvent* event,
                                                              gpointer self);
static void __lambda37_ (TerminalTerminalWidget* self);
static void ___lambda37__vte_terminal_selection_changed (VteTerminal* _sender,
                                                  gpointer self);
static void __lambda38_ (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_set_resized (TerminalTerminalWidget* self,
                                           gboolean value);
static void ___lambda38__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void terminal_terminal_widget_check_cwd_changed (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_check_cwd_changed_vte_terminal_contents_changed (VteTerminal* _sender,
                                                                                gpointer self);
static void terminal_terminal_widget_on_child_exited (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                          gint status,
                                                                          gpointer self);
static void __lambda39_ (Block3Data* _data3_);
static void terminal_terminal_widget_setup_menu (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_setup_menu_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                      GdkEventOwnerChange* event,
                                                                      gpointer self);
static void ___lambda39__gtk_widget_realize (GtkWidget* _sender,
                                      gpointer self);
static void _vala_array_add1 (GtkTargetEntry* * array,
                       gint* length,
                       gint* size,
                       const GtkTargetEntry* value);
static void _vala_array_add2 (GtkTargetEntry* * array,
                       gint* length,
                       gint* size,
                       const GtkTargetEntry* value);
static void _vala_array_add3 (GtkTargetEntry* * array,
                       gint* length,
                       gint* size,
                       const GtkTargetEntry* value);
VALA_EXTERN void terminal_terminal_widget_drag_received (TerminalTerminalWidget* self,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             GtkSelectionData* selection_data,
                                             guint target_type,
                                             guint time_);
static void _terminal_terminal_widget_drag_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                            GdkDragContext* context,
                                                                            gint x,
                                                                            gint y,
                                                                            GtkSelectionData* selection_data,
                                                                            guint info,
                                                                            guint time_,
                                                                            gpointer self);
static void terminal_terminal_widget_clickable (TerminalTerminalWidget* self,
                                         gchar** str,
                                         gint str_length1);
static void __lambda40_ (TerminalTerminalWidget* self);
static void ___lambda40__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static void terminal_terminal_widget_copy_output (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_copy_output_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void __lambda41_ (TerminalTerminalWidget* self);
static void ___lambda41__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
VALA_EXTERN void terminal_terminal_widget_reload (TerminalTerminalWidget* self);
static void _terminal_terminal_widget_reload_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self);
static void terminal_terminal_widget_scroll_to_command (TerminalTerminalWidget* self,
                                                 GSimpleAction* action,
                                                 GVariant* parameter);
static void _terminal_terminal_widget_scroll_to_command_g_simple_action_activate (GSimpleAction* _sender,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void _vte_terminal_select_all_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self);
static void __lambda42_ (TerminalTerminalWidget* self,
                  GVariant* p);
static gchar* _variant_get1 (GVariant* value);
static void ___lambda42__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static gchar* terminal_terminal_widget_get_link (TerminalTerminalWidget* self,
                                          GdkEvent* event);
VALA_EXTERN TerminalMainWindow* terminal_terminal_widget_get_window (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_main_window_update_context_menu (TerminalMainWindow* self);
VALA_EXTERN GSimpleAction* terminal_main_window_get_simple_action (TerminalMainWindow* self,
                                                       const gchar* action);
VALA_EXTERN void terminal_terminal_widget_remember_position (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_remember_command_end_position (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_remember_command_start_position (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_get_resized (TerminalTerminalWidget* self);
VALA_EXTERN gchar* terminal_terminal_widget_get_last_output (TerminalTerminalWidget* self,
                                                 gboolean include_command);
static gboolean __lambda31_ (TerminalTerminalWidget* self,
                      guint keyval,
                      guint code);
static gboolean ___lambda31___localfunc0_ (guint keyval,
                                    guint code,
                                    gpointer self);
static void __lambda30_ (TerminalTerminalWidget* self,
                  GtkClipboard* clipboard,
                  GdkAtom* atoms,
                  gint atoms_length1);
static void ___lambda30__gtk_clipboard_targets_received_func (GtkClipboard* clipboard,
                                                       GdkAtom* atoms,
                                                       gint n_atoms,
                                                       gpointer self);
static void terminal_terminal_widget_real_copy_clipboard (VteTerminal* base);
static void terminal_terminal_widget_real_paste_clipboard (VteTerminal* base);
static void __lambda32_ (TerminalTerminalWidget* self,
                  GtkClipboard* clipboard,
                  const gchar* text);
VALA_EXTERN GType terminal_unsafe_paste_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalUnsafePasteDialog, g_object_unref)
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN TerminalUnsafePasteDialog* terminal_unsafe_paste_dialog_new (TerminalMainWindow* parent,
                                                             const gchar* title_text,
                                                             const gchar* text_to_paste);
VALA_EXTERN TerminalUnsafePasteDialog* terminal_unsafe_paste_dialog_construct (GType object_type,
                                                                   TerminalMainWindow* parent,
                                                                   const gchar* title_text,
                                                                   const gchar* text_to_paste);
static void ____lambda33_ (Block4Data* _data4_,
                    gint res);
static void _____lambda33__gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self);
static void ___lambda32__gtk_clipboard_text_received_func (GtkClipboard* clipboard,
                                                    const gchar* text,
                                                    gpointer self);
VALA_EXTERN GdkRGBA* terminal_themes_get_rgba_palette (const gchar* theme,
                                           gint* result_length1);
static GdkRGBA* _vala_array_dup1 (GdkRGBA* self,
                           gssize length);
VALA_EXTERN void terminal_terminal_widget_kill_fg (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_try_get_foreground_pid (TerminalTerminalWidget* self,
                                                          gint* pid);
VALA_EXTERN void terminal_terminal_widget_term_ps (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_active_shell (TerminalTerminalWidget* self,
                                            const gchar* dir);
VALA_EXTERN void terminal_terminal_widget_run_program (TerminalTerminalWidget* self,
                                           const gchar* program_string,
                                           const gchar* working_directory);
VALA_EXTERN gboolean terminal_terminal_widget_get_child_has_exited (TerminalTerminalWidget* self);
VALA_EXTERN gboolean terminal_terminal_widget_has_foreground_process (TerminalTerminalWidget* self);
VALA_EXTERN gint terminal_terminal_widget_calculate_width (TerminalTerminalWidget* self,
                                               gint column_count);
VALA_EXTERN gint terminal_terminal_widget_calculate_height (TerminalTerminalWidget* self,
                                                gint row_count);
VALA_EXTERN gchar* terminal_terminal_widget_get_shell_location (TerminalTerminalWidget* self);
static void terminal_terminal_widget_real_increase_font_size (VteTerminal* base);
static void terminal_terminal_widget_real_decrease_font_size (VteTerminal* base);
VALA_EXTERN gboolean terminal_terminal_widget_is_init_complete (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_set_init_complete (TerminalTerminalWidget* self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN GType terminal_foreground_process_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalForegroundProcessDialog, g_object_unref)
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN TerminalForegroundProcessDialog* terminal_foreground_process_dialog_new_before_tab_reload (TerminalMainWindow* parent);
VALA_EXTERN TerminalForegroundProcessDialog* terminal_foreground_process_dialog_construct_before_tab_reload (GType object_type,
                                                                                                 TerminalMainWindow* parent);
static void ___lambda12_ (Block6Data* _data6_,
                   gint res);
static void ____lambda12__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
VALA_EXTERN const gchar* terminal_terminal_widget_get_current_working_directory (TerminalTerminalWidget* self);
static void terminal_terminal_widget_set_current_working_directory (TerminalTerminalWidget* self,
                                                             const gchar* value);
VALA_EXTERN TerminalApplication* terminal_main_window_get_app (TerminalMainWindow* self);
VALA_EXTERN GtkMenu* terminal_main_window_get_menu (TerminalMainWindow* self);
VALA_EXTERN const gchar* terminal_terminal_widget_get_tab_label (TerminalTerminalWidget* self);
VALA_EXTERN void terminal_terminal_widget_set_tab_label (TerminalTerminalWidget* self,
                                             const gchar* value);
VALA_EXTERN gboolean terminal_terminal_widget_get_killed (TerminalTerminalWidget* self);
static void terminal_terminal_widget_finalize (GObject * obj);
static GType terminal_terminal_widget_get_type_once (void);
static void _vala_terminal_terminal_widget_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_terminal_terminal_widget_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_COPY[2] = {"<Control><Shift>C", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_COPY_OUTPUT[2] = {"<Alt>C", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_PASTE[2] = {"<Control><Shift>V", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_RELOAD[3] = {"<Control><Shift>R", "<Ctrl>F5", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_SCROLL_TO_COMMAND[2] = {"<Alt>Up", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_SELECT_ALL[2] = {"<Control><Shift>A", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_DEFAULT[3] = {"<control>0", "<Control>KP_0", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_IN[4] = {"<Control>plus", "<Control>equal", "<Control>KP_Add", NULL};
const gchar* TERMINAL_TERMINAL_WIDGET_ACCELS_ZOOM_OUT[3] = {"<Control>minus", "<Control>KP_Subtract", NULL};
static const gchar* TERMINAL_TERMINAL_WIDGET_REGEX_STRINGS[5] = {TERMINAL_TERMINAL_WIDGET_SCHEME "//(?:" TERMINAL_TERMINAL_WIDGET_USERPASS "\\@)?" TERMINAL_TERMINAL_WIDGET_HOST TERMINAL_TERMINAL_WIDGET_PORT TERMINAL_TERMINAL_WIDGET_URLPATH, "(?:www|ftp)" TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "*\\." TERMINAL_TERMINAL_WIDGET_HOST TERMINAL_TERMINAL_WIDGET_PORT TERMINAL_TERMINAL_WIDGET_URLPATH, "(?:callto:|h323:|sip:)" TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "[" TERMINAL_TERMINAL_WIDGET_USERCHARS ".]*(?:" TERMINAL_TERMINAL_WIDGET_PORT "/[a-z0-9]+)?\\@" TERMINAL_TERMINAL_WIDGET_HOST, "(?:mailto:)?" TERMINAL_TERMINAL_WIDGET_USERCHARS_CLASS "[" TERMINAL_TERMINAL_WIDGET_USERCHARS ".]*\\@" TERMINAL_TERMINAL_WIDGET_HOSTCHARS_CLASS "+\\." TERMINAL_TERMINAL_WIDGET_HOST, "(?:news:|man:|info:)[[:alnum:]\\Q^_{|}~!\"#$%&'()*+,./;:=?`\\E]+"};

static inline gpointer
terminal_terminal_widget_get_instance_private (TerminalTerminalWidget* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalTerminalWidget_private_offset);
}

static GType
terminal_terminal_widget_drop_targets_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST, "TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST", "urilist"}, {TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING, "TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING", "string"}, {TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT, "TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT", "text"}, {0, NULL, NULL}};
	GType terminal_terminal_widget_drop_targets_type_id;
	terminal_terminal_widget_drop_targets_type_id = g_enum_register_static ("TerminalTerminalWidgetDropTargets", values);
	return terminal_terminal_widget_drop_targets_type_id;
}

static GType
terminal_terminal_widget_drop_targets_get_type (void)
{
	static volatile gsize terminal_terminal_widget_drop_targets_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_widget_drop_targets_type_id__once)) {
		GType terminal_terminal_widget_drop_targets_type_id;
		terminal_terminal_widget_drop_targets_type_id = terminal_terminal_widget_drop_targets_get_type_once ();
		g_once_init_leave (&terminal_terminal_widget_drop_targets_type_id__once, terminal_terminal_widget_drop_targets_type_id);
	}
	return terminal_terminal_widget_drop_targets_type_id__once;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 164 "../src/Widgets/TerminalWidget.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 164 "../src/Widgets/TerminalWidget.vala"
	return _data3_;
#line 599 "TerminalWidget.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 164 "../src/Widgets/TerminalWidget.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 609 "TerminalWidget.c"
		TerminalTerminalWidget* self;
#line 164 "../src/Widgets/TerminalWidget.vala"
		self = _data3_->self;
#line 164 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (self);
#line 164 "../src/Widgets/TerminalWidget.vala"
		g_slice_free (Block3Data, _data3_);
#line 617 "TerminalWidget.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 179 "../src/Widgets/TerminalWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 626 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_theme_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 180 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_theme ((TerminalTerminalWidget*) self);
#line 636 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_audible_bell_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 181 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_audible_bell ((TerminalTerminalWidget*) self);
#line 646 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_theme_g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 182 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_theme ((TerminalTerminalWidget*) self);
#line 656 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_update_cursor_shape_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 184 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_cursor_shape ((TerminalTerminalWidget*) self);
#line 666 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_pointer_focus_gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                                           gdouble x,
                                                                           gdouble y,
                                                                           gpointer self)
{
#line 194 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_pointer_focus ((TerminalTerminalWidget*) self);
#line 677 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_scroll_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                     gdouble dx,
                                                                     gdouble dy,
                                                                     gpointer self)
{
#line 199 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_scroll ((TerminalTerminalWidget*) self, dx, dy);
#line 688 "TerminalWidget.c"
}

static void
__lambda29_ (TerminalTerminalWidget* self)
{
#line 200 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_delta = 0.0;
#line 696 "TerminalWidget.c"
}

static void
___lambda29__gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                     gpointer self)
{
#line 200 "../src/Widgets/TerminalWidget.vala"
	__lambda29_ ((TerminalTerminalWidget*) self);
#line 705 "TerminalWidget.c"
}

static gboolean
_terminal_terminal_widget_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self)
{
	gboolean result;
	result = terminal_terminal_widget_key_pressed ((TerminalTerminalWidget*) self, keyval, keycode, state);
#line 205 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 719 "TerminalWidget.c"
}

static void
__lambda34_ (TerminalTerminalWidget* self)
{
	GtkEventControllerScroll* _tmp0_;
#line 206 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->scroll_controller;
#line 206 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 730 "TerminalWidget.c"
}

static void
___lambda34__gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                    guint keyval,
                                                    guint keycode,
                                                    GdkModifierType state,
                                                    gpointer self)
{
#line 206 "../src/Widgets/TerminalWidget.vala"
	__lambda34_ ((TerminalTerminalWidget*) self);
#line 742 "TerminalWidget.c"
}

static void
__lambda35_ (TerminalTerminalWidget* self)
{
	GtkEventControllerScroll* _tmp0_;
#line 207 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->scroll_controller;
#line 207 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 753 "TerminalWidget.c"
}

static void
___lambda35__gtk_event_controller_key_focus_out (GtkEventControllerKey* _sender,
                                                 gpointer self)
{
#line 207 "../src/Widgets/TerminalWidget.vala"
	__lambda35_ ((TerminalTerminalWidget*) self);
#line 762 "TerminalWidget.c"
}

static gboolean
__lambda36_ (TerminalTerminalWidget* self)
{
	gboolean result;
#line 216 "../src/Widgets/TerminalWidget.vala"
	self->priv->modifier_pressed = !self->priv->modifier_pressed;
#line 217 "../src/Widgets/TerminalWidget.vala"
	result = TRUE;
#line 217 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 775 "TerminalWidget.c"
}

static gboolean
___lambda36__gtk_event_controller_key_modifiers (GtkEventControllerKey* _sender,
                                                 GdkModifierType object,
                                                 gpointer self)
{
	gboolean result;
	result = __lambda36_ ((TerminalTerminalWidget*) self);
#line 213 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 787 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_button_pressed_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                          gint n_press,
                                                                          gdouble x,
                                                                          gdouble y,
                                                                          gpointer self)
{
#line 224 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_button_pressed ((TerminalTerminalWidget*) self, _sender, n_press, x, y);
#line 799 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_button_released_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                            gint n_press,
                                                                            gdouble x,
                                                                            gdouble y,
                                                                            gpointer self)
{
#line 225 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_button_released ((TerminalTerminalWidget*) self, _sender, n_press, x, y);
#line 811 "TerminalWidget.c"
}

static gboolean
_gtk_event_controller_handle_event_gtk_widget_event (GtkWidget* _sender,
                                                     GdkEvent* event,
                                                     gpointer self)
{
	gboolean result;
	result = gtk_event_controller_handle_event ((GtkEventController*) self, event);
#line 228 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 823 "TerminalWidget.c"
}

static void
__lambda37_ (TerminalTerminalWidget* self)
{
	GSimpleAction* _tmp0_;
#line 230 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->copy_action;
#line 230 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp0_, vte_terminal_get_has_selection ((VteTerminal*) self));
#line 834 "TerminalWidget.c"
}

static void
___lambda37__vte_terminal_selection_changed (VteTerminal* _sender,
                                             gpointer self)
{
#line 230 "../src/Widgets/TerminalWidget.vala"
	__lambda37_ ((TerminalTerminalWidget*) self);
#line 843 "TerminalWidget.c"
}

static void
__lambda38_ (TerminalTerminalWidget* self)
{
#line 231 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_resized (self, TRUE);
#line 851 "TerminalWidget.c"
}

static void
___lambda38__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 231 "../src/Widgets/TerminalWidget.vala"
	__lambda38_ ((TerminalTerminalWidget*) self);
#line 861 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_check_cwd_changed_vte_terminal_contents_changed (VteTerminal* _sender,
                                                                           gpointer self)
{
#line 232 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_check_cwd_changed ((TerminalTerminalWidget*) self);
#line 870 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                     gint status,
                                                                     gpointer self)
{
#line 233 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_on_child_exited ((TerminalTerminalWidget*) self);
#line 880 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_setup_menu_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                 GdkEventOwnerChange* event,
                                                                 gpointer self)
{
#line 237 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_setup_menu ((TerminalTerminalWidget*) self);
#line 890 "TerminalWidget.c"
}

static void
__lambda39_ (Block3Data* _data3_)
{
	TerminalTerminalWidget* self;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
#line 235 "../src/Widgets/TerminalWidget.vala"
	self = _data3_->self;
#line 236 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_widget_get_clipboard ((GtkWidget*) self, GDK_SELECTION_CLIPBOARD);
#line 236 "../src/Widgets/TerminalWidget.vala"
	self->priv->clipboard = _tmp0_;
#line 237 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->priv->clipboard;
#line 237 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp1_, "owner-change", (GCallback) _terminal_terminal_widget_setup_menu_gtk_clipboard_owner_change, self, 0);
#line 238 "../src/Widgets/TerminalWidget.vala"
	g_signal_handler_disconnect ((GObject*) self, _data3_->once);
#line 911 "TerminalWidget.c"
}

static void
___lambda39__gtk_widget_realize (GtkWidget* _sender,
                                 gpointer self)
{
#line 235 "../src/Widgets/TerminalWidget.vala"
	__lambda39_ (self);
#line 920 "TerminalWidget.c"
}

static void
_vala_array_add1 (GtkTargetEntry* * array,
                  gint* length,
                  gint* size,
                  const GtkTargetEntry* value)
{
#line 247 "../src/Widgets/TerminalWidget.vala"
	if ((*length) == (*size)) {
#line 247 "../src/Widgets/TerminalWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 247 "../src/Widgets/TerminalWidget.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 935 "TerminalWidget.c"
	}
#line 247 "../src/Widgets/TerminalWidget.vala"
	(*array)[(*length)++] = *value;
#line 939 "TerminalWidget.c"
}

static void
_vala_array_add2 (GtkTargetEntry* * array,
                  gint* length,
                  gint* size,
                  const GtkTargetEntry* value)
{
#line 248 "../src/Widgets/TerminalWidget.vala"
	if ((*length) == (*size)) {
#line 248 "../src/Widgets/TerminalWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 248 "../src/Widgets/TerminalWidget.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 954 "TerminalWidget.c"
	}
#line 248 "../src/Widgets/TerminalWidget.vala"
	(*array)[(*length)++] = *value;
#line 958 "TerminalWidget.c"
}

static void
_vala_array_add3 (GtkTargetEntry* * array,
                  gint* length,
                  gint* size,
                  const GtkTargetEntry* value)
{
#line 249 "../src/Widgets/TerminalWidget.vala"
	if ((*length) == (*size)) {
#line 249 "../src/Widgets/TerminalWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 249 "../src/Widgets/TerminalWidget.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 973 "TerminalWidget.c"
	}
#line 249 "../src/Widgets/TerminalWidget.vala"
	(*array)[(*length)++] = *value;
#line 977 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_drag_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       gint x,
                                                                       gint y,
                                                                       GtkSelectionData* selection_data,
                                                                       guint info,
                                                                       guint time_,
                                                                       gpointer self)
{
#line 254 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_drag_received ((TerminalTerminalWidget*) self, context, x, y, selection_data, info, time_);
#line 992 "TerminalWidget.c"
}

static void
__lambda40_ (TerminalTerminalWidget* self)
{
#line 263 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_copy_clipboard ((VteTerminal*) self);
#line 1000 "TerminalWidget.c"
}

static void
___lambda40__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 263 "../src/Widgets/TerminalWidget.vala"
	__lambda40_ ((TerminalTerminalWidget*) self);
#line 1010 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_copy_output_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 268 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_copy_output ((TerminalTerminalWidget*) self);
#line 1020 "TerminalWidget.c"
}

static void
__lambda41_ (TerminalTerminalWidget* self)
{
#line 272 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_paste_clipboard ((VteTerminal*) self);
#line 1028 "TerminalWidget.c"
}

static void
___lambda41__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 272 "../src/Widgets/TerminalWidget.vala"
	__lambda41_ ((TerminalTerminalWidget*) self);
#line 1038 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_reload_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 276 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_reload ((TerminalTerminalWidget*) self);
#line 1048 "TerminalWidget.c"
}

static void
_terminal_terminal_widget_scroll_to_command_g_simple_action_activate (GSimpleAction* _sender,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 281 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_scroll_to_command ((TerminalTerminalWidget*) self, _sender, parameter);
#line 1058 "TerminalWidget.c"
}

static void
_vte_terminal_select_all_g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self)
{
#line 285 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_select_all ((VteTerminal*) self);
#line 1068 "TerminalWidget.c"
}

static gchar*
_variant_get1 (GVariant* value)
{
#line 290 "../src/Widgets/TerminalWidget.vala"
	return g_variant_dup_string (value, NULL);
#line 1076 "TerminalWidget.c"
}

static void
__lambda42_ (TerminalTerminalWidget* self,
             GVariant* p)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 290 "../src/Widgets/TerminalWidget.vala"
	static GQuark _tmp2_label0 = 0;
#line 290 "../src/Widgets/TerminalWidget.vala"
	static GQuark _tmp2_label1 = 0;
#line 290 "../src/Widgets/TerminalWidget.vala"
	static GQuark _tmp2_label2 = 0;
#line 290 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = _variant_get1 (p);
#line 290 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 290 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 290 "../src/Widgets/TerminalWidget.vala"
	g_free (_tmp1_);
#line 290 "../src/Widgets/TerminalWidget.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("in")))) {
#line 290 "../src/Widgets/TerminalWidget.vala"
		switch (0) {
#line 1104 "TerminalWidget.c"
			default:
			{
#line 292 "../src/Widgets/TerminalWidget.vala"
				g_signal_emit_by_name ((VteTerminal*) self, "increase-font-size");
#line 293 "../src/Widgets/TerminalWidget.vala"
				break;
#line 1111 "TerminalWidget.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("out")))) {
#line 290 "../src/Widgets/TerminalWidget.vala"
		switch (0) {
#line 1117 "TerminalWidget.c"
			default:
			{
#line 295 "../src/Widgets/TerminalWidget.vala"
				g_signal_emit_by_name ((VteTerminal*) self, "decrease-font-size");
#line 296 "../src/Widgets/TerminalWidget.vala"
				break;
#line 1124 "TerminalWidget.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("default")))) {
#line 290 "../src/Widgets/TerminalWidget.vala"
		switch (0) {
#line 1130 "TerminalWidget.c"
			default:
			{
#line 298 "../src/Widgets/TerminalWidget.vala"
				vte_terminal_set_font_scale ((VteTerminal*) self, 1.0);
#line 299 "../src/Widgets/TerminalWidget.vala"
				break;
#line 1137 "TerminalWidget.c"
			}
		}
	}
}

static void
___lambda42__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 289 "../src/Widgets/TerminalWidget.vala"
	__lambda42_ ((TerminalTerminalWidget*) self, parameter);
#line 1150 "TerminalWidget.c"
}

TerminalTerminalWidget*
terminal_terminal_widget_construct (GType object_type,
                                    TerminalMainWindow* parent_window)
{
	TerminalTerminalWidget * self = NULL;
	Block3Data* _data3_;
	gint _tmp0_;
	gchar* _tmp1_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp2_;
	GraniteSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GtkEventControllerMotion* _tmp13_ = NULL;
	GtkEventControllerMotion* _tmp14_;
	GtkEventControllerScroll* _tmp15_ = NULL;
	GtkEventControllerScroll* _tmp16_;
	GtkEventControllerScroll* _tmp17_;
	GtkEventControllerKey* _tmp18_ = NULL;
	GtkEventControllerKey* _tmp19_;
	GtkEventControllerKey* _tmp20_;
	GtkEventControllerKey* _tmp21_;
	GtkEventControllerKey* _tmp22_;
	GtkGestureMultiPress* _tmp23_ = NULL;
	GtkGestureMultiPress* _tmp24_;
	GtkGestureMultiPress* _tmp25_;
	GtkEventControllerKey* _tmp26_;
	gulong _tmp27_;
	GtkTargetEntry uri_entry = {0};
	GtkTargetEntry _tmp28_ = {0};
	GtkTargetEntry string_entry = {0};
	GtkTargetEntry _tmp29_ = {0};
	GtkTargetEntry text_entry = {0};
	GtkTargetEntry _tmp30_ = {0};
	GtkTargetEntry* targets = NULL;
	GtkTargetEntry* _tmp31_;
	gint targets_length1;
	gint _targets_size_;
	GtkTargetEntry _tmp32_;
	GtkTargetEntry _tmp33_;
	GtkTargetEntry _tmp34_;
	GtkTargetEntry* _tmp35_;
	gint _tmp35__length1;
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp36_;
	GSimpleAction* _tmp37_;
	GSimpleAction* _tmp38_;
	GSimpleAction* _tmp39_;
	GSimpleAction* _tmp40_;
	GSimpleAction* _tmp41_;
	GSimpleAction* _tmp42_;
	GSimpleAction* _tmp43_;
	GSimpleAction* _tmp44_;
	GSimpleAction* _tmp45_;
	GSimpleAction* _tmp46_;
	GSimpleAction* _tmp47_;
	GSimpleAction* reload_action = NULL;
	GSimpleAction* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
	GSimpleAction* _tmp51_;
	GSimpleAction* _tmp52_;
	GSimpleAction* select_all_action = NULL;
	GSimpleAction* _tmp53_;
	GSimpleAction* zoom_action = NULL;
	const GVariantType* _tmp54_;
	GSimpleAction* _tmp55_;
#line 164 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (parent_window != NULL, NULL);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_data3_->_ref_count_ = 1;
#line 164 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) g_object_new (object_type, NULL);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_data3_->self = g_object_ref (self);
#line 165 "../src/Widgets/TerminalWidget.vala"
	g_object_set ((VteTerminal*) self, "pointer-autohide", TRUE, NULL);
#line 167 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_terminal_id_counter;
#line 167 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_terminal_id_counter = _tmp0_ + 1;
#line 167 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 167 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->terminal_id);
#line 167 "../src/Widgets/TerminalWidget.vala"
	self->terminal_id = _tmp1_;
#line 169 "../src/Widgets/TerminalWidget.vala"
	self->priv->init_complete = FALSE;
#line 171 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_window (self, parent_window);
#line 172 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_child_has_exited (self, FALSE);
#line 173 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_killed (self, FALSE);
#line 175 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_audible_bell (self);
#line 176 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_cursor_shape (self);
#line 177 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_update_theme (self);
#line 179 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = granite_settings_get_default ();
#line 179 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 179 "../src/Widgets/TerminalWidget.vala"
	granite_settings = _tmp3_;
#line 180 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GObject*) granite_settings, "notify::prefers-color-scheme", (GCallback) _terminal_terminal_widget_update_theme_g_object_notify, self, 0);
#line 181 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = terminal_application_settings;
#line 181 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp4_, "changed::audible-bell", (GCallback) _terminal_terminal_widget_update_audible_bell_g_settings_changed, self, 0);
#line 182 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = terminal_application_settings;
#line 182 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp5_, "changed::background", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 183 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = terminal_application_settings;
#line 183 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp6_, "changed::cursor-color", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 184 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = terminal_application_settings;
#line 184 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp7_, "changed::cursor-shape", (GCallback) _terminal_terminal_widget_update_cursor_shape_g_settings_changed, self, 0);
#line 185 "../src/Widgets/TerminalWidget.vala"
	_tmp8_ = terminal_application_settings;
#line 185 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp8_, "changed::follow-system-style", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 186 "../src/Widgets/TerminalWidget.vala"
	_tmp9_ = terminal_application_settings;
#line 186 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp9_, "changed::foreground", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 187 "../src/Widgets/TerminalWidget.vala"
	_tmp10_ = terminal_application_settings;
#line 187 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp10_, "changed::palette", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 188 "../src/Widgets/TerminalWidget.vala"
	_tmp11_ = terminal_application_settings;
#line 188 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp11_, "changed::prefer-dark-style", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 189 "../src/Widgets/TerminalWidget.vala"
	_tmp12_ = terminal_application_settings;
#line 189 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp12_, "changed::theme", (GCallback) _terminal_terminal_widget_update_theme_g_settings_changed, self, 0);
#line 191 "../src/Widgets/TerminalWidget.vala"
	_tmp13_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 191 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp13_, GTK_PHASE_CAPTURE);
#line 191 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 191 "../src/Widgets/TerminalWidget.vala"
	self->priv->motion_controller = _tmp13_;
#line 194 "../src/Widgets/TerminalWidget.vala"
	_tmp14_ = self->priv->motion_controller;
#line 194 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp14_, "enter", (GCallback) _terminal_terminal_widget_pointer_focus_gtk_event_controller_motion_enter, self, 0);
#line 196 "../src/Widgets/TerminalWidget.vala"
	_tmp15_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new ((GtkWidget*) self, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 196 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp15_, GTK_PHASE_TARGET);
#line 196 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 196 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_controller = _tmp15_;
#line 199 "../src/Widgets/TerminalWidget.vala"
	_tmp16_ = self->priv->scroll_controller;
#line 199 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp16_, "scroll", (GCallback) _terminal_terminal_widget_scroll_gtk_event_controller_scroll_scroll, self, 0);
#line 200 "../src/Widgets/TerminalWidget.vala"
	_tmp17_ = self->priv->scroll_controller;
#line 200 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp17_, "scroll-end", (GCallback) ___lambda29__gtk_event_controller_scroll_scroll_end, self, 0);
#line 202 "../src/Widgets/TerminalWidget.vala"
	_tmp18_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 202 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp18_, GTK_PHASE_NONE);
#line 202 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 202 "../src/Widgets/TerminalWidget.vala"
	self->priv->key_controller = _tmp18_;
#line 205 "../src/Widgets/TerminalWidget.vala"
	_tmp19_ = self->priv->key_controller;
#line 205 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp19_, "key-pressed", (GCallback) _terminal_terminal_widget_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 206 "../src/Widgets/TerminalWidget.vala"
	_tmp20_ = self->priv->key_controller;
#line 206 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp20_, "key-released", (GCallback) ___lambda34__gtk_event_controller_key_key_released, self, 0);
#line 207 "../src/Widgets/TerminalWidget.vala"
	_tmp21_ = self->priv->key_controller;
#line 207 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp21_, "focus-out", (GCallback) ___lambda35__gtk_event_controller_key_focus_out, self, 0);
#line 213 "../src/Widgets/TerminalWidget.vala"
	_tmp22_ = self->priv->key_controller;
#line 213 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp22_, "modifiers", (GCallback) ___lambda36__gtk_event_controller_key_modifiers, self, 0);
#line 220 "../src/Widgets/TerminalWidget.vala"
	_tmp23_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 220 "../src/Widgets/TerminalWidget.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp23_, GTK_PHASE_TARGET);
#line 220 "../src/Widgets/TerminalWidget.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp23_, (guint) 0);
#line 220 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 220 "../src/Widgets/TerminalWidget.vala"
	self->priv->press_gesture = _tmp23_;
#line 224 "../src/Widgets/TerminalWidget.vala"
	_tmp24_ = self->priv->press_gesture;
#line 224 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp24_, "pressed", (GCallback) _terminal_terminal_widget_button_pressed_gtk_gesture_multi_press_pressed, self, 0);
#line 225 "../src/Widgets/TerminalWidget.vala"
	_tmp25_ = self->priv->press_gesture;
#line 225 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp25_, "released", (GCallback) _terminal_terminal_widget_button_released_gtk_gesture_multi_press_released, self, 0);
#line 228 "../src/Widgets/TerminalWidget.vala"
	_tmp26_ = self->priv->key_controller;
#line 228 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "event", (GCallback) _gtk_event_controller_handle_event_gtk_widget_event, (GtkEventController*) _tmp26_, 0);
#line 230 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((VteTerminal*) self, "selection-changed", (GCallback) ___lambda37__vte_terminal_selection_changed, self, 0);
#line 231 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda38__gtk_widget_size_allocate, self, 0);
#line 232 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((VteTerminal*) self, "contents-changed", (GCallback) _terminal_terminal_widget_check_cwd_changed_vte_terminal_contents_changed, self, 0);
#line 233 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((VteTerminal*) self, "child-exited", (GCallback) _terminal_terminal_widget_on_child_exited_vte_terminal_child_exited, self, 0);
#line 234 "../src/Widgets/TerminalWidget.vala"
	_data3_->once = (gulong) 0;
#line 235 "../src/Widgets/TerminalWidget.vala"
	_tmp27_ = g_signal_connect_data ((GtkWidget*) self, "realize", (GCallback) ___lambda39__gtk_widget_realize, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 235 "../src/Widgets/TerminalWidget.vala"
	_data3_->once = _tmp27_;
#line 242 "../src/Widgets/TerminalWidget.vala"
	_tmp28_.target = "text/uri-list";
#line 242 "../src/Widgets/TerminalWidget.vala"
	_tmp28_.flags = (guint) GTK_TARGET_OTHER_APP;
#line 242 "../src/Widgets/TerminalWidget.vala"
	_tmp28_.info = (guint) TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST;
#line 242 "../src/Widgets/TerminalWidget.vala"
	uri_entry = _tmp28_;
#line 243 "../src/Widgets/TerminalWidget.vala"
	_tmp29_.target = "STRING";
#line 243 "../src/Widgets/TerminalWidget.vala"
	_tmp29_.flags = (guint) GTK_TARGET_OTHER_APP;
#line 243 "../src/Widgets/TerminalWidget.vala"
	_tmp29_.info = (guint) TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING;
#line 243 "../src/Widgets/TerminalWidget.vala"
	string_entry = _tmp29_;
#line 244 "../src/Widgets/TerminalWidget.vala"
	_tmp30_.target = "text/plain";
#line 244 "../src/Widgets/TerminalWidget.vala"
	_tmp30_.flags = (guint) GTK_TARGET_OTHER_APP;
#line 244 "../src/Widgets/TerminalWidget.vala"
	_tmp30_.info = (guint) TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT;
#line 244 "../src/Widgets/TerminalWidget.vala"
	text_entry = _tmp30_;
#line 246 "../src/Widgets/TerminalWidget.vala"
	_tmp31_ = g_new0 (GtkTargetEntry, 0);
#line 246 "../src/Widgets/TerminalWidget.vala"
	targets = _tmp31_;
#line 246 "../src/Widgets/TerminalWidget.vala"
	targets_length1 = 0;
#line 246 "../src/Widgets/TerminalWidget.vala"
	_targets_size_ = targets_length1;
#line 247 "../src/Widgets/TerminalWidget.vala"
	_tmp32_ = uri_entry;
#line 247 "../src/Widgets/TerminalWidget.vala"
	_vala_array_add1 (&targets, &targets_length1, &_targets_size_, &_tmp32_);
#line 248 "../src/Widgets/TerminalWidget.vala"
	_tmp33_ = string_entry;
#line 248 "../src/Widgets/TerminalWidget.vala"
	_vala_array_add2 (&targets, &targets_length1, &_targets_size_, &_tmp33_);
#line 249 "../src/Widgets/TerminalWidget.vala"
	_tmp34_ = text_entry;
#line 249 "../src/Widgets/TerminalWidget.vala"
	_vala_array_add3 (&targets, &targets_length1, &_targets_size_, &_tmp34_);
#line 251 "../src/Widgets/TerminalWidget.vala"
	_tmp35_ = targets;
#line 251 "../src/Widgets/TerminalWidget.vala"
	_tmp35__length1 = targets_length1;
#line 251 "../src/Widgets/TerminalWidget.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp35_, (gint) _tmp35__length1, GDK_ACTION_COPY);
#line 254 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-received", (GCallback) _terminal_terminal_widget_drag_received_gtk_widget_drag_data_received, self, 0);
#line 255 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_clickable (self, TERMINAL_TERMINAL_WIDGET_REGEX_STRINGS, (gint) G_N_ELEMENTS (TERMINAL_TERMINAL_WIDGET_REGEX_STRINGS));
#line 258 "../src/Widgets/TerminalWidget.vala"
	_tmp36_ = g_simple_action_group_new ();
#line 258 "../src/Widgets/TerminalWidget.vala"
	action_group = _tmp36_;
#line 259 "../src/Widgets/TerminalWidget.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "term", (GActionGroup*) action_group);
#line 261 "../src/Widgets/TerminalWidget.vala"
	_tmp37_ = g_simple_action_new ("copy", NULL);
#line 261 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_action);
#line 261 "../src/Widgets/TerminalWidget.vala"
	self->priv->copy_action = _tmp37_;
#line 262 "../src/Widgets/TerminalWidget.vala"
	_tmp38_ = self->priv->copy_action;
#line 262 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp38_, FALSE);
#line 263 "../src/Widgets/TerminalWidget.vala"
	_tmp39_ = self->priv->copy_action;
#line 263 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp39_, "activate", (GCallback) ___lambda40__g_simple_action_activate, self, 0);
#line 264 "../src/Widgets/TerminalWidget.vala"
	_tmp40_ = self->priv->copy_action;
#line 264 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp40_);
#line 266 "../src/Widgets/TerminalWidget.vala"
	_tmp41_ = g_simple_action_new ("copy-output", NULL);
#line 266 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_output_action);
#line 266 "../src/Widgets/TerminalWidget.vala"
	self->priv->copy_output_action = _tmp41_;
#line 267 "../src/Widgets/TerminalWidget.vala"
	_tmp42_ = self->priv->copy_output_action;
#line 267 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp42_, FALSE);
#line 268 "../src/Widgets/TerminalWidget.vala"
	_tmp43_ = self->priv->copy_output_action;
#line 268 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp43_, "activate", (GCallback) _terminal_terminal_widget_copy_output_g_simple_action_activate, self, 0);
#line 269 "../src/Widgets/TerminalWidget.vala"
	_tmp44_ = self->priv->copy_output_action;
#line 269 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp44_);
#line 271 "../src/Widgets/TerminalWidget.vala"
	_tmp45_ = g_simple_action_new ("paste", NULL);
#line 271 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->paste_action);
#line 271 "../src/Widgets/TerminalWidget.vala"
	self->priv->paste_action = _tmp45_;
#line 272 "../src/Widgets/TerminalWidget.vala"
	_tmp46_ = self->priv->paste_action;
#line 272 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp46_, "activate", (GCallback) ___lambda41__g_simple_action_activate, self, 0);
#line 273 "../src/Widgets/TerminalWidget.vala"
	_tmp47_ = self->priv->paste_action;
#line 273 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp47_);
#line 275 "../src/Widgets/TerminalWidget.vala"
	_tmp48_ = g_simple_action_new ("reload", NULL);
#line 275 "../src/Widgets/TerminalWidget.vala"
	reload_action = _tmp48_;
#line 276 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (reload_action, "activate", (GCallback) _terminal_terminal_widget_reload_g_simple_action_activate, self, 0);
#line 277 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) reload_action);
#line 279 "../src/Widgets/TerminalWidget.vala"
	_tmp49_ = g_simple_action_new ("scroll-to-command", NULL);
#line 279 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_to_command_action);
#line 279 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_to_command_action = _tmp49_;
#line 280 "../src/Widgets/TerminalWidget.vala"
	_tmp50_ = self->priv->scroll_to_command_action;
#line 280 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp50_, FALSE);
#line 281 "../src/Widgets/TerminalWidget.vala"
	_tmp51_ = self->priv->scroll_to_command_action;
#line 281 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (_tmp51_, "activate", (GCallback) _terminal_terminal_widget_scroll_to_command_g_simple_action_activate, self, 0);
#line 282 "../src/Widgets/TerminalWidget.vala"
	_tmp52_ = self->priv->scroll_to_command_action;
#line 282 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp52_);
#line 284 "../src/Widgets/TerminalWidget.vala"
	_tmp53_ = g_simple_action_new ("select-all", NULL);
#line 284 "../src/Widgets/TerminalWidget.vala"
	select_all_action = _tmp53_;
#line 285 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (select_all_action, "activate", (GCallback) _vte_terminal_select_all_g_simple_action_activate, (VteTerminal*) self, 0);
#line 286 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) select_all_action);
#line 288 "../src/Widgets/TerminalWidget.vala"
	_tmp54_ = G_VARIANT_TYPE_STRING;
#line 288 "../src/Widgets/TerminalWidget.vala"
	_tmp55_ = g_simple_action_new ("zoom", _tmp54_);
#line 288 "../src/Widgets/TerminalWidget.vala"
	zoom_action = _tmp55_;
#line 289 "../src/Widgets/TerminalWidget.vala"
	g_signal_connect_object (zoom_action, "activate", (GCallback) ___lambda42__g_simple_action_activate, self, 0);
#line 302 "../src/Widgets/TerminalWidget.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) zoom_action);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (zoom_action);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (select_all_action);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (reload_action);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (action_group);
#line 164 "../src/Widgets/TerminalWidget.vala"
	targets = (g_free (targets), NULL);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (granite_settings);
#line 164 "../src/Widgets/TerminalWidget.vala"
	block3_data_unref (_data3_);
#line 164 "../src/Widgets/TerminalWidget.vala"
	_data3_ = NULL;
#line 164 "../src/Widgets/TerminalWidget.vala"
	return self;
#line 1567 "TerminalWidget.c"
}

TerminalTerminalWidget*
terminal_terminal_widget_new (TerminalMainWindow* parent_window)
{
#line 164 "../src/Widgets/TerminalWidget.vala"
	return terminal_terminal_widget_construct (TERMINAL_TYPE_TERMINAL_WIDGET, parent_window);
#line 1575 "TerminalWidget.c"
}

static void
terminal_terminal_widget_pointer_focus (TerminalTerminalWidget* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 305 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Widgets/TerminalWidget.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 307 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 307 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_allow_hyperlink ((VteTerminal*) self, _tmp1_);
#line 1591 "TerminalWidget.c"
}

static void
terminal_terminal_widget_button_pressed (TerminalTerminalWidget* self,
                                         GtkGestureMultiPress* gesture,
                                         gint n_press,
                                         gdouble x,
                                         gdouble y)
{
#line 310 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 311 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->link_uri);
#line 311 "../src/Widgets/TerminalWidget.vala"
	self->link_uri = NULL;
#line 313 "../src/Widgets/TerminalWidget.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 1611 "TerminalWidget.c"
		GdkEvent* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		GdkRectangle rect = {0};
		GdkRectangle _tmp4_ = {0};
		TerminalMainWindow* _tmp5_;
		TerminalMainWindow* _tmp6_;
		GtkMenu* _tmp7_;
		GdkWindow* _tmp8_;
		GdkRectangle _tmp9_;
		GtkMenu* _tmp10_;
#line 314 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, NULL);
#line 314 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = terminal_terminal_widget_get_link (self, _tmp0_);
#line 314 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (self->link_uri);
#line 314 "../src/Widgets/TerminalWidget.vala"
		self->link_uri = _tmp1_;
#line 316 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = self->link_uri;
#line 316 "../src/Widgets/TerminalWidget.vala"
		if (_tmp2_ != NULL) {
#line 1635 "TerminalWidget.c"
			GSimpleAction* _tmp3_;
#line 317 "../src/Widgets/TerminalWidget.vala"
			_tmp3_ = self->priv->copy_action;
#line 317 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp3_, TRUE);
#line 1641 "TerminalWidget.c"
		}
#line 320 "../src/Widgets/TerminalWidget.vala"
		_tmp4_.x = (gint) x;
#line 320 "../src/Widgets/TerminalWidget.vala"
		_tmp4_.y = (gint) y;
#line 320 "../src/Widgets/TerminalWidget.vala"
		rect = _tmp4_;
#line 321 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = terminal_terminal_widget_get_window (self);
#line 321 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 321 "../src/Widgets/TerminalWidget.vala"
		terminal_main_window_update_context_menu (_tmp6_);
#line 322 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_setup_menu (self);
#line 324 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = self->priv->menu;
#line 324 "../src/Widgets/TerminalWidget.vala"
		_tmp8_ = gtk_widget_get_window ((GtkWidget*) self);
#line 324 "../src/Widgets/TerminalWidget.vala"
		_tmp9_ = rect;
#line 324 "../src/Widgets/TerminalWidget.vala"
		gtk_menu_popup_at_rect (_tmp7_, _tmp8_, &_tmp9_, GDK_GRAVITY_SOUTH_WEST, GDK_GRAVITY_NORTH_WEST, NULL);
#line 325 "../src/Widgets/TerminalWidget.vala"
		_tmp10_ = self->priv->menu;
#line 325 "../src/Widgets/TerminalWidget.vala"
		gtk_menu_shell_select_first ((GtkMenuShell*) _tmp10_, FALSE);
#line 327 "../src/Widgets/TerminalWidget.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1671 "TerminalWidget.c"
	}
}

static void
terminal_terminal_widget_button_released (TerminalTerminalWidget* self,
                                          GtkGestureMultiPress* gesture,
                                          gint n_press,
                                          gdouble x,
                                          gdouble y)
{
#line 331 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 332 "../src/Widgets/TerminalWidget.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1688 "TerminalWidget.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 333 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = vte_terminal_get_allow_hyperlink ((VteTerminal*) self);
#line 333 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = _tmp0_;
#line 333 "../src/Widgets/TerminalWidget.vala"
		if (_tmp1_) {
#line 1697 "TerminalWidget.c"
			GdkEvent* _tmp2_;
			gchar* _tmp3_;
			gboolean _tmp4_ = FALSE;
			const gchar* _tmp5_;
#line 334 "../src/Widgets/TerminalWidget.vala"
			_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, NULL);
#line 334 "../src/Widgets/TerminalWidget.vala"
			_tmp3_ = terminal_terminal_widget_get_link (self, _tmp2_);
#line 334 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (self->link_uri);
#line 334 "../src/Widgets/TerminalWidget.vala"
			self->link_uri = _tmp3_;
#line 336 "../src/Widgets/TerminalWidget.vala"
			_tmp5_ = self->link_uri;
#line 336 "../src/Widgets/TerminalWidget.vala"
			if (_tmp5_ != NULL) {
#line 336 "../src/Widgets/TerminalWidget.vala"
				_tmp4_ = !vte_terminal_get_has_selection ((VteTerminal*) self);
#line 1716 "TerminalWidget.c"
			} else {
#line 336 "../src/Widgets/TerminalWidget.vala"
				_tmp4_ = FALSE;
#line 1720 "TerminalWidget.c"
			}
#line 336 "../src/Widgets/TerminalWidget.vala"
			if (_tmp4_) {
#line 1724 "TerminalWidget.c"
				TerminalMainWindow* _tmp6_;
				TerminalMainWindow* _tmp7_;
				GSimpleAction* _tmp8_;
				GSimpleAction* _tmp9_;
#line 337 "../src/Widgets/TerminalWidget.vala"
				_tmp6_ = terminal_terminal_widget_get_window (self);
#line 337 "../src/Widgets/TerminalWidget.vala"
				_tmp7_ = _tmp6_;
#line 337 "../src/Widgets/TerminalWidget.vala"
				_tmp8_ = terminal_main_window_get_simple_action (_tmp7_, TERMINAL_MAIN_WINDOW_ACTION_OPEN_IN_BROWSER);
#line 337 "../src/Widgets/TerminalWidget.vala"
				_tmp9_ = _tmp8_;
#line 337 "../src/Widgets/TerminalWidget.vala"
				g_signal_emit_by_name (_tmp9_, "activate", NULL);
#line 337 "../src/Widgets/TerminalWidget.vala"
				_g_object_unref0 (_tmp9_);
#line 1741 "TerminalWidget.c"
			}
		} else {
#line 340 "../src/Widgets/TerminalWidget.vala"
			vte_terminal_set_allow_hyperlink ((VteTerminal*) self, TRUE);
#line 1746 "TerminalWidget.c"
		}
	}
}

static void
terminal_terminal_widget_scroll (TerminalTerminalWidget* self,
                                 gdouble x,
                                 gdouble y)
{
#line 345 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_delta = self->priv->scroll_delta + y;
#line 349 "../src/Widgets/TerminalWidget.vala"
	if (self->priv->scroll_delta >= 0.5) {
#line 350 "../src/Widgets/TerminalWidget.vala"
		g_signal_emit_by_name ((VteTerminal*) self, "decrease-font-size");
#line 351 "../src/Widgets/TerminalWidget.vala"
		self->priv->scroll_delta = 0.0;
#line 1766 "TerminalWidget.c"
	} else {
#line 352 "../src/Widgets/TerminalWidget.vala"
		if (self->priv->scroll_delta <= (-0.5)) {
#line 353 "../src/Widgets/TerminalWidget.vala"
			g_signal_emit_by_name ((VteTerminal*) self, "increase-font-size");
#line 354 "../src/Widgets/TerminalWidget.vala"
			self->priv->scroll_delta = 0.0;
#line 1774 "TerminalWidget.c"
		}
	}
}

static gboolean
__lambda31_ (TerminalTerminalWidget* self,
             guint keyval,
             guint code)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkKeymap* keymap = NULL;
	GdkDisplay* _tmp0_;
	GdkKeymap* _tmp1_;
	GdkKeymap* _tmp2_;
	GdkKeymap* _tmp3_;
	GdkKeymapKey* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gboolean result;
#line 418 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 418 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = gdk_keymap_get_for_display (_tmp0_);
#line 418 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 418 "../src/Widgets/TerminalWidget.vala"
	keymap = _tmp2_;
#line 419 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = keymap;
#line 419 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = gdk_keymap_get_entries_for_keyval (_tmp3_, keyval, &_tmp4_, &_tmp5_);
#line 419 "../src/Widgets/TerminalWidget.vala"
	keys = (g_free (keys), NULL);
#line 419 "../src/Widgets/TerminalWidget.vala"
	keys = _tmp4_;
#line 419 "../src/Widgets/TerminalWidget.vala"
	keys_length1 = _tmp5_;
#line 419 "../src/Widgets/TerminalWidget.vala"
	_keys_size_ = keys_length1;
#line 419 "../src/Widgets/TerminalWidget.vala"
	if (_tmp6_) {
#line 1818 "TerminalWidget.c"
		GdkKeymapKey* _tmp7_;
		gint _tmp7__length1;
#line 420 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = keys;
#line 420 "../src/Widgets/TerminalWidget.vala"
		_tmp7__length1 = keys_length1;
#line 1825 "TerminalWidget.c"
		{
			GdkKeymapKey* key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 420 "../src/Widgets/TerminalWidget.vala"
			key_collection = _tmp7_;
#line 420 "../src/Widgets/TerminalWidget.vala"
			key_collection_length1 = _tmp7__length1;
#line 420 "../src/Widgets/TerminalWidget.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 1837 "TerminalWidget.c"
				GdkKeymapKey key = {0};
#line 420 "../src/Widgets/TerminalWidget.vala"
				key = key_collection[key_it];
#line 1841 "TerminalWidget.c"
				{
					GdkKeymapKey _tmp8_;
#line 421 "../src/Widgets/TerminalWidget.vala"
					_tmp8_ = key;
#line 421 "../src/Widgets/TerminalWidget.vala"
					if (code == _tmp8_.keycode) {
#line 422 "../src/Widgets/TerminalWidget.vala"
						result = TRUE;
#line 422 "../src/Widgets/TerminalWidget.vala"
						_g_object_unref0 (keymap);
#line 422 "../src/Widgets/TerminalWidget.vala"
						keys = (g_free (keys), NULL);
#line 422 "../src/Widgets/TerminalWidget.vala"
						return result;
#line 1856 "TerminalWidget.c"
					}
				}
			}
		}
	}
#line 427 "../src/Widgets/TerminalWidget.vala"
	result = FALSE;
#line 427 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (keymap);
#line 427 "../src/Widgets/TerminalWidget.vala"
	keys = (g_free (keys), NULL);
#line 427 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 1870 "TerminalWidget.c"
}

static gboolean
___lambda31___localfunc0_ (guint keyval,
                           guint code,
                           gpointer self)
{
	gboolean result;
	result = __lambda31_ ((TerminalTerminalWidget*) self, keyval, code);
#line 415 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 1882 "TerminalWidget.c"
}

static gboolean
terminal_terminal_widget_key_pressed (TerminalTerminalWidget* self,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType modifiers)
{
	_LocalFunc0_ match_keycode = NULL;
	gpointer match_keycode_target;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean result;
#line 358 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 359 "../src/Widgets/TerminalWidget.vala"
	switch (keyval) {
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Control_R:
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Control_L:
#line 1904 "TerminalWidget.c"
		{
			GtkEventControllerScroll* _tmp0_;
#line 362 "../src/Widgets/TerminalWidget.vala"
			_tmp0_ = self->priv->scroll_controller;
#line 362 "../src/Widgets/TerminalWidget.vala"
			gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 363 "../src/Widgets/TerminalWidget.vala"
			break;
#line 1913 "TerminalWidget.c"
		}
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Return:
#line 1917 "TerminalWidget.c"
		{
			GSimpleAction* _tmp1_;
			GSimpleAction* _tmp2_;
#line 366 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_remember_position (self);
#line 367 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = self->priv->scroll_to_command_action;
#line 367 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp1_, TRUE);
#line 368 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_remember_command_end_position (self);
#line 369 "../src/Widgets/TerminalWidget.vala"
			_tmp2_ = self->priv->copy_output_action;
#line 369 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp2_, FALSE);
#line 370 "../src/Widgets/TerminalWidget.vala"
			break;
#line 1935 "TerminalWidget.c"
		}
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Up:
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Down:
#line 1941 "TerminalWidget.c"
		{
#line 374 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_remember_command_start_position (self);
#line 375 "../src/Widgets/TerminalWidget.vala"
			break;
#line 1947 "TerminalWidget.c"
		}
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Menu:
#line 1951 "TerminalWidget.c"
		{
			glong col = 0L;
			glong row = 0L;
			glong _tmp3_ = 0L;
			glong _tmp4_ = 0L;
			glong cell_width = 0L;
			glong cell_height = 0L;
			gdouble vadj = 0.0;
			GtkAdjustment* _tmp5_;
			GtkAdjustment* _tmp6_;
			gdouble _tmp7_;
			gdouble _tmp8_;
			GdkRectangle rect = {0};
			GdkRectangle _tmp9_ = {0};
			TerminalMainWindow* _tmp10_;
			TerminalMainWindow* _tmp11_;
			GtkMenu* _tmp12_;
			GdkWindow* _tmp13_;
			GdkRectangle _tmp14_;
			GtkMenu* _tmp15_;
#line 380 "../src/Widgets/TerminalWidget.vala"
			vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp3_, &_tmp4_);
#line 380 "../src/Widgets/TerminalWidget.vala"
			col = _tmp3_;
#line 380 "../src/Widgets/TerminalWidget.vala"
			row = _tmp4_;
#line 382 "../src/Widgets/TerminalWidget.vala"
			cell_width = vte_terminal_get_char_width ((VteTerminal*) self);
#line 383 "../src/Widgets/TerminalWidget.vala"
			cell_height = vte_terminal_get_char_height ((VteTerminal*) self);
#line 384 "../src/Widgets/TerminalWidget.vala"
			_tmp5_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) self);
#line 384 "../src/Widgets/TerminalWidget.vala"
			_tmp6_ = _tmp5_;
#line 384 "../src/Widgets/TerminalWidget.vala"
			_tmp7_ = gtk_adjustment_get_value (_tmp6_);
#line 384 "../src/Widgets/TerminalWidget.vala"
			_tmp8_ = _tmp7_;
#line 384 "../src/Widgets/TerminalWidget.vala"
			vadj = _tmp8_;
#line 386 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.x = (gint) (col * cell_width);
#line 386 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.y = (gint) ((row - vadj) * cell_height);
#line 386 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.width = (gint) cell_width;
#line 386 "../src/Widgets/TerminalWidget.vala"
			_tmp9_.height = (gint) cell_height;
#line 386 "../src/Widgets/TerminalWidget.vala"
			rect = _tmp9_;
#line 393 "../src/Widgets/TerminalWidget.vala"
			_tmp10_ = terminal_terminal_widget_get_window (self);
#line 393 "../src/Widgets/TerminalWidget.vala"
			_tmp11_ = _tmp10_;
#line 393 "../src/Widgets/TerminalWidget.vala"
			terminal_main_window_update_context_menu (_tmp11_);
#line 394 "../src/Widgets/TerminalWidget.vala"
			terminal_terminal_widget_setup_menu (self);
#line 397 "../src/Widgets/TerminalWidget.vala"
			_tmp12_ = self->priv->menu;
#line 397 "../src/Widgets/TerminalWidget.vala"
			_tmp13_ = gtk_widget_get_window ((GtkWidget*) self);
#line 397 "../src/Widgets/TerminalWidget.vala"
			_tmp14_ = rect;
#line 397 "../src/Widgets/TerminalWidget.vala"
			gtk_menu_popup_at_rect (_tmp12_, _tmp13_, &_tmp14_, GDK_GRAVITY_SOUTH_WEST, GDK_GRAVITY_NORTH_WEST, NULL);
#line 398 "../src/Widgets/TerminalWidget.vala"
			_tmp15_ = self->priv->menu;
#line 398 "../src/Widgets/TerminalWidget.vala"
			gtk_menu_shell_select_first ((GtkMenuShell*) _tmp15_, FALSE);
#line 399 "../src/Widgets/TerminalWidget.vala"
			break;
#line 2024 "TerminalWidget.c"
		}
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Alt_L:
#line 359 "../src/Widgets/TerminalWidget.vala"
		case GDK_KEY_Alt_R:
#line 2030 "TerminalWidget.c"
		{
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_;
			GSimpleAction* _tmp22_;
#line 404 "../src/Widgets/TerminalWidget.vala"
			_tmp17_ = self->priv->_resized;
#line 404 "../src/Widgets/TerminalWidget.vala"
			if (!_tmp17_) {
#line 2039 "TerminalWidget.c"
				gchar* _tmp18_;
				gchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 404 "../src/Widgets/TerminalWidget.vala"
				_tmp18_ = terminal_terminal_widget_get_last_output (self, TRUE);
#line 404 "../src/Widgets/TerminalWidget.vala"
				_tmp19_ = _tmp18_;
#line 404 "../src/Widgets/TerminalWidget.vala"
				_tmp20_ = strlen (_tmp19_);
#line 404 "../src/Widgets/TerminalWidget.vala"
				_tmp21_ = _tmp20_;
#line 404 "../src/Widgets/TerminalWidget.vala"
				_tmp16_ = _tmp21_ > 0;
#line 404 "../src/Widgets/TerminalWidget.vala"
				_g_free0 (_tmp19_);
#line 2056 "TerminalWidget.c"
			} else {
#line 404 "../src/Widgets/TerminalWidget.vala"
				_tmp16_ = FALSE;
#line 2060 "TerminalWidget.c"
			}
#line 404 "../src/Widgets/TerminalWidget.vala"
			_tmp22_ = self->priv->copy_output_action;
#line 404 "../src/Widgets/TerminalWidget.vala"
			g_simple_action_set_enabled (_tmp22_, _tmp16_);
#line 405 "../src/Widgets/TerminalWidget.vala"
			break;
#line 2068 "TerminalWidget.c"
		}
		default:
		{
			gboolean _tmp23_ = FALSE;
#line 408 "../src/Widgets/TerminalWidget.vala"
			if (!self->priv->modifier_pressed) {
#line 408 "../src/Widgets/TerminalWidget.vala"
				_tmp23_ = TRUE;
#line 2077 "TerminalWidget.c"
			} else {
#line 408 "../src/Widgets/TerminalWidget.vala"
				_tmp23_ = !((modifiers & gtk_accelerator_get_default_mod_mask ()) == gtk_accelerator_get_default_mod_mask ());
#line 2081 "TerminalWidget.c"
			}
#line 408 "../src/Widgets/TerminalWidget.vala"
			if (_tmp23_) {
#line 409 "../src/Widgets/TerminalWidget.vala"
				terminal_terminal_widget_remember_command_start_position (self);
#line 2087 "TerminalWidget.c"
			}
#line 411 "../src/Widgets/TerminalWidget.vala"
			break;
#line 2091 "TerminalWidget.c"
		}
	}
#line 415 "../src/Widgets/TerminalWidget.vala"
	match_keycode = ___lambda31___localfunc0_;
#line 415 "../src/Widgets/TerminalWidget.vala"
	match_keycode_target = self;
#line 430 "../src/Widgets/TerminalWidget.vala"
	if ((modifiers & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 2100 "TerminalWidget.c"
		GSettings* _tmp25_;
#line 430 "../src/Widgets/TerminalWidget.vala"
		_tmp25_ = terminal_application_settings;
#line 430 "../src/Widgets/TerminalWidget.vala"
		_tmp24_ = g_settings_get_boolean (_tmp25_, "natural-copy-paste");
#line 2106 "TerminalWidget.c"
	} else {
#line 430 "../src/Widgets/TerminalWidget.vala"
		_tmp24_ = FALSE;
#line 2110 "TerminalWidget.c"
	}
#line 430 "../src/Widgets/TerminalWidget.vala"
	if (_tmp24_) {
#line 2114 "TerminalWidget.c"
		_LocalFunc0_ _tmp26_;
		gpointer _tmp26__target;
#line 431 "../src/Widgets/TerminalWidget.vala"
		_tmp26_ = match_keycode;
#line 431 "../src/Widgets/TerminalWidget.vala"
		_tmp26__target = match_keycode_target;
#line 431 "../src/Widgets/TerminalWidget.vala"
		if (_tmp26_ (GDK_KEY_c, keycode, _tmp26__target)) {
#line 432 "../src/Widgets/TerminalWidget.vala"
			if (vte_terminal_get_has_selection ((VteTerminal*) self)) {
#line 433 "../src/Widgets/TerminalWidget.vala"
				vte_terminal_copy_clipboard ((VteTerminal*) self);
#line 434 "../src/Widgets/TerminalWidget.vala"
				if (!((modifiers & GDK_SHIFT_MASK) == GDK_SHIFT_MASK)) {
#line 435 "../src/Widgets/TerminalWidget.vala"
					vte_terminal_unselect_all ((VteTerminal*) self);
#line 2131 "TerminalWidget.c"
				}
#line 437 "../src/Widgets/TerminalWidget.vala"
				result = TRUE;
#line 437 "../src/Widgets/TerminalWidget.vala"
				return result;
#line 2137 "TerminalWidget.c"
			} else {
#line 439 "../src/Widgets/TerminalWidget.vala"
				self->last_key_was_return = TRUE;
#line 2141 "TerminalWidget.c"
			}
		} else {
			gboolean _tmp27_ = FALSE;
			_LocalFunc0_ _tmp28_;
			gpointer _tmp28__target;
#line 441 "../src/Widgets/TerminalWidget.vala"
			_tmp28_ = match_keycode;
#line 441 "../src/Widgets/TerminalWidget.vala"
			_tmp28__target = match_keycode_target;
#line 441 "../src/Widgets/TerminalWidget.vala"
			if (_tmp28_ (GDK_KEY_v, keycode, _tmp28__target)) {
#line 2153 "TerminalWidget.c"
				GtkClipboard* _tmp29_;
#line 441 "../src/Widgets/TerminalWidget.vala"
				_tmp29_ = self->priv->clipboard;
#line 441 "../src/Widgets/TerminalWidget.vala"
				_tmp27_ = gtk_clipboard_wait_is_text_available (_tmp29_);
#line 2159 "TerminalWidget.c"
			} else {
#line 441 "../src/Widgets/TerminalWidget.vala"
				_tmp27_ = FALSE;
#line 2163 "TerminalWidget.c"
			}
#line 441 "../src/Widgets/TerminalWidget.vala"
			if (_tmp27_) {
#line 442 "../src/Widgets/TerminalWidget.vala"
				vte_terminal_paste_clipboard ((VteTerminal*) self);
#line 443 "../src/Widgets/TerminalWidget.vala"
				result = TRUE;
#line 443 "../src/Widgets/TerminalWidget.vala"
				return result;
#line 2173 "TerminalWidget.c"
			}
		}
	}
#line 447 "../src/Widgets/TerminalWidget.vala"
	if ((modifiers & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 447 "../src/Widgets/TerminalWidget.vala"
		_tmp30_ = keyval == GDK_KEY_Up;
#line 2181 "TerminalWidget.c"
	} else {
#line 447 "../src/Widgets/TerminalWidget.vala"
		_tmp30_ = FALSE;
#line 2185 "TerminalWidget.c"
	}
#line 447 "../src/Widgets/TerminalWidget.vala"
	if (_tmp30_) {
#line 2189 "TerminalWidget.c"
		GSimpleAction* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
#line 448 "../src/Widgets/TerminalWidget.vala"
		_tmp31_ = self->priv->scroll_to_command_action;
#line 448 "../src/Widgets/TerminalWidget.vala"
		_tmp32_ = g_action_get_enabled ((GAction*) _tmp31_);
#line 448 "../src/Widgets/TerminalWidget.vala"
		_tmp33_ = _tmp32_;
#line 448 "../src/Widgets/TerminalWidget.vala"
		result = !_tmp33_;
#line 448 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 2203 "TerminalWidget.c"
	}
#line 451 "../src/Widgets/TerminalWidget.vala"
	result = FALSE;
#line 451 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 2209 "TerminalWidget.c"
}

static void
__lambda30_ (TerminalTerminalWidget* self,
             GtkClipboard* clipboard,
             GdkAtom* atoms,
             gint atoms_length1)
{
	gboolean can_paste = FALSE;
	gboolean _tmp0_ = FALSE;
	GSimpleAction* _tmp2_;
#line 456 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (clipboard != NULL);
#line 457 "../src/Widgets/TerminalWidget.vala"
	can_paste = FALSE;
#line 459 "../src/Widgets/TerminalWidget.vala"
	if (atoms != NULL) {
#line 459 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = atoms_length1 > 0;
#line 2229 "TerminalWidget.c"
	} else {
#line 459 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 2233 "TerminalWidget.c"
	}
#line 459 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 2237 "TerminalWidget.c"
		gboolean _tmp1_ = FALSE;
#line 460 "../src/Widgets/TerminalWidget.vala"
		if (gtk_targets_include_text (atoms, (gint) atoms_length1)) {
#line 460 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = TRUE;
#line 2243 "TerminalWidget.c"
		} else {
#line 460 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = gtk_targets_include_uri (atoms, (gint) atoms_length1);
#line 2247 "TerminalWidget.c"
		}
#line 460 "../src/Widgets/TerminalWidget.vala"
		can_paste = _tmp1_;
#line 2251 "TerminalWidget.c"
	}
#line 463 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->priv->paste_action;
#line 463 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp2_, can_paste);
#line 2257 "TerminalWidget.c"
}

static void
___lambda30__gtk_clipboard_targets_received_func (GtkClipboard* clipboard,
                                                  GdkAtom* atoms,
                                                  gint n_atoms,
                                                  gpointer self)
{
#line 456 "../src/Widgets/TerminalWidget.vala"
	__lambda30_ ((TerminalTerminalWidget*) self, clipboard, atoms, n_atoms);
#line 456 "../src/Widgets/TerminalWidget.vala"
	g_object_unref (self);
#line 2270 "TerminalWidget.c"
}

static void
terminal_terminal_widget_setup_menu (TerminalTerminalWidget* self)
{
	GtkClipboard* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean has_output = FALSE;
	GSimpleAction* _tmp7_;
#line 454 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 456 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->clipboard;
#line 456 "../src/Widgets/TerminalWidget.vala"
	gtk_clipboard_request_targets (_tmp0_, ___lambda30__gtk_clipboard_targets_received_func, g_object_ref (self));
#line 467 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->priv->_resized;
#line 467 "../src/Widgets/TerminalWidget.vala"
	if (!_tmp2_) {
#line 2291 "TerminalWidget.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 467 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = terminal_terminal_widget_get_last_output (self, TRUE);
#line 467 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = _tmp3_;
#line 467 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = strlen (_tmp4_);
#line 467 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 467 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = _tmp6_ > 0;
#line 467 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp4_);
#line 2308 "TerminalWidget.c"
	} else {
#line 467 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = FALSE;
#line 2312 "TerminalWidget.c"
	}
#line 467 "../src/Widgets/TerminalWidget.vala"
	has_output = _tmp1_;
#line 468 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = self->priv->copy_output_action;
#line 468 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (_tmp7_, has_output);
#line 2320 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_copy_clipboard (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 471 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 472 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->link_uri;
#line 472 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_ != NULL) {
#line 472 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = !vte_terminal_get_has_selection ((VteTerminal*) self);
#line 2337 "TerminalWidget.c"
	} else {
#line 472 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 2341 "TerminalWidget.c"
	}
#line 472 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 2345 "TerminalWidget.c"
		GtkClipboard* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 473 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = self->priv->clipboard;
#line 473 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = self->link_uri;
#line 473 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = self->link_uri;
#line 473 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = strlen (_tmp4_);
#line 473 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 473 "../src/Widgets/TerminalWidget.vala"
		gtk_clipboard_set_text (_tmp2_, _tmp3_, _tmp6_);
#line 2363 "TerminalWidget.c"
	} else {
#line 475 "../src/Widgets/TerminalWidget.vala"
		VTE_TERMINAL_CLASS (terminal_terminal_widget_parent_class)->copy_clipboard (G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
#line 2367 "TerminalWidget.c"
	}
}

static void
terminal_terminal_widget_copy_output (TerminalTerminalWidget* self)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	GtkClipboard* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 479 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 480 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_get_last_output (self, TRUE);
#line 480 "../src/Widgets/TerminalWidget.vala"
	output = _tmp0_;
#line 481 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = self->priv->clipboard;
#line 481 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = strlen (output);
#line 481 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _tmp2_;
#line 481 "../src/Widgets/TerminalWidget.vala"
	gtk_clipboard_set_text (_tmp1_, output, _tmp3_);
#line 479 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (output);
#line 2395 "TerminalWidget.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 2414 "TerminalWidget.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 507 "../src/Widgets/TerminalWidget.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 507 "../src/Widgets/TerminalWidget.vala"
	return _data4_;
#line 2424 "TerminalWidget.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 507 "../src/Widgets/TerminalWidget.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2434 "TerminalWidget.c"
		TerminalTerminalWidget* self;
#line 507 "../src/Widgets/TerminalWidget.vala"
		self = _data4_->self;
#line 507 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (_data4_->dialog);
#line 507 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (self);
#line 507 "../src/Widgets/TerminalWidget.vala"
		g_slice_free (Block4Data, _data4_);
#line 2444 "TerminalWidget.c"
	}
}

static void
____lambda33_ (Block4Data* _data4_,
               gint res)
{
	TerminalTerminalWidget* self;
	TerminalUnsafePasteDialog* _tmp0_;
#line 509 "../src/Widgets/TerminalWidget.vala"
	self = _data4_->self;
#line 510 "../src/Widgets/TerminalWidget.vala"
	if (res == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 511 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_remember_command_start_position (self);
#line 512 "../src/Widgets/TerminalWidget.vala"
		VTE_TERMINAL_CLASS (terminal_terminal_widget_parent_class)->paste_clipboard (G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
#line 2462 "TerminalWidget.c"
	}
#line 515 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = _data4_->dialog;
#line 515 "../src/Widgets/TerminalWidget.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 2468 "TerminalWidget.c"
}

static void
_____lambda33__gtk_dialog_response (GtkDialog* _sender,
                                    gint response_id,
                                    gpointer self)
{
#line 509 "../src/Widgets/TerminalWidget.vala"
	____lambda33_ (self, response_id);
#line 2478 "TerminalWidget.c"
}

static void
__lambda32_ (TerminalTerminalWidget* self,
             GtkClipboard* clipboard,
             const gchar* text)
{
	TerminalMainWindow* toplevel = NULL;
	GtkWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	TerminalMainWindow* _tmp2_;
#line 485 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (clipboard != NULL);
#line 486 "../src/Widgets/TerminalWidget.vala"
	if (text == NULL) {
#line 487 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2496 "TerminalWidget.c"
	}
#line 490 "../src/Widgets/TerminalWidget.vala"
	if (!g_utf8_validate (text, (gssize) -1, NULL)) {
#line 491 "../src/Widgets/TerminalWidget.vala"
		g_warning ("TerminalWidget.vala:491: Dropping invalid UTF-8 paste");
#line 492 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2504 "TerminalWidget.c"
	}
#line 495 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 495 "../src/Widgets/TerminalWidget.vala"
	toplevel = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindow);
#line 497 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = toplevel;
#line 497 "../src/Widgets/TerminalWidget.vala"
	if (!_tmp2_->unsafe_ignored) {
#line 2514 "TerminalWidget.c"
		GSettings* _tmp3_;
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = terminal_application_settings;
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = g_settings_get_boolean (_tmp3_, "unsafe-paste-alert");
#line 2520 "TerminalWidget.c"
	} else {
#line 497 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = FALSE;
#line 2524 "TerminalWidget.c"
	}
#line 497 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_) {
#line 2528 "TerminalWidget.c"
		gchar* warn_text = NULL;
		const gchar* _tmp6_;
#line 498 "../src/Widgets/TerminalWidget.vala"
		warn_text = NULL;
#line 499 "../src/Widgets/TerminalWidget.vala"
		g_strstrip (text);
#line 501 "../src/Widgets/TerminalWidget.vala"
		if (string_contains (text, "\n")) {
#line 2537 "TerminalWidget.c"
			gchar* _tmp4_;
#line 502 "../src/Widgets/TerminalWidget.vala"
			_tmp4_ = g_strdup (_ ("The pasted text may contain multiple commands"));
#line 502 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (warn_text);
#line 502 "../src/Widgets/TerminalWidget.vala"
			warn_text = _tmp4_;
#line 2545 "TerminalWidget.c"
		} else {
#line 503 "../src/Widgets/TerminalWidget.vala"
			if (string_contains (text, "sudo")) {
#line 2549 "TerminalWidget.c"
				gchar* _tmp5_;
#line 504 "../src/Widgets/TerminalWidget.vala"
				_tmp5_ = g_strdup (_ ("The pasted text may be trying to gain administrative access"));
#line 504 "../src/Widgets/TerminalWidget.vala"
				_g_free0 (warn_text);
#line 504 "../src/Widgets/TerminalWidget.vala"
				warn_text = _tmp5_;
#line 2557 "TerminalWidget.c"
			}
		}
#line 507 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = warn_text;
#line 507 "../src/Widgets/TerminalWidget.vala"
		if (_tmp6_ != NULL) {
#line 2564 "TerminalWidget.c"
			Block4Data* _data4_;
			TerminalMainWindow* _tmp7_;
			const gchar* _tmp8_;
			TerminalUnsafePasteDialog* _tmp9_;
			TerminalUnsafePasteDialog* _tmp10_;
			TerminalUnsafePasteDialog* _tmp11_;
#line 507 "../src/Widgets/TerminalWidget.vala"
			_data4_ = g_slice_new0 (Block4Data);
#line 507 "../src/Widgets/TerminalWidget.vala"
			_data4_->_ref_count_ = 1;
#line 507 "../src/Widgets/TerminalWidget.vala"
			_data4_->self = g_object_ref (self);
#line 508 "../src/Widgets/TerminalWidget.vala"
			_tmp7_ = toplevel;
#line 508 "../src/Widgets/TerminalWidget.vala"
			_tmp8_ = warn_text;
#line 508 "../src/Widgets/TerminalWidget.vala"
			_tmp9_ = terminal_unsafe_paste_dialog_new (_tmp7_, _tmp8_, text);
#line 508 "../src/Widgets/TerminalWidget.vala"
			g_object_ref_sink (_tmp9_);
#line 508 "../src/Widgets/TerminalWidget.vala"
			_data4_->dialog = _tmp9_;
#line 509 "../src/Widgets/TerminalWidget.vala"
			_tmp10_ = _data4_->dialog;
#line 509 "../src/Widgets/TerminalWidget.vala"
			g_signal_connect_data ((GtkDialog*) _tmp10_, "response", (GCallback) _____lambda33__gtk_dialog_response, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 518 "../src/Widgets/TerminalWidget.vala"
			_tmp11_ = _data4_->dialog;
#line 518 "../src/Widgets/TerminalWidget.vala"
			gtk_window_present ((GtkWindow*) _tmp11_);
#line 519 "../src/Widgets/TerminalWidget.vala"
			block4_data_unref (_data4_);
#line 519 "../src/Widgets/TerminalWidget.vala"
			_data4_ = NULL;
#line 519 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (warn_text);
#line 519 "../src/Widgets/TerminalWidget.vala"
			return;
#line 2603 "TerminalWidget.c"
		}
#line 497 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (warn_text);
#line 2607 "TerminalWidget.c"
	}
#line 523 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_remember_command_start_position (self);
#line 524 "../src/Widgets/TerminalWidget.vala"
	VTE_TERMINAL_CLASS (terminal_terminal_widget_parent_class)->paste_clipboard (G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
#line 2613 "TerminalWidget.c"
}

static void
___lambda32__gtk_clipboard_text_received_func (GtkClipboard* clipboard,
                                               const gchar* text,
                                               gpointer self)
{
#line 485 "../src/Widgets/TerminalWidget.vala"
	__lambda32_ ((TerminalTerminalWidget*) self, clipboard, text);
#line 485 "../src/Widgets/TerminalWidget.vala"
	g_object_unref (self);
#line 2625 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_paste_clipboard (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	GtkClipboard* _tmp0_;
#line 484 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 485 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->clipboard;
#line 485 "../src/Widgets/TerminalWidget.vala"
	gtk_clipboard_request_text (_tmp0_, ___lambda32__gtk_clipboard_text_received_func, g_object_ref (self));
#line 2639 "TerminalWidget.c"
}

static GdkRGBA*
_vala_array_dup1 (GdkRGBA* self,
                  gssize length)
{
#line 548 "../src/Widgets/TerminalWidget.vala"
	if (length > 0) {
#line 548 "../src/Widgets/TerminalWidget.vala"
		return _vala_memdup2 (self, length * sizeof (GdkRGBA));
#line 2650 "TerminalWidget.c"
	}
#line 548 "../src/Widgets/TerminalWidget.vala"
	return NULL;
#line 2654 "TerminalWidget.c"
}

static void
terminal_terminal_widget_update_theme (TerminalTerminalWidget* self)
{
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GdkRGBA* theme_palette = NULL;
	GdkRGBA* _tmp2_;
	gint theme_palette_length1;
	gint _theme_palette_size_;
	GSettings* _tmp3_;
	GdkRGBA background = {0};
	GdkRGBA* _tmp19_;
	gint _tmp19__length1;
	GdkRGBA _tmp20_;
	GdkRGBA foreground = {0};
	GdkRGBA* _tmp21_;
	gint _tmp21__length1;
	GdkRGBA _tmp22_;
	GdkRGBA cursor = {0};
	GdkRGBA* _tmp23_;
	gint _tmp23__length1;
	GdkRGBA _tmp24_;
	GdkRGBA* palette = NULL;
	GdkRGBA* _tmp25_;
	gint _tmp25__length1;
	GdkRGBA* _tmp26_;
	gint _tmp26__length1;
	gint palette_length1;
	gint _palette_size_;
	GdkRGBA _tmp27_;
	GdkRGBA _tmp28_;
	GdkRGBA _tmp29_;
#line 528 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 529 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 529 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 529 "../src/Widgets/TerminalWidget.vala"
	gtk_settings = _tmp1_;
#line 530 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = g_new0 (GdkRGBA, TERMINAL_THEMES_PALETTE_SIZE);
#line 530 "../src/Widgets/TerminalWidget.vala"
	theme_palette = _tmp2_;
#line 530 "../src/Widgets/TerminalWidget.vala"
	theme_palette_length1 = TERMINAL_THEMES_PALETTE_SIZE;
#line 530 "../src/Widgets/TerminalWidget.vala"
	_theme_palette_size_ = theme_palette_length1;
#line 531 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = terminal_application_settings;
#line 531 "../src/Widgets/TerminalWidget.vala"
	if (g_settings_get_boolean (_tmp3_, "follow-system-style")) {
#line 2710 "TerminalWidget.c"
		gboolean system_prefers_dark = FALSE;
		GraniteSettings* _tmp4_;
		GraniteSettingsColorScheme _tmp5_;
		GraniteSettingsColorScheme _tmp6_;
		GtkSettings* _tmp7_;
#line 532 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = granite_settings_get_default ();
#line 532 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = granite_settings_get_prefers_color_scheme (_tmp4_);
#line 532 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = _tmp5_;
#line 532 "../src/Widgets/TerminalWidget.vala"
		system_prefers_dark = _tmp6_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK;
#line 533 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = gtk_settings;
#line 533 "../src/Widgets/TerminalWidget.vala"
		g_object_set (_tmp7_, "gtk-application-prefer-dark-theme", system_prefers_dark, NULL);
#line 535 "../src/Widgets/TerminalWidget.vala"
		if (system_prefers_dark) {
#line 2730 "TerminalWidget.c"
			gint _tmp8_ = 0;
			GdkRGBA* _tmp9_;
#line 536 "../src/Widgets/TerminalWidget.vala"
			_tmp9_ = terminal_themes_get_rgba_palette (TERMINAL_THEMES_DARK, &_tmp8_);
#line 536 "../src/Widgets/TerminalWidget.vala"
			theme_palette = (g_free (theme_palette), NULL);
#line 536 "../src/Widgets/TerminalWidget.vala"
			theme_palette = _tmp9_;
#line 536 "../src/Widgets/TerminalWidget.vala"
			theme_palette_length1 = _tmp8_;
#line 536 "../src/Widgets/TerminalWidget.vala"
			_theme_palette_size_ = theme_palette_length1;
#line 2743 "TerminalWidget.c"
		} else {
			gint _tmp10_ = 0;
			GdkRGBA* _tmp11_;
#line 538 "../src/Widgets/TerminalWidget.vala"
			_tmp11_ = terminal_themes_get_rgba_palette (TERMINAL_THEMES_LIGHT, &_tmp10_);
#line 538 "../src/Widgets/TerminalWidget.vala"
			theme_palette = (g_free (theme_palette), NULL);
#line 538 "../src/Widgets/TerminalWidget.vala"
			theme_palette = _tmp11_;
#line 538 "../src/Widgets/TerminalWidget.vala"
			theme_palette_length1 = _tmp10_;
#line 538 "../src/Widgets/TerminalWidget.vala"
			_theme_palette_size_ = theme_palette_length1;
#line 2757 "TerminalWidget.c"
		}
	} else {
		GtkSettings* _tmp12_;
		GSettings* _tmp13_;
		GSettings* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gint _tmp17_ = 0;
		GdkRGBA* _tmp18_;
#line 541 "../src/Widgets/TerminalWidget.vala"
		_tmp12_ = gtk_settings;
#line 541 "../src/Widgets/TerminalWidget.vala"
		_tmp13_ = terminal_application_settings;
#line 541 "../src/Widgets/TerminalWidget.vala"
		g_object_set (_tmp12_, "gtk-application-prefer-dark-theme", g_settings_get_boolean (_tmp13_, "prefer-dark-style"), NULL);
#line 542 "../src/Widgets/TerminalWidget.vala"
		_tmp14_ = terminal_application_settings;
#line 542 "../src/Widgets/TerminalWidget.vala"
		_tmp15_ = g_settings_get_string (_tmp14_, "theme");
#line 542 "../src/Widgets/TerminalWidget.vala"
		_tmp16_ = _tmp15_;
#line 542 "../src/Widgets/TerminalWidget.vala"
		_tmp18_ = terminal_themes_get_rgba_palette (_tmp16_, &_tmp17_);
#line 542 "../src/Widgets/TerminalWidget.vala"
		theme_palette = (g_free (theme_palette), NULL);
#line 542 "../src/Widgets/TerminalWidget.vala"
		theme_palette = _tmp18_;
#line 542 "../src/Widgets/TerminalWidget.vala"
		theme_palette_length1 = _tmp17_;
#line 542 "../src/Widgets/TerminalWidget.vala"
		_theme_palette_size_ = theme_palette_length1;
#line 542 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp16_);
#line 2791 "TerminalWidget.c"
	}
#line 545 "../src/Widgets/TerminalWidget.vala"
	_tmp19_ = theme_palette;
#line 545 "../src/Widgets/TerminalWidget.vala"
	_tmp19__length1 = theme_palette_length1;
#line 545 "../src/Widgets/TerminalWidget.vala"
	_tmp20_ = _tmp19_[TERMINAL_THEMES_PALETTE_SIZE - 3];
#line 545 "../src/Widgets/TerminalWidget.vala"
	background = _tmp20_;
#line 546 "../src/Widgets/TerminalWidget.vala"
	_tmp21_ = theme_palette;
#line 546 "../src/Widgets/TerminalWidget.vala"
	_tmp21__length1 = theme_palette_length1;
#line 546 "../src/Widgets/TerminalWidget.vala"
	_tmp22_ = _tmp21_[TERMINAL_THEMES_PALETTE_SIZE - 2];
#line 546 "../src/Widgets/TerminalWidget.vala"
	foreground = _tmp22_;
#line 547 "../src/Widgets/TerminalWidget.vala"
	_tmp23_ = theme_palette;
#line 547 "../src/Widgets/TerminalWidget.vala"
	_tmp23__length1 = theme_palette_length1;
#line 547 "../src/Widgets/TerminalWidget.vala"
	_tmp24_ = _tmp23_[TERMINAL_THEMES_PALETTE_SIZE - 1];
#line 547 "../src/Widgets/TerminalWidget.vala"
	cursor = _tmp24_;
#line 548 "../src/Widgets/TerminalWidget.vala"
	_tmp25_ = theme_palette;
#line 548 "../src/Widgets/TerminalWidget.vala"
	_tmp25__length1 = theme_palette_length1;
#line 548 "../src/Widgets/TerminalWidget.vala"
	_tmp26_ = (_tmp25_ != NULL) ? _vala_array_dup1 (_tmp25_ + 0, 16 - 0) : _tmp25_;
#line 548 "../src/Widgets/TerminalWidget.vala"
	_tmp26__length1 = 16 - 0;
#line 548 "../src/Widgets/TerminalWidget.vala"
	palette = _tmp26_;
#line 548 "../src/Widgets/TerminalWidget.vala"
	palette_length1 = _tmp26__length1;
#line 548 "../src/Widgets/TerminalWidget.vala"
	_palette_size_ = palette_length1;
#line 550 "../src/Widgets/TerminalWidget.vala"
	_tmp27_ = foreground;
#line 550 "../src/Widgets/TerminalWidget.vala"
	_tmp28_ = background;
#line 550 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_colors ((VteTerminal*) self, &_tmp27_, &_tmp28_, palette, (gsize) palette_length1);
#line 551 "../src/Widgets/TerminalWidget.vala"
	_tmp29_ = cursor;
#line 551 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_color_cursor ((VteTerminal*) self, &_tmp29_);
#line 528 "../src/Widgets/TerminalWidget.vala"
	palette = (g_free (palette), NULL);
#line 528 "../src/Widgets/TerminalWidget.vala"
	theme_palette = (g_free (theme_palette), NULL);
#line 528 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (gtk_settings);
#line 2847 "TerminalWidget.c"
}

static void
terminal_terminal_widget_update_audible_bell (TerminalTerminalWidget* self)
{
	GSettings* _tmp0_;
#line 554 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 555 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_application_settings;
#line 555 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_audible_bell ((VteTerminal*) self, g_settings_get_boolean (_tmp0_, "audible-bell"));
#line 2860 "TerminalWidget.c"
}

static void
terminal_terminal_widget_update_cursor_shape (TerminalTerminalWidget* self)
{
	GSettings* _tmp0_;
#line 558 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_application_settings;
#line 559 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_cursor_shape ((VteTerminal*) self, (VteCursorShape) g_settings_get_enum (_tmp0_, "cursor-shape"));
#line 2873 "TerminalWidget.c"
}

static void
terminal_terminal_widget_on_child_exited (TerminalTerminalWidget* self)
{
#line 562 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 563 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_child_has_exited (self, TRUE);
#line 564 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 2885 "TerminalWidget.c"
}

void
terminal_terminal_widget_kill_fg (TerminalTerminalWidget* self)
{
	gint fg_pid = 0;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
#line 567 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 569 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = terminal_terminal_widget_try_get_foreground_pid (self, &_tmp0_);
#line 569 "../src/Widgets/TerminalWidget.vala"
	fg_pid = _tmp0_;
#line 569 "../src/Widgets/TerminalWidget.vala"
	if (_tmp1_) {
#line 570 "../src/Widgets/TerminalWidget.vala"
		kill ((pid_t) fg_pid, (gint) SIGKILL);
#line 2904 "TerminalWidget.c"
	}
}

void
terminal_terminal_widget_term_ps (TerminalTerminalWidget* self)
{
	gint pid_fd = 0;
	struct pollfd pid_pfd[1] = {0};
	struct pollfd _tmp0_ = {0};
#line 573 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 574 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_killed (self, TRUE);
#line 577 "../src/Widgets/TerminalWidget.vala"
	pid_fd = syscall (TERMINAL_TERMINAL_WIDGET_SYS_PIDFD_OPEN, self->priv->child_pid, 0, NULL);
#line 582 "../src/Widgets/TerminalWidget.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGHUP);
#line 583 "../src/Widgets/TerminalWidget.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGTERM);
#line 586 "../src/Widgets/TerminalWidget.vala"
	if (pid_fd == -1) {
#line 589 "../src/Widgets/TerminalWidget.vala"
		waitpid ((pid_t) self->priv->child_pid, NULL, 0);
#line 595 "../src/Widgets/TerminalWidget.vala"
		return;
#line 2930 "TerminalWidget.c"
	}
#line 599 "../src/Widgets/TerminalWidget.vala"
	memset (&_tmp0_, 0, sizeof (struct pollfd));
#line 599 "../src/Widgets/TerminalWidget.vala"
	_tmp0_.fd = pid_fd;
#line 599 "../src/Widgets/TerminalWidget.vala"
	_tmp0_.events = POLLIN;
#line 599 "../src/Widgets/TerminalWidget.vala"
	pid_pfd[0] = _tmp0_;
#line 605 "../src/Widgets/TerminalWidget.vala"
	while (TRUE) {
#line 605 "../src/Widgets/TerminalWidget.vala"
		if (!(poll (pid_pfd, (gint) 1, -1) != 1)) {
#line 605 "../src/Widgets/TerminalWidget.vala"
			break;
#line 2946 "TerminalWidget.c"
		}
	}
#line 607 "../src/Widgets/TerminalWidget.vala"
	close (pid_fd);
#line 2951 "TerminalWidget.c"
}

void
terminal_terminal_widget_active_shell (TerminalTerminalWidget* self,
                                       const gchar* dir)
{
	gchar* shell = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar** envv = NULL;
	gint envv_length1;
	gint _envv_size_;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	GError* _inner_error0_ = NULL;
#line 610 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 610 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (dir != NULL);
#line 611 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_application_settings;
#line 611 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "shell");
#line 611 "../src/Widgets/TerminalWidget.vala"
	shell = _tmp1_;
#line 612 "../src/Widgets/TerminalWidget.vala"
	envv = NULL;
#line 612 "../src/Widgets/TerminalWidget.vala"
	envv_length1 = 0;
#line 612 "../src/Widgets/TerminalWidget.vala"
	_envv_size_ = envv_length1;
#line 614 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = shell;
#line 614 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 2991 "TerminalWidget.c"
		gchar* _tmp3_;
#line 615 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = vte_get_user_shell ();
#line 615 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (shell);
#line 615 "../src/Widgets/TerminalWidget.vala"
		shell = _tmp3_;
#line 2999 "TerminalWidget.c"
	}
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = self->terminal_id;
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = g_strconcat ("PANTHEON_TERMINAL_ID=", _tmp4_, NULL);
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = g_getenv ("PROMPT_COMMAND");
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = g_strconcat ("PROMPT_COMMAND=" TERMINAL_TERMINAL_WIDGET_SEND_PROCESS_FINISHED_BASH, _tmp6_, NULL);
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp8_ = g_new0 (gchar*, 2 + 1);
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp8_[0] = _tmp5_;
#line 617 "../src/Widgets/TerminalWidget.vala"
	_tmp8_[1] = _tmp7_;
#line 617 "../src/Widgets/TerminalWidget.vala"
	envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 617 "../src/Widgets/TerminalWidget.vala"
	envv = _tmp8_;
#line 617 "../src/Widgets/TerminalWidget.vala"
	envv_length1 = 2;
#line 617 "../src/Widgets/TerminalWidget.vala"
	_envv_size_ = envv_length1;
#line 3023 "TerminalWidget.c"
	{
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GPid _tmp14_ = 0;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp9_ = shell;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp11_ = g_new0 (gchar*, 1 + 1);
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp11_[0] = _tmp10_;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp12_ = _tmp11_;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp12__length1 = 1;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp13_ = envv;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp13__length1 = envv_length1;
#line 632 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_spawn_sync ((VteTerminal*) self, VTE_PTY_DEFAULT, dir, _tmp12_, _tmp13_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp14_, NULL, &_inner_error0_);
#line 632 "../src/Widgets/TerminalWidget.vala"
		self->priv->child_pid = _tmp14_;
#line 632 "../src/Widgets/TerminalWidget.vala"
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 632 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3057 "TerminalWidget.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 631 "../src/Widgets/TerminalWidget.vala"
		e = _inner_error0_;
#line 631 "../src/Widgets/TerminalWidget.vala"
		_inner_error0_ = NULL;
#line 635 "../src/Widgets/TerminalWidget.vala"
		_tmp15_ = e;
#line 635 "../src/Widgets/TerminalWidget.vala"
		_tmp16_ = _tmp15_->message;
#line 635 "../src/Widgets/TerminalWidget.vala"
		g_warning ("TerminalWidget.vala:635: %s", _tmp16_);
#line 631 "../src/Widgets/TerminalWidget.vala"
		_g_error_free0 (e);
#line 3079 "TerminalWidget.c"
	}
	__finally0:
#line 631 "../src/Widgets/TerminalWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 631 "../src/Widgets/TerminalWidget.vala"
		envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 631 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (shell);
#line 631 "../src/Widgets/TerminalWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 631 "../src/Widgets/TerminalWidget.vala"
		g_clear_error (&_inner_error0_);
#line 631 "../src/Widgets/TerminalWidget.vala"
		return;
#line 3094 "TerminalWidget.c"
	}
#line 638 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_check_cwd_changed (self);
#line 610 "../src/Widgets/TerminalWidget.vala"
	envv = (_vala_array_free (envv, envv_length1, (GDestroyNotify) g_free), NULL);
#line 610 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (shell);
#line 3102 "TerminalWidget.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 3139 "TerminalWidget.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 3145 "TerminalWidget.c"
}

void
terminal_terminal_widget_run_program (TerminalTerminalWidget* self,
                                      const gchar* program_string,
                                      const gchar* working_directory)
{
	GError* _inner_error0_ = NULL;
#line 641 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 641 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (program_string != NULL);
#line 3158 "TerminalWidget.c"
	{
		gchar** program_with_args = NULL;
		gint program_with_args_length1;
		gint _program_with_args_size_;
		gchar** _tmp0_ = NULL;
		gint _tmp1_ = 0;
		gchar** _tmp2_;
		gint _tmp2__length1;
		GPid _tmp3_ = 0;
#line 643 "../src/Widgets/TerminalWidget.vala"
		program_with_args = NULL;
#line 643 "../src/Widgets/TerminalWidget.vala"
		program_with_args_length1 = 0;
#line 643 "../src/Widgets/TerminalWidget.vala"
		_program_with_args_size_ = program_with_args_length1;
#line 644 "../src/Widgets/TerminalWidget.vala"
		g_shell_parse_argv (program_string, &_tmp1_, &_tmp0_, &_inner_error0_);
#line 644 "../src/Widgets/TerminalWidget.vala"
		program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 644 "../src/Widgets/TerminalWidget.vala"
		program_with_args = _tmp0_;
#line 644 "../src/Widgets/TerminalWidget.vala"
		program_with_args_length1 = _tmp1_;
#line 644 "../src/Widgets/TerminalWidget.vala"
		_program_with_args_size_ = program_with_args_length1;
#line 644 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 644 "../src/Widgets/TerminalWidget.vala"
			program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 3188 "TerminalWidget.c"
			goto __catch0_g_error;
		}
#line 646 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = program_with_args;
#line 646 "../src/Widgets/TerminalWidget.vala"
		_tmp2__length1 = program_with_args_length1;
#line 646 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_spawn_sync ((VteTerminal*) self, VTE_PTY_DEFAULT, working_directory, _tmp2_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp3_, NULL, &_inner_error0_);
#line 646 "../src/Widgets/TerminalWidget.vala"
		self->priv->child_pid = _tmp3_;
#line 646 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 646 "../src/Widgets/TerminalWidget.vala"
			program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 3203 "TerminalWidget.c"
			goto __catch0_g_error;
		}
#line 642 "../src/Widgets/TerminalWidget.vala"
		program_with_args = (_vala_array_free (program_with_args, program_with_args_length1, (GDestroyNotify) g_free), NULL);
#line 3208 "TerminalWidget.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		guint8* _tmp10_;
		gint _tmp10__length1;
		gint _tmp11_ = 0;
		guint8* _tmp12_;
		gint _tmp12__length1;
#line 642 "../src/Widgets/TerminalWidget.vala"
		e = _inner_error0_;
#line 642 "../src/Widgets/TerminalWidget.vala"
		_inner_error0_ = NULL;
#line 649 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = e;
#line 649 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = _tmp4_->message;
#line 649 "../src/Widgets/TerminalWidget.vala"
		g_warning ("TerminalWidget.vala:649: %s", _tmp5_);
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = e;
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp7_ = _tmp6_->message;
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp8_ = g_strconcat (_tmp7_, "\r\n\r\n", NULL);
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp9_ = _tmp8_;
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp10_ = string_get_data (_tmp9_, &_tmp11_);
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp10__length1 = _tmp11_;
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp12_ = _tmp10_;
#line 650 "../src/Widgets/TerminalWidget.vala"
		_tmp12__length1 = _tmp10__length1;
#line 650 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_feed ((VteTerminal*) self, _tmp12_, (gssize) _tmp12__length1);
#line 650 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp9_);
#line 651 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_active_shell (self, working_directory);
#line 642 "../src/Widgets/TerminalWidget.vala"
		_g_error_free0 (e);
#line 3259 "TerminalWidget.c"
	}
	__finally0:
#line 642 "../src/Widgets/TerminalWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 642 "../src/Widgets/TerminalWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 642 "../src/Widgets/TerminalWidget.vala"
		g_clear_error (&_inner_error0_);
#line 642 "../src/Widgets/TerminalWidget.vala"
		return;
#line 3270 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_try_get_foreground_pid (TerminalTerminalWidget* self,
                                                 gint* pid)
{
	gint _vala_pid = 0;
	gboolean _tmp0_;
	gint pty = 0;
	VtePty* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint fgpid = 0;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 655 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 656 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_child_has_exited;
#line 656 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 657 "../src/Widgets/TerminalWidget.vala"
		_vala_pid = -1;
#line 658 "../src/Widgets/TerminalWidget.vala"
		result = FALSE;
#line 658 "../src/Widgets/TerminalWidget.vala"
		if (pid) {
#line 658 "../src/Widgets/TerminalWidget.vala"
			*pid = _vala_pid;
#line 3301 "TerminalWidget.c"
		}
#line 658 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 3305 "TerminalWidget.c"
	}
#line 661 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = vte_terminal_get_pty ((VteTerminal*) self);
#line 661 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = vte_pty_get_fd (_tmp1_);
#line 661 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _tmp2_;
#line 661 "../src/Widgets/TerminalWidget.vala"
	pty = _tmp3_;
#line 662 "../src/Widgets/TerminalWidget.vala"
	fgpid = (gint) tcgetpgrp (pty);
#line 664 "../src/Widgets/TerminalWidget.vala"
	if (fgpid != ((gint) self->priv->child_pid)) {
#line 664 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = fgpid != -1;
#line 3321 "TerminalWidget.c"
	} else {
#line 664 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = FALSE;
#line 3325 "TerminalWidget.c"
	}
#line 664 "../src/Widgets/TerminalWidget.vala"
	if (_tmp4_) {
#line 665 "../src/Widgets/TerminalWidget.vala"
		_vala_pid = (gint) fgpid;
#line 666 "../src/Widgets/TerminalWidget.vala"
		result = TRUE;
#line 666 "../src/Widgets/TerminalWidget.vala"
		if (pid) {
#line 666 "../src/Widgets/TerminalWidget.vala"
			*pid = _vala_pid;
#line 3337 "TerminalWidget.c"
		}
#line 666 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 3341 "TerminalWidget.c"
	} else {
#line 668 "../src/Widgets/TerminalWidget.vala"
		_vala_pid = -1;
#line 669 "../src/Widgets/TerminalWidget.vala"
		result = FALSE;
#line 669 "../src/Widgets/TerminalWidget.vala"
		if (pid) {
#line 669 "../src/Widgets/TerminalWidget.vala"
			*pid = _vala_pid;
#line 3351 "TerminalWidget.c"
		}
#line 669 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 3355 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_has_foreground_process (TerminalTerminalWidget* self)
{
	gboolean result;
#line 673 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 674 "../src/Widgets/TerminalWidget.vala"
	result = terminal_terminal_widget_try_get_foreground_pid (self, NULL);
#line 674 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3369 "TerminalWidget.c"
}

gint
terminal_terminal_widget_calculate_width (TerminalTerminalWidget* self,
                                          gint column_count)
{
	gint width = 0;
	gint result;
#line 677 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 678 "../src/Widgets/TerminalWidget.vala"
	width = ((gint) vte_terminal_get_char_width ((VteTerminal*) self)) * column_count;
#line 679 "../src/Widgets/TerminalWidget.vala"
	result = width;
#line 679 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3386 "TerminalWidget.c"
}

gint
terminal_terminal_widget_calculate_height (TerminalTerminalWidget* self,
                                           gint row_count)
{
	gint height = 0;
	gint result;
#line 682 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 683 "../src/Widgets/TerminalWidget.vala"
	height = ((gint) vte_terminal_get_char_height ((VteTerminal*) self)) * row_count;
#line 684 "../src/Widgets/TerminalWidget.vala"
	result = height;
#line 684 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3403 "TerminalWidget.c"
}

static void
terminal_terminal_widget_clickable (TerminalTerminalWidget* self,
                                    gchar** str,
                                    gint str_length1)
{
	GError* _inner_error0_ = NULL;
#line 687 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 3414 "TerminalWidget.c"
	{
		gchar** exp_collection = NULL;
		gint exp_collection_length1 = 0;
		gint _exp_collection_size_ = 0;
		gint exp_it = 0;
#line 688 "../src/Widgets/TerminalWidget.vala"
		exp_collection = str;
#line 688 "../src/Widgets/TerminalWidget.vala"
		exp_collection_length1 = str_length1;
#line 688 "../src/Widgets/TerminalWidget.vala"
		for (exp_it = 0; exp_it < exp_collection_length1; exp_it = exp_it + 1) {
#line 3426 "TerminalWidget.c"
			const gchar* exp = NULL;
#line 688 "../src/Widgets/TerminalWidget.vala"
			exp = exp_collection[exp_it];
#line 3430 "TerminalWidget.c"
			{
				{
					VteRegex* regex = NULL;
					const gchar* _tmp0_;
					VteRegex* _tmp1_;
					gint id = 0;
					VteRegex* _tmp2_;
#line 690 "../src/Widgets/TerminalWidget.vala"
					_tmp0_ = exp;
#line 690 "../src/Widgets/TerminalWidget.vala"
					_tmp1_ = vte_regex_new_for_match (_tmp0_, (gssize) -1, (guint32) PCRE2_MULTILINE, &_inner_error0_);
#line 690 "../src/Widgets/TerminalWidget.vala"
					regex = _tmp1_;
#line 690 "../src/Widgets/TerminalWidget.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3446 "TerminalWidget.c"
						goto __catch0_g_error;
					}
#line 691 "../src/Widgets/TerminalWidget.vala"
					_tmp2_ = regex;
#line 691 "../src/Widgets/TerminalWidget.vala"
					id = vte_terminal_match_add_regex ((VteTerminal*) self, _tmp2_, (guint32) 0);
#line 692 "../src/Widgets/TerminalWidget.vala"
					vte_terminal_match_set_cursor_name ((VteTerminal*) self, id, "pointer");
#line 689 "../src/Widgets/TerminalWidget.vala"
					_vte_regex_unref0 (regex);
#line 3457 "TerminalWidget.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* _error_ = NULL;
					GError* _tmp3_;
					const gchar* _tmp4_;
#line 689 "../src/Widgets/TerminalWidget.vala"
					_error_ = _inner_error0_;
#line 689 "../src/Widgets/TerminalWidget.vala"
					_inner_error0_ = NULL;
#line 694 "../src/Widgets/TerminalWidget.vala"
					_tmp3_ = _error_;
#line 694 "../src/Widgets/TerminalWidget.vala"
					_tmp4_ = _tmp3_->message;
#line 694 "../src/Widgets/TerminalWidget.vala"
					g_warning ("TerminalWidget.vala:694: %s", _tmp4_);
#line 689 "../src/Widgets/TerminalWidget.vala"
					_g_error_free0 (_error_);
#line 3477 "TerminalWidget.c"
				}
				__finally0:
#line 689 "../src/Widgets/TerminalWidget.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 689 "../src/Widgets/TerminalWidget.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 689 "../src/Widgets/TerminalWidget.vala"
					g_clear_error (&_inner_error0_);
#line 689 "../src/Widgets/TerminalWidget.vala"
					return;
#line 3488 "TerminalWidget.c"
				}
			}
		}
	}
}

static gchar*
terminal_terminal_widget_get_link (TerminalTerminalWidget* self,
                                   GdkEvent* event)
{
	gchar* _tmp0_;
	gchar* result;
#line 699 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 699 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (event != NULL, NULL);
#line 700 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_match_check_event ((VteTerminal*) self, event, NULL);
#line 700 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 700 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3511 "TerminalWidget.c"
}

gchar*
terminal_terminal_widget_get_shell_location (TerminalTerminalWidget* self)
{
	gint pid = 0;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 703 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 704 "../src/Widgets/TerminalWidget.vala"
	pid = (gint) ((GPid) self->priv->child_pid);
#line 3524 "TerminalWidget.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = g_strdup_printf ("/proc/%d/cwd", pid);
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = _tmp1_;
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = g_file_read_link (_tmp2_, &_inner_error0_);
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = _tmp3_;
#line 707 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp2_);
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = _tmp4_;
#line 707 "../src/Widgets/TerminalWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "../src/Widgets/TerminalWidget.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3548 "TerminalWidget.c"
				goto __catch0_g_file_error;
			}
#line 707 "../src/Widgets/TerminalWidget.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 707 "../src/Widgets/TerminalWidget.vala"
			g_clear_error (&_inner_error0_);
#line 707 "../src/Widgets/TerminalWidget.vala"
			return NULL;
#line 3557 "TerminalWidget.c"
		}
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp5_ = _tmp0_;
#line 707 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = NULL;
#line 707 "../src/Widgets/TerminalWidget.vala"
		result = _tmp5_;
#line 707 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_tmp0_);
#line 707 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 3569 "TerminalWidget.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		gchar* _tmp6_;
#line 706 "../src/Widgets/TerminalWidget.vala"
		g_clear_error (&_inner_error0_);
#line 711 "../src/Widgets/TerminalWidget.vala"
		_tmp6_ = g_strdup ("");
#line 711 "../src/Widgets/TerminalWidget.vala"
		result = _tmp6_;
#line 711 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 3583 "TerminalWidget.c"
	}
	__finally0:
#line 706 "../src/Widgets/TerminalWidget.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 706 "../src/Widgets/TerminalWidget.vala"
	g_clear_error (&_inner_error0_);
#line 706 "../src/Widgets/TerminalWidget.vala"
	return NULL;
#line 3592 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_increase_font_size (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 715 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 716 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 716 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 716 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, _tmp1_ + 0.1);
#line 3609 "TerminalWidget.c"
}

static void
terminal_terminal_widget_real_decrease_font_size (VteTerminal* base)
{
	TerminalTerminalWidget * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 719 "../src/Widgets/TerminalWidget.vala"
	self = (TerminalTerminalWidget*) base;
#line 720 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 720 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _tmp0_;
#line 720 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, _tmp1_ - 0.1);
#line 3626 "TerminalWidget.c"
}

gboolean
terminal_terminal_widget_is_init_complete (TerminalTerminalWidget* self)
{
	gboolean result;
#line 723 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 724 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->init_complete;
#line 724 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 3639 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_init_complete (TerminalTerminalWidget* self)
{
#line 727 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 728 "../src/Widgets/TerminalWidget.vala"
	self->priv->init_complete = TRUE;
#line 3649 "TerminalWidget.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 3663 "TerminalWidget.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 3667 "TerminalWidget.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 3673 "TerminalWidget.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 3678 "TerminalWidget.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 3684 "TerminalWidget.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 3688 "TerminalWidget.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 3692 "TerminalWidget.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 3696 "TerminalWidget.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3700 "TerminalWidget.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3704 "TerminalWidget.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 3719 "TerminalWidget.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 3728 "TerminalWidget.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 3735 "TerminalWidget.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 3741 "TerminalWidget.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 3749 "TerminalWidget.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 3753 "TerminalWidget.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 3759 "TerminalWidget.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 3764 "TerminalWidget.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 3770 "TerminalWidget.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 3774 "TerminalWidget.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 3778 "TerminalWidget.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 3784 "TerminalWidget.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 3790 "TerminalWidget.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 3802 "TerminalWidget.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 3806 "TerminalWidget.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 3810 "TerminalWidget.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 3815 "TerminalWidget.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 3823 "TerminalWidget.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 3841 "TerminalWidget.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 3847 "TerminalWidget.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 3851 "TerminalWidget.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 3859 "TerminalWidget.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 3868 "TerminalWidget.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 3877 "TerminalWidget.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 3883 "TerminalWidget.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 3891 "TerminalWidget.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 3903 "TerminalWidget.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 3909 "TerminalWidget.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 3913 "TerminalWidget.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 3921 "TerminalWidget.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 3932 "TerminalWidget.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 3941 "TerminalWidget.c"
	}
}

void
terminal_terminal_widget_drag_received (TerminalTerminalWidget* self,
                                        GdkDragContext* context,
                                        gint x,
                                        gint y,
                                        GtkSelectionData* selection_data,
                                        guint target_type,
                                        guint time_)
{
#line 731 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 731 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (context != NULL);
#line 731 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (selection_data != NULL);
#line 733 "../src/Widgets/TerminalWidget.vala"
	switch (target_type) {
#line 733 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_URILIST:
#line 3964 "TerminalWidget.c"
		{
			gchar** uris = NULL;
			gchar** _tmp0_;
			gchar** _tmp1_;
			gint uris_length1;
			gint _uris_size_;
			gchar* path = NULL;
			GFile* file = NULL;
			gchar* uris_s = NULL;
			gchar** _tmp16_;
			gint _tmp16__length1;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			guint8* _tmp19_;
			gint _tmp19__length1;
			gint _tmp20_ = 0;
			guint8* _tmp21_;
			gint _tmp21__length1;
#line 735 "../src/Widgets/TerminalWidget.vala"
			_tmp1_ = _tmp0_ = gtk_selection_data_get_uris (selection_data);
#line 735 "../src/Widgets/TerminalWidget.vala"
			uris = _tmp1_;
#line 735 "../src/Widgets/TerminalWidget.vala"
			uris_length1 = _vala_array_length (_tmp0_);
#line 735 "../src/Widgets/TerminalWidget.vala"
			_uris_size_ = uris_length1;
#line 3991 "TerminalWidget.c"
			{
				gint i = 0;
#line 739 "../src/Widgets/TerminalWidget.vala"
				i = 0;
#line 3996 "TerminalWidget.c"
				{
					gboolean _tmp2_ = FALSE;
#line 739 "../src/Widgets/TerminalWidget.vala"
					_tmp2_ = TRUE;
#line 739 "../src/Widgets/TerminalWidget.vala"
					while (TRUE) {
#line 4003 "TerminalWidget.c"
						gchar** _tmp4_;
						gint _tmp4__length1;
						gchar** _tmp5_;
						gint _tmp5__length1;
						const gchar* _tmp6_;
						GFile* _tmp7_;
						GFile* _tmp8_;
						gchar* _tmp9_;
						const gchar* _tmp10_;
#line 739 "../src/Widgets/TerminalWidget.vala"
						if (!_tmp2_) {
#line 4015 "TerminalWidget.c"
							gint _tmp3_;
#line 739 "../src/Widgets/TerminalWidget.vala"
							_tmp3_ = i;
#line 739 "../src/Widgets/TerminalWidget.vala"
							i = _tmp3_ + 1;
#line 4021 "TerminalWidget.c"
						}
#line 739 "../src/Widgets/TerminalWidget.vala"
						_tmp2_ = FALSE;
#line 739 "../src/Widgets/TerminalWidget.vala"
						_tmp4_ = uris;
#line 739 "../src/Widgets/TerminalWidget.vala"
						_tmp4__length1 = uris_length1;
#line 739 "../src/Widgets/TerminalWidget.vala"
						if (!(i < _tmp4__length1)) {
#line 739 "../src/Widgets/TerminalWidget.vala"
							break;
#line 4033 "TerminalWidget.c"
						}
#line 740 "../src/Widgets/TerminalWidget.vala"
						_tmp5_ = uris;
#line 740 "../src/Widgets/TerminalWidget.vala"
						_tmp5__length1 = uris_length1;
#line 740 "../src/Widgets/TerminalWidget.vala"
						_tmp6_ = _tmp5_[i];
#line 740 "../src/Widgets/TerminalWidget.vala"
						_tmp7_ = g_file_new_for_uri (_tmp6_);
#line 740 "../src/Widgets/TerminalWidget.vala"
						_g_object_unref0 (file);
#line 740 "../src/Widgets/TerminalWidget.vala"
						file = _tmp7_;
#line 741 "../src/Widgets/TerminalWidget.vala"
						_tmp8_ = file;
#line 741 "../src/Widgets/TerminalWidget.vala"
						_tmp9_ = g_file_get_path (_tmp8_);
#line 741 "../src/Widgets/TerminalWidget.vala"
						_g_free0 (path);
#line 741 "../src/Widgets/TerminalWidget.vala"
						path = _tmp9_;
#line 741 "../src/Widgets/TerminalWidget.vala"
						_tmp10_ = path;
#line 741 "../src/Widgets/TerminalWidget.vala"
						if (_tmp10_ != NULL) {
#line 4059 "TerminalWidget.c"
							gchar** _tmp11_;
							gint _tmp11__length1;
							const gchar* _tmp12_;
							gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp11_ = uris;
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp11__length1 = uris_length1;
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp12_ = path;
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp13_ = g_shell_quote (_tmp12_);
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp14_ = _tmp13_;
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp15_ = g_strconcat (_tmp14_, " ", NULL);
#line 742 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (_tmp11_[i]);
#line 742 "../src/Widgets/TerminalWidget.vala"
							_tmp11_[i] = _tmp15_;
#line 742 "../src/Widgets/TerminalWidget.vala"
							_g_free0 (_tmp14_);
#line 4084 "TerminalWidget.c"
						}
					}
				}
			}
#line 746 "../src/Widgets/TerminalWidget.vala"
			_tmp16_ = uris;
#line 746 "../src/Widgets/TerminalWidget.vala"
			_tmp16__length1 = uris_length1;
#line 746 "../src/Widgets/TerminalWidget.vala"
			_tmp17_ = _vala_g_strjoinv ("", _tmp16_, (gint) _tmp16__length1);
#line 746 "../src/Widgets/TerminalWidget.vala"
			uris_s = _tmp17_;
#line 747 "../src/Widgets/TerminalWidget.vala"
			_tmp18_ = uris_s;
#line 747 "../src/Widgets/TerminalWidget.vala"
			_tmp19_ = string_get_data (_tmp18_, &_tmp20_);
#line 747 "../src/Widgets/TerminalWidget.vala"
			_tmp19__length1 = _tmp20_;
#line 747 "../src/Widgets/TerminalWidget.vala"
			_tmp21_ = _tmp19_;
#line 747 "../src/Widgets/TerminalWidget.vala"
			_tmp21__length1 = _tmp19__length1;
#line 747 "../src/Widgets/TerminalWidget.vala"
			vte_terminal_feed_child ((VteTerminal*) self, _tmp21_, (gssize) _tmp21__length1);
#line 748 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (uris_s);
#line 748 "../src/Widgets/TerminalWidget.vala"
			_g_object_unref0 (file);
#line 748 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (path);
#line 748 "../src/Widgets/TerminalWidget.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 748 "../src/Widgets/TerminalWidget.vala"
			break;
#line 4119 "TerminalWidget.c"
		}
#line 733 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_STRING:
#line 733 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_DROP_TARGETS_TEXT:
#line 4125 "TerminalWidget.c"
		{
			gchar* data = NULL;
			gchar* _tmp22_;
			const gchar* _tmp23_;
#line 751 "../src/Widgets/TerminalWidget.vala"
			_tmp22_ = gtk_selection_data_get_text (selection_data);
#line 751 "../src/Widgets/TerminalWidget.vala"
			data = _tmp22_;
#line 753 "../src/Widgets/TerminalWidget.vala"
			_tmp23_ = data;
#line 753 "../src/Widgets/TerminalWidget.vala"
			if (_tmp23_ != NULL) {
#line 4138 "TerminalWidget.c"
				const gchar* _tmp24_;
				guint8* _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_ = 0;
				guint8* _tmp27_;
				gint _tmp27__length1;
#line 754 "../src/Widgets/TerminalWidget.vala"
				_tmp24_ = data;
#line 754 "../src/Widgets/TerminalWidget.vala"
				_tmp25_ = string_get_data (_tmp24_, &_tmp26_);
#line 754 "../src/Widgets/TerminalWidget.vala"
				_tmp25__length1 = _tmp26_;
#line 754 "../src/Widgets/TerminalWidget.vala"
				_tmp27_ = _tmp25_;
#line 754 "../src/Widgets/TerminalWidget.vala"
				_tmp27__length1 = _tmp25__length1;
#line 754 "../src/Widgets/TerminalWidget.vala"
				vte_terminal_feed_child ((VteTerminal*) self, _tmp27_, (gssize) _tmp27__length1);
#line 4157 "TerminalWidget.c"
			}
#line 757 "../src/Widgets/TerminalWidget.vala"
			_g_free0 (data);
#line 757 "../src/Widgets/TerminalWidget.vala"
			break;
#line 4163 "TerminalWidget.c"
		}
		default:
#line 733 "../src/Widgets/TerminalWidget.vala"
		break;
#line 4168 "TerminalWidget.c"
	}
}

void
terminal_terminal_widget_remember_position (TerminalTerminalWidget* self)
{
	glong col = 0L;
	glong row = 0L;
	glong _tmp0_ = 0L;
	glong _tmp1_ = 0L;
#line 761 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 763 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp0_, &_tmp1_);
#line 763 "../src/Widgets/TerminalWidget.vala"
	col = _tmp0_;
#line 763 "../src/Widgets/TerminalWidget.vala"
	row = _tmp1_;
#line 764 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_position = row;
#line 4189 "TerminalWidget.c"
}

void
terminal_terminal_widget_remember_command_start_position (TerminalTerminalWidget* self)
{
	gboolean _tmp0_ = FALSE;
	glong col = 0L;
	glong row = 0L;
	glong _tmp1_ = 0L;
	glong _tmp2_ = 0L;
#line 767 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 768 "../src/Widgets/TerminalWidget.vala"
	if (!self->last_key_was_return) {
#line 768 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = TRUE;
#line 4206 "TerminalWidget.c"
	} else {
#line 768 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = terminal_terminal_widget_has_foreground_process (self);
#line 4210 "TerminalWidget.c"
	}
#line 768 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 769 "../src/Widgets/TerminalWidget.vala"
		return;
#line 4216 "TerminalWidget.c"
	}
#line 773 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp1_, &_tmp2_);
#line 773 "../src/Widgets/TerminalWidget.vala"
	col = _tmp1_;
#line 773 "../src/Widgets/TerminalWidget.vala"
	row = _tmp2_;
#line 774 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_command_start_row = row;
#line 775 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = FALSE;
#line 776 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_set_resized (self, FALSE);
#line 4230 "TerminalWidget.c"
}

void
terminal_terminal_widget_remember_command_end_position (TerminalTerminalWidget* self)
{
	gboolean _tmp0_ = FALSE;
	glong col = 0L;
	glong row = 0L;
	glong _tmp1_ = 0L;
	glong _tmp2_ = 0L;
#line 779 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 780 "../src/Widgets/TerminalWidget.vala"
	if (self->last_key_was_return) {
#line 780 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = !terminal_terminal_widget_has_foreground_process (self);
#line 4247 "TerminalWidget.c"
	} else {
#line 780 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = FALSE;
#line 4251 "TerminalWidget.c"
	}
#line 780 "../src/Widgets/TerminalWidget.vala"
	if (_tmp0_) {
#line 781 "../src/Widgets/TerminalWidget.vala"
		return;
#line 4257 "TerminalWidget.c"
	}
#line 785 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp1_, &_tmp2_);
#line 785 "../src/Widgets/TerminalWidget.vala"
	col = _tmp1_;
#line 785 "../src/Widgets/TerminalWidget.vala"
	row = _tmp2_;
#line 788 "../src/Widgets/TerminalWidget.vala"
	if ((row - self->priv->remembered_command_end_row) <= ((glong) 2)) {
#line 789 "../src/Widgets/TerminalWidget.vala"
		self->priv->remembered_command_end_row = row;
#line 4269 "TerminalWidget.c"
	}
#line 792 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 4273 "TerminalWidget.c"
}

gchar*
terminal_terminal_widget_get_last_output (TerminalTerminalWidget* self,
                                          gboolean include_command)
{
	glong output_end_col = 0L;
	glong output_end_row = 0L;
	glong start_row = 0L;
	glong _tmp0_ = 0L;
	glong _tmp1_ = 0L;
	glong command_lines = 0L;
	glong _tmp2_ = 0L;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 795 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 797 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, &_tmp0_, &_tmp1_);
#line 797 "../src/Widgets/TerminalWidget.vala"
	output_end_col = _tmp0_;
#line 797 "../src/Widgets/TerminalWidget.vala"
	output_end_row = _tmp1_;
#line 799 "../src/Widgets/TerminalWidget.vala"
	command_lines = self->priv->remembered_command_end_row - self->priv->remembered_command_start_row;
#line 801 "../src/Widgets/TerminalWidget.vala"
	if (!include_command) {
#line 802 "../src/Widgets/TerminalWidget.vala"
		start_row = self->priv->remembered_command_end_row + 1;
#line 4306 "TerminalWidget.c"
	} else {
#line 804 "../src/Widgets/TerminalWidget.vala"
		start_row = self->priv->remembered_command_start_row;
#line 4310 "TerminalWidget.c"
	}
#line 807 "../src/Widgets/TerminalWidget.vala"
	if (include_command) {
#line 807 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = command_lines + 1;
#line 4316 "TerminalWidget.c"
	} else {
#line 807 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = (glong) 1;
#line 4320 "TerminalWidget.c"
	}
#line 807 "../src/Widgets/TerminalWidget.vala"
	if ((output_end_row - start_row) < _tmp2_) {
#line 4324 "TerminalWidget.c"
		gchar* _tmp3_;
#line 808 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = g_strdup ("");
#line 808 "../src/Widgets/TerminalWidget.vala"
		result = _tmp3_;
#line 808 "../src/Widgets/TerminalWidget.vala"
		return result;
#line 4332 "TerminalWidget.c"
	}
#line 811 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 817 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = vte_terminal_get_text_range ((VteTerminal*) self, start_row, (glong) 0, output_end_row - 1, (glong) 1000, NULL, NULL, NULL);
#line 817 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = _tmp4_;
#line 817 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
#line 817 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = _tmp6_;
#line 817 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (_tmp5_);
#line 817 "../src/Widgets/TerminalWidget.vala"
	result = _tmp7_;
#line 817 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4350 "TerminalWidget.c"
}

static void
terminal_terminal_widget_scroll_to_command (TerminalTerminalWidget* self,
                                            GSimpleAction* action,
                                            GVariant* parameter)
{
	glong row = 0L;
	glong delta = 0L;
	glong _tmp0_ = 0L;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	GtkAdjustment* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	GdkWindow* _tmp7_;
#line 820 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 820 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (action != NULL);
#line 823 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_get_cursor_position ((VteTerminal*) self, NULL, &_tmp0_);
#line 823 "../src/Widgets/TerminalWidget.vala"
	row = _tmp0_;
#line 824 "../src/Widgets/TerminalWidget.vala"
	delta = self->priv->remembered_position - row;
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) self);
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _tmp1_;
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) self);
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = _tmp3_;
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = _tmp5_;
#line 826 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = gtk_widget_get_window ((GtkWidget*) self);
#line 826 "../src/Widgets/TerminalWidget.vala"
	gtk_adjustment_set_value (_tmp4_, _tmp6_ + ((((gint) delta) + (gdk_window_get_height (_tmp7_) / vte_terminal_get_char_height ((VteTerminal*) self))) - 1));
#line 827 "../src/Widgets/TerminalWidget.vala"
	g_simple_action_set_enabled (action, FALSE);
#line 4396 "TerminalWidget.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 830 "../src/Widgets/TerminalWidget.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 830 "../src/Widgets/TerminalWidget.vala"
	return _data5_;
#line 4406 "TerminalWidget.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 830 "../src/Widgets/TerminalWidget.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4416 "TerminalWidget.c"
		TerminalTerminalWidget* self;
#line 830 "../src/Widgets/TerminalWidget.vala"
		self = _data5_->self;
#line 830 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (_data5_->old_loc);
#line 830 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (self);
#line 830 "../src/Widgets/TerminalWidget.vala"
		g_slice_free (Block5Data, _data5_);
#line 4426 "TerminalWidget.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 833 "../src/Widgets/TerminalWidget.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 833 "../src/Widgets/TerminalWidget.vala"
	return _data6_;
#line 4437 "TerminalWidget.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 833 "../src/Widgets/TerminalWidget.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 4447 "TerminalWidget.c"
		TerminalTerminalWidget* self;
#line 833 "../src/Widgets/TerminalWidget.vala"
		self = _data6_->_data5_->self;
#line 833 "../src/Widgets/TerminalWidget.vala"
		_g_object_unref0 (_data6_->dialog);
#line 833 "../src/Widgets/TerminalWidget.vala"
		block5_data_unref (_data6_->_data5_);
#line 833 "../src/Widgets/TerminalWidget.vala"
		_data6_->_data5_ = NULL;
#line 833 "../src/Widgets/TerminalWidget.vala"
		g_slice_free (Block6Data, _data6_);
#line 4459 "TerminalWidget.c"
	}
}

static void
___lambda12_ (Block6Data* _data6_,
              gint res)
{
	Block5Data* _data5_;
	TerminalTerminalWidget* self;
	TerminalForegroundProcessDialog* _tmp1_;
#line 835 "../src/Widgets/TerminalWidget.vala"
	_data5_ = _data6_->_data5_;
#line 835 "../src/Widgets/TerminalWidget.vala"
	self = _data5_->self;
#line 836 "../src/Widgets/TerminalWidget.vala"
	if (res == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 4476 "TerminalWidget.c"
		const gchar* _tmp0_;
#line 837 "../src/Widgets/TerminalWidget.vala"
		kill ((pid_t) self->priv->child_pid, (gint) SIGTERM);
#line 838 "../src/Widgets/TerminalWidget.vala"
		vte_terminal_reset ((VteTerminal*) self, TRUE, TRUE);
#line 839 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = _data5_->old_loc;
#line 839 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_active_shell (self, _tmp0_);
#line 4486 "TerminalWidget.c"
	}
#line 842 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = _data6_->dialog;
#line 842 "../src/Widgets/TerminalWidget.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp1_);
#line 4492 "TerminalWidget.c"
}

static void
____lambda12__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 835 "../src/Widgets/TerminalWidget.vala"
	___lambda12_ (self, response_id);
#line 4502 "TerminalWidget.c"
}

void
terminal_terminal_widget_reload (TerminalTerminalWidget* self)
{
	Block5Data* _data5_;
	gchar* _tmp0_;
	const gchar* _tmp5_;
#line 830 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 830 "../src/Widgets/TerminalWidget.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 830 "../src/Widgets/TerminalWidget.vala"
	_data5_->_ref_count_ = 1;
#line 830 "../src/Widgets/TerminalWidget.vala"
	_data5_->self = g_object_ref (self);
#line 831 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_get_shell_location (self);
#line 831 "../src/Widgets/TerminalWidget.vala"
	_data5_->old_loc = _tmp0_;
#line 833 "../src/Widgets/TerminalWidget.vala"
	if (terminal_terminal_widget_has_foreground_process (self)) {
#line 4525 "TerminalWidget.c"
		Block6Data* _data6_;
		GtkWidget* _tmp1_;
		TerminalForegroundProcessDialog* _tmp2_;
		TerminalForegroundProcessDialog* _tmp3_;
		TerminalForegroundProcessDialog* _tmp4_;
#line 833 "../src/Widgets/TerminalWidget.vala"
		_data6_ = g_slice_new0 (Block6Data);
#line 833 "../src/Widgets/TerminalWidget.vala"
		_data6_->_ref_count_ = 1;
#line 833 "../src/Widgets/TerminalWidget.vala"
		_data6_->_data5_ = block5_data_ref (_data5_);
#line 834 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 834 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = terminal_foreground_process_dialog_new_before_tab_reload (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TERMINAL_TYPE_MAIN_WINDOW, TerminalMainWindow));
#line 834 "../src/Widgets/TerminalWidget.vala"
		g_object_ref_sink (_tmp2_);
#line 834 "../src/Widgets/TerminalWidget.vala"
		_data6_->dialog = _tmp2_;
#line 835 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = _data6_->dialog;
#line 835 "../src/Widgets/TerminalWidget.vala"
		g_signal_connect_data ((GtkDialog*) _tmp3_, "response", (GCallback) ____lambda12__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 845 "../src/Widgets/TerminalWidget.vala"
		_tmp4_ = _data6_->dialog;
#line 845 "../src/Widgets/TerminalWidget.vala"
		gtk_window_present ((GtkWindow*) _tmp4_);
#line 846 "../src/Widgets/TerminalWidget.vala"
		block6_data_unref (_data6_);
#line 846 "../src/Widgets/TerminalWidget.vala"
		_data6_ = NULL;
#line 846 "../src/Widgets/TerminalWidget.vala"
		block5_data_unref (_data5_);
#line 846 "../src/Widgets/TerminalWidget.vala"
		_data5_ = NULL;
#line 846 "../src/Widgets/TerminalWidget.vala"
		return;
#line 4563 "TerminalWidget.c"
	}
#line 849 "../src/Widgets/TerminalWidget.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGTERM);
#line 850 "../src/Widgets/TerminalWidget.vala"
	vte_terminal_reset ((VteTerminal*) self, TRUE, TRUE);
#line 851 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = _data5_->old_loc;
#line 851 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_active_shell (self, _tmp5_);
#line 830 "../src/Widgets/TerminalWidget.vala"
	block5_data_unref (_data5_);
#line 830 "../src/Widgets/TerminalWidget.vala"
	_data5_ = NULL;
#line 4577 "TerminalWidget.c"
}

static void
terminal_terminal_widget_check_cwd_changed (TerminalTerminalWidget* self)
{
	gchar* cwd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 854 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 855 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = terminal_terminal_widget_get_shell_location (self);
#line 855 "../src/Widgets/TerminalWidget.vala"
	cwd = _tmp0_;
#line 856 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = cwd;
#line 856 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = self->priv->_current_working_directory;
#line 856 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) != 0) {
#line 4599 "TerminalWidget.c"
		const gchar* _tmp3_;
#line 857 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = cwd;
#line 857 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_current_working_directory (self, _tmp3_);
#line 858 "../src/Widgets/TerminalWidget.vala"
		g_signal_emit (self, terminal_terminal_widget_signals[TERMINAL_TERMINAL_WIDGET_CWD_CHANGED_SIGNAL], 0);
#line 4607 "TerminalWidget.c"
	}
#line 854 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (cwd);
#line 4611 "TerminalWidget.c"
}

const gchar*
terminal_terminal_widget_get_current_working_directory (TerminalTerminalWidget* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_current_working_directory;
#line 31 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4627 "TerminalWidget.c"
}

static void
terminal_terminal_widget_set_current_working_directory (TerminalTerminalWidget* self,
                                                        const gchar* value)
{
	gchar* old_value;
#line 31 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_current_working_directory (self);
#line 31 "../src/Widgets/TerminalWidget.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4641 "TerminalWidget.c"
		gchar* _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (self->priv->_current_working_directory);
#line 31 "../src/Widgets/TerminalWidget.vala"
		self->priv->_current_working_directory = _tmp0_;
#line 31 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY]);
#line 4651 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_get_resized (TerminalTerminalWidget* self)
{
	gboolean result;
#line 34 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->_resized;
#line 34 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4665 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_resized (TerminalTerminalWidget* self,
                                      gboolean value)
{
	gboolean old_value;
#line 34 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_resized (self);
#line 34 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 34 "../src/Widgets/TerminalWidget.vala"
		self->priv->_resized = value;
#line 34 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY]);
#line 4683 "TerminalWidget.c"
	}
}

TerminalMainWindow*
terminal_terminal_widget_get_window (TerminalTerminalWidget* self)
{
	TerminalMainWindow* result;
	TerminalMainWindow* _tmp0_;
#line 40 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_window;
#line 41 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 41 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4700 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_window (TerminalTerminalWidget* self,
                                     TerminalMainWindow* value)
{
	TerminalMainWindow* _tmp0_;
	TerminalApplication* _tmp1_;
	TerminalApplication* _tmp2_;
	TerminalApplication* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
#line 44 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->_window);
#line 45 "../src/Widgets/TerminalWidget.vala"
	self->priv->_window = _tmp0_;
#line 46 "../src/Widgets/TerminalWidget.vala"
	_tmp1_ = terminal_main_window_get_app (value);
#line 46 "../src/Widgets/TerminalWidget.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/Widgets/TerminalWidget.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 46 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->app);
#line 46 "../src/Widgets/TerminalWidget.vala"
	self->app = _tmp3_;
#line 47 "../src/Widgets/TerminalWidget.vala"
	_tmp4_ = terminal_main_window_get_menu (value);
#line 47 "../src/Widgets/TerminalWidget.vala"
	_tmp5_ = _tmp4_;
#line 47 "../src/Widgets/TerminalWidget.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 47 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->menu);
#line 47 "../src/Widgets/TerminalWidget.vala"
	self->priv->menu = _tmp6_;
#line 48 "../src/Widgets/TerminalWidget.vala"
	_tmp7_ = self->priv->menu;
#line 48 "../src/Widgets/TerminalWidget.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp7_);
#line 44 "../src/Widgets/TerminalWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_WINDOW_PROPERTY]);
#line 4749 "TerminalWidget.c"
}

const gchar*
terminal_terminal_widget_get_tab_label (TerminalTerminalWidget* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = self->priv->_tab_label;
#line 59 "../src/Widgets/TerminalWidget.vala"
	result = _tmp0_;
#line 59 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4765 "TerminalWidget.c"
}

void
terminal_terminal_widget_set_tab_label (TerminalTerminalWidget* self,
                                        const gchar* value)
{
#line 62 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/Widgets/TerminalWidget.vala"
	if (value != NULL) {
#line 4776 "TerminalWidget.c"
		gchar* _tmp0_;
		GraniteWidgetsTab* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 64 "../src/Widgets/TerminalWidget.vala"
		_tmp0_ = g_strdup (value);
#line 64 "../src/Widgets/TerminalWidget.vala"
		_g_free0 (self->priv->_tab_label);
#line 64 "../src/Widgets/TerminalWidget.vala"
		self->priv->_tab_label = _tmp0_;
#line 65 "../src/Widgets/TerminalWidget.vala"
		_tmp1_ = self->tab;
#line 65 "../src/Widgets/TerminalWidget.vala"
		_tmp2_ = terminal_terminal_widget_get_tab_label (self);
#line 65 "../src/Widgets/TerminalWidget.vala"
		_tmp3_ = _tmp2_;
#line 65 "../src/Widgets/TerminalWidget.vala"
		granite_widgets_tab_set_label (_tmp1_, _tmp3_);
#line 4795 "TerminalWidget.c"
	}
#line 62 "../src/Widgets/TerminalWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY]);
#line 4799 "TerminalWidget.c"
}

gboolean
terminal_terminal_widget_get_child_has_exited (TerminalTerminalWidget* self)
{
	gboolean result;
#line 133 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 133 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->_child_has_exited;
#line 133 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4812 "TerminalWidget.c"
}

static void
terminal_terminal_widget_set_child_has_exited (TerminalTerminalWidget* self,
                                               gboolean value)
{
	gboolean old_value;
#line 134 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_child_has_exited (self);
#line 134 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 134 "../src/Widgets/TerminalWidget.vala"
		self->priv->_child_has_exited = value;
#line 134 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY]);
#line 4830 "TerminalWidget.c"
	}
}

gboolean
terminal_terminal_widget_get_killed (TerminalTerminalWidget* self)
{
	gboolean result;
#line 138 "../src/Widgets/TerminalWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 138 "../src/Widgets/TerminalWidget.vala"
	result = self->priv->_killed;
#line 138 "../src/Widgets/TerminalWidget.vala"
	return result;
#line 4844 "TerminalWidget.c"
}

static void
terminal_terminal_widget_set_killed (TerminalTerminalWidget* self,
                                     gboolean value)
{
	gboolean old_value;
#line 139 "../src/Widgets/TerminalWidget.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/Widgets/TerminalWidget.vala"
	old_value = terminal_terminal_widget_get_killed (self);
#line 139 "../src/Widgets/TerminalWidget.vala"
	if (old_value != value) {
#line 139 "../src/Widgets/TerminalWidget.vala"
		self->priv->_killed = value;
#line 139 "../src/Widgets/TerminalWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY]);
#line 4862 "TerminalWidget.c"
	}
}

static void
terminal_terminal_widget_class_init (TerminalTerminalWidgetClass * klass,
                                     gpointer klass_data)
{
#line 21 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_type_class_adjust_private_offset (klass, &TerminalTerminalWidget_private_offset);
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->copy_clipboard = (void (*) (VteTerminal*)) terminal_terminal_widget_real_copy_clipboard;
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->paste_clipboard = (void (*) (VteTerminal*)) terminal_terminal_widget_real_paste_clipboard;
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->increase_font_size = (void (*) (VteTerminal*)) terminal_terminal_widget_real_increase_font_size;
#line 21 "../src/Widgets/TerminalWidget.vala"
	((VteTerminalClass *) klass)->decrease_font_size = (void (*) (VteTerminal*)) terminal_terminal_widget_real_decrease_font_size;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_terminal_widget_get_property;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_terminal_widget_set_property;
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_terminal_widget_finalize;
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY] = g_param_spec_string ("current-working-directory", "current-working-directory", "current-working-directory", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY] = g_param_spec_boolean ("resized", "resized", "resized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_WINDOW_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TERMINAL_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY] = g_param_spec_string ("tab-label", "tab-label", "tab-label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY] = g_param_spec_boolean ("child-has-exited", "child-has-exited", "child-has-exited", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY, terminal_terminal_widget_properties[TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY] = g_param_spec_boolean ("killed", "killed", "killed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/TerminalWidget.vala"
	terminal_terminal_widget_signals[TERMINAL_TERMINAL_WIDGET_CWD_CHANGED_SIGNAL] = g_signal_new ("cwd-changed", TERMINAL_TYPE_TERMINAL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4902 "TerminalWidget.c"
}

static void
terminal_terminal_widget_instance_init (TerminalTerminalWidget * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
#line 21 "../src/Widgets/TerminalWidget.vala"
	self->priv = terminal_terminal_widget_get_instance_private (self);
#line 31 "../src/Widgets/TerminalWidget.vala"
	_tmp0_ = g_strdup ("");
#line 31 "../src/Widgets/TerminalWidget.vala"
	self->priv->_current_working_directory = _tmp0_;
#line 150 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_command_start_row = (glong) 0;
#line 151 "../src/Widgets/TerminalWidget.vala"
	self->priv->remembered_command_end_row = (glong) 0;
#line 152 "../src/Widgets/TerminalWidget.vala"
	self->last_key_was_return = TRUE;
#line 159 "../src/Widgets/TerminalWidget.vala"
	self->priv->modifier_pressed = FALSE;
#line 160 "../src/Widgets/TerminalWidget.vala"
	self->priv->scroll_delta = 0.0;
#line 4926 "TerminalWidget.c"
}

static void
terminal_terminal_widget_finalize (GObject * obj)
{
	TerminalTerminalWidget * self;
#line 21 "../src/Widgets/TerminalWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 29 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->app);
#line 30 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->terminal_id);
#line 31 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->priv->_current_working_directory);
#line 37 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->_window);
#line 52 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->menu);
#line 53 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->tab);
#line 54 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->link_uri);
#line 56 "../src/Widgets/TerminalWidget.vala"
	_g_free0 (self->priv->_tab_label);
#line 144 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_action);
#line 145 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->copy_output_action);
#line 146 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->paste_action);
#line 147 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_to_command_action);
#line 154 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 155 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 156 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 157 "../src/Widgets/TerminalWidget.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 21 "../src/Widgets/TerminalWidget.vala"
	G_OBJECT_CLASS (terminal_terminal_widget_parent_class)->finalize (obj);
#line 4969 "TerminalWidget.c"
}

static GType
terminal_terminal_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalTerminalWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_terminal_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalTerminalWidget), 0, (GInstanceInitFunc) terminal_terminal_widget_instance_init, NULL };
	GType terminal_terminal_widget_type_id;
	terminal_terminal_widget_type_id = g_type_register_static (vte_terminal_get_type (), "TerminalTerminalWidget", &g_define_type_info, 0);
	TerminalTerminalWidget_private_offset = g_type_add_instance_private (terminal_terminal_widget_type_id, sizeof (TerminalTerminalWidgetPrivate));
	return terminal_terminal_widget_type_id;
}

GType
terminal_terminal_widget_get_type (void)
{
	static volatile gsize terminal_terminal_widget_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_widget_type_id__once)) {
		GType terminal_terminal_widget_type_id;
		terminal_terminal_widget_type_id = terminal_terminal_widget_get_type_once ();
		g_once_init_leave (&terminal_terminal_widget_type_id__once, terminal_terminal_widget_type_id);
	}
	return terminal_terminal_widget_type_id__once;
}

static void
_vala_terminal_terminal_widget_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	TerminalTerminalWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 21 "../src/Widgets/TerminalWidget.vala"
	switch (property_id) {
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_string (value, terminal_terminal_widget_get_current_working_directory (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_boolean (value, terminal_terminal_widget_get_resized (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_WINDOW_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_object (value, terminal_terminal_widget_get_window (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_string (value, terminal_terminal_widget_get_tab_label (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_boolean (value, terminal_terminal_widget_get_child_has_exited (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		g_value_set_boolean (value, terminal_terminal_widget_get_killed (self));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5040 "TerminalWidget.c"
		default:
#line 21 "../src/Widgets/TerminalWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5046 "TerminalWidget.c"
	}
}

static void
_vala_terminal_terminal_widget_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	TerminalTerminalWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL_WIDGET, TerminalTerminalWidget);
#line 21 "../src/Widgets/TerminalWidget.vala"
	switch (property_id) {
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CURRENT_WORKING_DIRECTORY_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_current_working_directory (self, g_value_get_string (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_RESIZED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_resized (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_WINDOW_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_window (self, g_value_get_object (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_TAB_LABEL_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_tab_label (self, g_value_get_string (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_CHILD_HAS_EXITED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_child_has_exited (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 21 "../src/Widgets/TerminalWidget.vala"
		case TERMINAL_TERMINAL_WIDGET_KILLED_PROPERTY:
#line 21 "../src/Widgets/TerminalWidget.vala"
		terminal_terminal_widget_set_killed (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5096 "TerminalWidget.c"
		default:
#line 21 "../src/Widgets/TerminalWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/TerminalWidget.vala"
		break;
#line 5102 "TerminalWidget.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

